//############################################################################//
/*
Project Frontier
ZRG lander v0.3

v0.1:
Initial code

v0.1-0.3(061101):Artlav
Cleaned the code
Remade scenario handling

Copyright 2006 Frontier team
*/
//############################################################################//
#define STRICT
#define ORBITER_MODULE

#include "LanderZRG.h"

//############################################################################//
bool LANDERZRG::clbkLoadGenericCockpit(){return true;}       
void LANDERZRG::InitVC(int vc){}
DLLCLBK VESSEL *ovcInit(OBJHANDLE hvessel,int flightmodel){return new LANDERZRG(hvessel,flightmodel);}
DLLCLBK void ovcExit(VESSEL *vessel){if(vessel) delete(LANDERZRG*)vessel;}      
void LANDERZRG::RevertGear(void){gear_status=(((gear_status==GEAR_UP)||(gear_status==GEAR_RAISING))?GEAR_LOWERING:GEAR_RAISING);}
void LANDERZRG::DefineAnimations(void)
{
 static UINT GearGrp[15]={1,2,3,9,10,11,13,14,15,16,17,18,19,20,21};
 static MGROUP_TRANSLATE Gear(0,GearGrp,15,_V(0,-3.1,0));
 anim_gear=CreateAnimation(0);
 AddAnimationComponent(anim_gear,0,1,&Gear);
}
void LANDERZRG::ReleaseSurfaces()
{
 for(int i=0;i<nsurf;i++)if(srf[i]){
  oapiDestroySurface(srf[i]);
  srf[i]=0;
 }
}       
DLLCLBK void InitModule(HINSTANCE hModule)
{
 g_Param.hDLL=hModule;          /// used for textout///////
 // allocate GDI resources
 g_Param.hFont[0]=CreateFont(-30,0,0,0,400,0,0,0,0,0,0,0,0,"Arial");
 g_Param.hFont[1]=CreateFont(-20,0,0,0,400,0,0,0,0,0,0,0,0,"Arial");
 g_Param.hFont[2]=CreateFont(-50,0,0,0,400,0,0,0,0,0,0,0,0,"Arial");
 g_Param.hPen[0]=CreatePen(PS_SOLID,3,RGB(120,220,120));
 g_Param.hPen[1]=CreatePen(PS_SOLID,1,RGB(220,220,120));
 g_Param.hBrush[0]=CreateSolidBrush(RGB(0,128,0));
}
void LANDERZRG::VerticalLaunch()// kept in for reference
{ 
 if(GetPitch()<1.45)SetThrusterGroupLevel(THGROUP_HOVER,1);
 if(GetPitch()>1.45){
  SetTouchdownPoints(_V(5.5,0,-16),_V(0,-5.5,-16),_V(-5.5,0,-16));
  SetThrusterGroupLevel(THGROUP_HOVER,0.0);
  gear_status=GEAR_RAISING;  
  c=0;
 }
}
//############################################################################//

//############################################################################//
//####################### Setting vessel parameters ##########################//
//############################################################################//
void LANDERZRG::clbkPostCreation(void)
{		    
 if(cvid==1)SetMeshVisibilityMode(AddMesh(vcmesh_tpl=oapiLoadMeshGlobal("LanderZRGGhostrider1")),MESHVIS_VC | MESHVIS_EXTERNAL);
 if(cvid==2)SetMeshVisibilityMode(AddMesh(vcmesh_tpl=oapiLoadMeshGlobal("LanderZRGGhostrider2")),MESHVIS_VC | MESHVIS_EXTERNAL);
 if(cvid==3)SetMeshVisibilityMode(AddMesh(vcmesh_tpl=oapiLoadMeshGlobal("LanderZRGGhostrider2")),MESHVIS_VC | MESHVIS_EXTERNAL);
 // SetMeshVisibilityMode(AddMesh(exmesh_tpl=oapiLoadMeshGlobal("LanderZRGGhostrider1")),MESHVIS_EXTERNAL);//coppied from deltaglider
// visual specs
 
//// ADDED FOR VC
    
 ZRGpanel=oapiLoadMeshGlobal("ZRGpanel");
 VECTOR3 ofs1=_V(0,1.45,13.76);
 SetMeshVisibilityMode(AddMesh(ZRGpanel,&ofs1),MESHVIS_VC); 

//SURFHANDLE tex2=oapiGetTextureHandle(ZRGpanel,4);// mesh ,texture#   krot
//SURFHANDLE tex3=oapiGetTextureHandle(ZRGpanel,5);// mesh ,texture#  hlvl
//SURFHANDLE tex4=oapiGetTextureHandle(ZRGpanel,6);// mesh ,texture#  prograde
//SURFHANDLE tex5=oapiGetTextureHandle(ZRGpanel,7);// mesh ,texture#  retrograde
//SURFHANDLE tex6=oapiGetTextureHandle(ZRGpanel,8);// mesh ,texture#  orbit norm
//SURFHANDLE tex7=oapiGetTextureHandle(ZRGpanel,9);// mesh ,texture#  orbit antinorm
//SURFHANDLE tex8=oapiGetTextureHandle(ZRGpanel,10);// mesh ,texture#  hold alt
//SURFHANDLE tex9=oapiGetTextureHandle(ZRGpanel,3);// mesh ,texture#  panel
////SURFHANDLE tex10=oapiGetTextureHandle(ZRGpanel,11);// mesh ,texture#  undock
//SURFHANDLE tex11=oapiGetTextureHandle(ZRGpanel,12);// mesh ,texture#  main off
//SURFHANDLE tex12=oapiGetTextureHandle(ZRGpanel,15);// mesh ,texture# gear
//SURFHANDLE tex13=oapiGetTextureHandle(ZRGpanel,14);// mesh ,texture# gearstat
//SURFHANDLE tex14=oapiGetTextureHandle(ZRGpanel,13);// mesh ,texture# FUELstat
///////////////////////////

 tex2=oapiGetTextureHandle(ZRGpanel,4);// mesh ,texture#   krot
 tex3=oapiGetTextureHandle(ZRGpanel,5);// mesh ,texture#  hlvl
 tex4=oapiGetTextureHandle(ZRGpanel,6);// mesh ,texture#  prograde
 tex5=oapiGetTextureHandle(ZRGpanel,7);// mesh ,texture#  retrograde
 tex6=oapiGetTextureHandle(ZRGpanel,8);// mesh ,texture#  orbit norm
 tex7=oapiGetTextureHandle(ZRGpanel,9);// mesh ,texture#  orbit antinorm
 tex8=oapiGetTextureHandle(ZRGpanel,10);// mesh ,texture#  hold alt
 tex9=oapiGetTextureHandle(ZRGpanel,3);// mesh ,texture#  panel
 tex10=oapiGetTextureHandle(ZRGpanel,11);// mesh ,texture#  undock
 tex11=oapiGetTextureHandle(ZRGpanel,12);// mesh ,texture#  main off
 tex12=oapiGetTextureHandle(ZRGpanel,15);// mesh ,texture# gear
 tex13=oapiGetTextureHandle(ZRGpanel,14);// mesh ,texture# gearstat
 tex14=oapiGetTextureHandle(ZRGpanel,13);// mesh ,texture# FUELstat
 tex15=oapiGetTextureHandle(ZRGpanel,16);// mesh ,texture# left mfd buttons
 tex16=oapiGetTextureHandle(ZRGpanel,17);// mesh ,texture# right mfd buttons

 tex16=oapiGetTextureHandle(ZRGpanel,2);// mesh ,texture# right mfd buttons



 
 osnd=ConnectToOrbiterSoundDLL3(GetHandle());
 ReplaceStockSound3(osnd,"Sound\\Rho1\\landerZRG\\RCS.wav",REPLACE_RCS_THRUST_ATTACK);
 ReplaceStockSound3(osnd,"Sound\\Rho1\\landerZRG\\AMB1.wav",REPLACE_COCKPIT_AMBIENCE_1);
 ReplaceStockSound3(osnd,"Sound\\Rho1\\landerZRG\\AMB2.wav",REPLACE_COCKPIT_AMBIENCE_2);
 ReplaceStockSound3(osnd,"Sound\\Rho1\\landerZRG\\AMB3.wav",REPLACE_COCKPIT_AMBIENCE_3);
 ReplaceStockSound3(osnd,"Sound\\Rho1\\landerZRG\\AMB4.wav",REPLACE_COCKPIT_AMBIENCE_4);
 SoundOptionOnOff3(osnd,PLAYCOUNTDOWNWHENTAKEOFF,FALSE);

 if(cvid==2){           
  SoundOptionOnOff3(osnd,PLAYGPWS,FALSE);
  SoundOptionOnOff3(osnd,DISPLAYTIMER,FALSE);
  SoundOptionOnOff3(osnd,PLAYDOCKLANDCLEARANCE,FALSE);
 }
 if(cvid==3){           
  SoundOptionOnOff3(osnd,PLAYGPWS,FALSE);
  SoundOptionOnOff3(osnd,DISPLAYTIMER,FALSE);
  SoundOptionOnOff3(osnd,PLAYDOCKLANDCLEARANCE,FALSE);
 }
 
 if(cvid==1){
  RequestLoadVesselWave3(osnd,1,"Sound\\Rho1\\LanderZRG\\Welcometomare.wav",RADIO_SOUND);
  RequestLoadVesselWave3(osnd,2,"Sound\\Rho1\\LanderZRG\\Greetings.wav",DEFAULT);
 }
 if(cvid==2){           
  RequestLoadVesselWave3(osnd,1,"Sound\\Rho1\\LanderZRG\\Welcometomare.wav",RADIO_SOUND);
  RequestLoadVesselWave3(osnd,2,"Sound\\Rho1\\LanderZRG\\Greetings2.wav",RADIO_SOUND);
  RequestLoadVesselWave3(osnd,3,"Sound\\Rho1\\LanderZRG\\Greetings3.wav",RADIO_SOUND);
  RequestLoadVesselWave3(osnd,4,"Sound\\Rho1\\LanderZRG\\Greetings4.wav",RADIO_SOUND);
 }  
 if(cvid==3){  
  RequestLoadVesselWave3(osnd,1,"Sound\\Rho1\\LanderZRG\\Reo.wav",RADIO_SOUND);
  RequestLoadVesselWave3(osnd,2,"Sound\\Rho1\\LanderZRG\\Gullone.wav",RADIO_SOUND);
  RequestLoadVesselWave3(osnd,3,"Sound\\Rho1\\LanderZRG\\Gulltwo.wav",RADIO_SOUND);
 }
}    
//############################################################################//
//############################################################################//
void LANDERZRG::clbkSetClassCaps(FILEHANDLE cfg)
{ 
 gear_proc=0;
 gear_status=GEAR_UP;

 krotation=0; 
 horizon=0; 
 prograde=0;

 retgrade=0;
 orbitn=0;
 orbitan=0;
 holdalt=0;
 gearpos=0;
 tgl=0;  

 SetSize(32);
 SetEmptyMass(20000);
 SetCW(0.1,.1,2,1.4);
 SetReentryTexture(NULL);
 SetWingAspect(0.7);
 SetWingEffectiveness(2.5);
 SetCrossSections(_V(45,81.5,16.5));
 SetRotDrag(_V(0.6,0.6,0.35));
 if(GetFlightModel() >= 1) {
  SetPitchMomentScale(1e-4);
  SetBankMomentScale(1e-4);
 }
 SetTrimScale(0.05);

 SetCameraOffset(_V(0.0,1.65,13.4));// for VC//////////////////////////////////////

 SetMaxWheelbrakeForce(4e6);
 SetPMI(_V(16,22,8));
 

 SetSurfaceFrictionCoeff(0.05,0.4);
 SetTouchdownPoints(_V(0,-5.5,9),_V(-4.2,-4.7,-5),_V(4.2,-4.7,-5));



 THRUSTER_HANDLE th_main,th_retro,th_rcs[22],th_group[8];

 SURFHANDLE tex1=oapiRegisterExhaustTexture("Zrgexhaust");
       

// propellant resources
 
 hpr=CreatePropellantResource(LANDERZRG_FUELMASS);

 // ***************** thruster definitions *******************
     
 PARTICLESTREAMSPEC contrail_main={
  0,5.0,16,200,0.15,1.0,5,3.0,PARTICLESTREAMSPEC::DIFFUSE,
  PARTICLESTREAMSPEC::LVL_PSQRT,0,2,
  PARTICLESTREAMSPEC::ATM_PLOG,1e-4,1
 };
 PARTICLESTREAMSPEC exhaust_main={
  0,2.0,20,200,0.05,0.1,8,1.0,PARTICLESTREAMSPEC::EMISSIVE,
  PARTICLESTREAMSPEC::LVL_SQRT,0,1,
  PARTICLESTREAMSPEC::ATM_PLOG,1e-5,0.1
 };

//flags;//srcsize;//srcrate;//v0;//srcspread;//lifetime;//growthrate;

 th_main=CreateThruster(_V(0,0,-20),_V(0,0,1),LANDERZRG_MAXMAINTH,hpr,LANDERZRG_ISP);
 CreateThrusterGroup(&th_main,1,THGROUP_MAIN);
 AddExhaust(th_main,22,1.3,_V(-7.6,-.21,-15.5),_V(0,0,-1),tex1);
 AddExhaust(th_main,22,1.3,_V(7.6,-.21,-15.5),_V(0,0,-1),tex1);
 AddExhaust(th_main,29,1.5,_V(-4.45,0,-15.5),_V(0,0,-1),tex1);
 AddExhaust(th_main,29,1.5,_V(4.45,0,-15.5),_V(0,0,-1),tex1);
 AddExhaust(th_main,24,1.4,_V(0,.126,-15.5),_V(0,0,-1),tex1);

 AddExhaustStream(th_main,_V(-4.45,0,-17.5),&contrail_main);
 AddExhaustStream(th_main,_V(4.45,0,-17.5),&contrail_main);
 AddExhaustStream(th_main,_V(-4.45,0,-17.5),&exhaust_main);
 AddExhaustStream(th_main,_V(4.45,0,-17.5),&exhaust_main);


 th_retro=CreateThruster(_V(0,.1,20),_V(0,0,-1),LANDERZRG_MAXMAINTH,hpr,LANDERZRG_ISP);
 CreateThrusterGroup(&th_retro,1,THGROUP_RETRO);

 AddExhaust(th_retro,2.5,0.2,_V(1,-0.7,16.1),_V(0.3,-1,1),tex1);
 AddExhaust(th_retro,2.5,0.2,_V(-1,-0.7,16.1),_V(-0.3,-1,1),tex1);
 AddExhaust(th_retro,2.5,0.2,_V(1,0.9,16.1),_V(0,0,1),tex1);
 AddExhaust(th_retro,2.5,0.2,_V(-1,0.9,16.1),_V(0,0,1),tex1);

 th_rcs[ 0]=CreateThruster(_V( 1,0,3),_V(0,1,0),LANDERZRG_MAXRCSTH,hpr,LANDERZRG_ISP);
 th_rcs[ 1]=CreateThruster(_V( 1,0,3),_V(0,-1,0),LANDERZRG_MAXRCSTH,hpr,LANDERZRG_ISP);
 th_rcs[ 2]=CreateThruster(_V(-1,0,3),_V(0,1,0),LANDERZRG_MAXRCSTH,hpr,LANDERZRG_ISP);
 th_rcs[ 3]=CreateThruster(_V(-1,0,3),_V(0,-1,0),LANDERZRG_MAXRCSTH,hpr,LANDERZRG_ISP);
 th_rcs[ 4]=CreateThruster(_V( 1,0,-3),_V(0,1,0),LANDERZRG_MAXRCSTH,hpr,LANDERZRG_ISP);
 th_rcs[ 5]=CreateThruster(_V( 1,0,-3),_V(0,-1,0),LANDERZRG_MAXRCSTH,hpr,LANDERZRG_ISP);
 th_rcs[ 6]=CreateThruster(_V(-1,0,-3),_V(0,1,0),LANDERZRG_MAXRCSTH,hpr,LANDERZRG_ISP);
 th_rcs[ 7]=CreateThruster(_V(-1,0,-3),_V(0,-1,0),LANDERZRG_MAXRCSTH,hpr,LANDERZRG_ISP);
 th_rcs[ 8]=CreateThruster(_V( 1,0,3),_V(-1,0,0),LANDERZRG_MAXRCSTH,hpr,LANDERZRG_ISP);
 th_rcs[ 9]=CreateThruster(_V(-1,0,3),_V(1,0,0),LANDERZRG_MAXRCSTH,hpr,LANDERZRG_ISP);
 th_rcs[10]=CreateThruster(_V( 1,0,-3),_V(-1,0,0),LANDERZRG_MAXRCSTH,hpr,LANDERZRG_ISP);
 th_rcs[11]=CreateThruster(_V(-1,0,-3),_V(1,0,0),LANDERZRG_MAXRCSTH,hpr,LANDERZRG_ISP);
 th_rcs[12]=CreateThruster(_V( 0,0,-3),_V(0,0,1),LANDERZRG_MAXRCSTH,hpr,LANDERZRG_ISP);
 th_rcs[13]=CreateThruster(_V( 0,0,3),_V(0,0,-1),LANDERZRG_MAXRCSTH,hpr,LANDERZRG_ISP);
 
 /////bank left
 th_rcs[14]= CreateThruster(_V( 1,0,3),_V(0,1,0),LANDERZRG_MAXRCSTH2,hpr,LANDERZRG_ISP);
 th_rcs[15]=CreateThruster(_V( 1,0,-3),_V(0,1,0),LANDERZRG_MAXRCSTH2,hpr,LANDERZRG_ISP);
 th_rcs[16]=CreateThruster(_V(-1,0,3),_V(0,-1,0),LANDERZRG_MAXRCSTH2,hpr,LANDERZRG_ISP);
 th_rcs[17]=CreateThruster(_V(-1,0,-3),_V(0,-1,0),LANDERZRG_MAXRCSTH2,hpr,LANDERZRG_ISP);

  /////bank right
 th_rcs[18]= CreateThruster(_V( 1,0,3),_V(0,-1,0),LANDERZRG_MAXRCSTH2,hpr,LANDERZRG_ISP);
 th_rcs[19]=CreateThruster(_V( 1,0,-3),_V(0,-1,0),LANDERZRG_MAXRCSTH2,hpr,LANDERZRG_ISP);
 th_rcs[20]=CreateThruster(_V(-1,0,3),_V(0,1,0),LANDERZRG_MAXRCSTH2,hpr,LANDERZRG_ISP);
 th_rcs[21]=CreateThruster(_V(-1,0,-3),_V(0,1,0),LANDERZRG_MAXRCSTH2,hpr,LANDERZRG_ISP);
 
 AddExhaust(th_rcs[13],2.5,0.2,_V(-1,-0.7,16.1),_V(0,0,1),tex1);
 AddExhaust(th_rcs[13],2.5,0.2,_V(1,-0.7,16.1),_V(0,0,1),tex1);

 th_group[0]=th_rcs[0];
 th_group[1]=th_rcs[2];
 th_group[2]=th_rcs[5];
 th_group[3]=th_rcs[7];
 CreateThrusterGroup(th_group,4,THGROUP_ATT_PITCHUP);
 AddExhaust(th_rcs[0],2.5,0.2,_V(1,-0.7,16.1),_V(0,-1,0),tex1);
 AddExhaust(th_rcs[2],2.5,0.2,_V(-1,-0.7,16.1),_V(0,-1,0),tex1);
 AddExhaust(th_rcs[5],2.5,0.2,_V(9.7,-0.2,-16.1),_V(0,1,0),tex1);
 AddExhaust(th_rcs[7],2.5,0.2,_V(-9.7,-0.2,-16.1),_V(0,1,0),tex1); 

    
 th_group[0]=th_rcs[1];
 th_group[1]=th_rcs[3];
 th_group[2]=th_rcs[4];
 th_group[3]=th_rcs[6];
 CreateThrusterGroup(th_group,4,THGROUP_ATT_PITCHDOWN);
 AddExhaust(th_rcs[1],2.5,0.2,_V(1,0.9,16.1),_V(0,1,0),tex1);
 AddExhaust(th_rcs[3],2.5,0.2,_V(-1,0.9,16.1),_V(0,1,0),tex1);
 AddExhaust(th_rcs[4],2.5,0.2,_V(9.7,-0.5,-16.1),_V(0,-1,0),tex1);
 AddExhaust(th_rcs[6],2.5,0.2,_V(-9.7,-0.5,-16.1),_V(0,-1,0),tex1); 

 th_group[0]=th_rcs[0];
 th_group[1]=th_rcs[4];
 th_group[2]=th_rcs[3];
 th_group[3]=th_rcs[7];
 th_group[4]=th_rcs[14];
 th_group[5]=th_rcs[15];
 th_group[6]=th_rcs[16];
 th_group[7]=th_rcs[17];
 CreateThrusterGroup(th_group,8,THGROUP_ATT_BANKLEFT);

 th_group[0]=th_rcs[1];
 th_group[1]=th_rcs[5];
 th_group[2]=th_rcs[2];
 th_group[3]=th_rcs[6];
 th_group[4]=th_rcs[18];
 th_group[5]=th_rcs[19];
 th_group[6]=th_rcs[20];
 th_group[7]=th_rcs[21];
 CreateThrusterGroup(th_group,8,THGROUP_ATT_BANKRIGHT);

 th_group[0]=th_rcs[0];
 th_group[1]=th_rcs[4];
 th_group[2]=th_rcs[2];
 th_group[3]=th_rcs[6];
 CreateThrusterGroup(th_group,4,THGROUP_ATT_UP);

 th_group[0]=th_rcs[1];
 th_group[1]=th_rcs[5];
 th_group[2]=th_rcs[3];
 th_group[3]=th_rcs[7];
 CreateThrusterGroup(th_group,4,THGROUP_ATT_DOWN);

 th_group[0]=th_rcs[8];
 th_group[1]=th_rcs[11];
 CreateThrusterGroup(th_group,2,THGROUP_ATT_YAWLEFT);
 AddExhaust(th_rcs[11],2.5,0.2,_V(-9.8,-0.3,-15.9),_V(-1,0,0),tex1);
 AddExhaust(th_rcs[11],2.5,0.2,_V(-9.7,-0.3,-16.1),_V(-1,0,0),tex1);
 //forward
 AddExhaust(th_rcs[8],2.5,0.2,_V(2,-0.1,16.1),_V(1,0,0),tex1);
 AddExhaust(th_rcs[8],2.5,0.2,_V(2,-0.3,16.1),_V(1,0,0),tex1);



 th_group[0]=th_rcs[9];
 th_group[1]=th_rcs[10];
 CreateThrusterGroup(th_group,2,THGROUP_ATT_YAWRIGHT);
 AddExhaust(th_rcs[10],2.5,0.2,_V(9.8,-0.3,-15.9),_V(1,0,0),tex1);
 AddExhaust(th_rcs[10],2.5,0.2,_V(9.7,-0.3,-16.1),_V(1,0,0),tex1);
 //forward
 AddExhaust(th_rcs[9],2.5,0.2,_V(-2,-0.1,16.1),_V(-1,0,0),tex1);
 AddExhaust(th_rcs[9],2.5,0.2,_V(-2,-0.3,16.1),_V(-1,0,0),tex1);

 th_group[0]=th_rcs[8];
 th_group[1]=th_rcs[10];
 CreateThrusterGroup(th_group,2,THGROUP_ATT_LEFT);

 th_group[0]=th_rcs[9];
 th_group[1]=th_rcs[11];
 CreateThrusterGroup(th_group,2,THGROUP_ATT_RIGHT);

 CreateThrusterGroup(th_rcs+12,1,THGROUP_ATT_FORWARD);
 CreateThrusterGroup(th_rcs+13,1,THGROUP_ATT_BACK);
 
// ********************* aerodynamics ***********************

 CreateAirfoil(LIFT_VERTICAL,_V(0,0,-0.2),VLiftCoeff,5,40,1.5);
 // wing and body lift+drag components

 CreateAirfoil(LIFT_HORIZONTAL,_V(0,0,-4),HLiftCoeff,5,15,1.5);
 // vertical stabiliser and body lift and drag components

 CreateControlSurface(AIRCTRL_ELEVATOR,  0.5,1.5,_V(   0,0,-7.2),AIRCTRL_AXIS_XPOS);
 CreateControlSurface(AIRCTRL_RUDDER,    0.8,1.5,_V(   0,0,-7.2),AIRCTRL_AXIS_YPOS);
// CreateControlSurface(AIRCTRL_AILERON,   0.2,1.5,_V( 7.5,0,-7.2),AIRCTRL_AXIS_XPOS);
// CreateControlSurface(AIRCTRL_AILERON,   0.2,1.5,_V(-7.5,0,-7.2),AIRCTRL_AXIS_XNEG);
 CreateControlSurface(AIRCTRL_AILERON,   0.5,1.5,_V( 7.5,0,-7.2),AIRCTRL_AXIS_XPOS);
 CreateControlSurface(AIRCTRL_AILERON,   0.5,1.5,_V(-7.5,0,-7.2),AIRCTRL_AXIS_XNEG);
 
 CreateControlSurface(AIRCTRL_ELEVATORTRIM,0.1,1.5,_V(   0,0,-7.2),AIRCTRL_AXIS_XPOS);
}
//############################################################################//
//############################# Secondary Timer ##############################//
//############################################################################//
void LANDERZRG::clbkPostStep(double simt,double simdt,double mjd)
{ 
 // ground steering
 if((GetThrusterGroupLevel(THGROUP_ATT_YAWLEFT)>0)&&(GroundContact()==true)&&(GetAirspeed()>1)){
  AddForce(_V(-5.5e5,0,0),_V(-15,0,15));
 }  
 if((GetThrusterGroupLevel(THGROUP_ATT_YAWRIGHT)>0)&&(GroundContact()==true)&&(GetAirspeed()>1)){
  AddForce(_V(5.5e5,0,0),_V(-15,0,15));
 }

 // vertical launch
 if(c==1)VerticalLaunch();

 // Animate gear
 if(gear_status >= GEAR_RAISING){
  double da=simdt*GEAR_OPERATING_SPEED;
  if(gear_status==GEAR_RAISING){
   if(gear_proc>0.0) gear_proc=max(0.0,gear_proc-da); else gear_status=GEAR_UP;
  }else{
   if(gear_proc<1.0)gear_proc=min(1.0,gear_proc+da); else gear_status=GEAR_DOWN;
  }
  SetAnimation(anim_gear,gear_proc); 
 }
}
//############################################################################//
//############################### Primary Timer ##############################//
//############################################################################//
void LANDERZRG::clbkPreStep(double simt,double simdt,double mjd) 
{
 VESSEL *v=oapiGetFocusInterface();// to determine which vehicle has focus
 
 char cbuf[4];       
 char cbuf2[5];
 char cbuf3[5];  
 char cbuf4[25];

 osnd=ConnectToOrbiterSoundDLL3(v->GetHandle()); ///Why???
 sprintf(oapiDebugString(),"PlayGLand2=%lf PlayGLand3=%lf PlayGLand4=%lf PlayZLand2=%lf PlayZLand3=%lf PlayZLand4=%lf",playGLand2,playGLand3,playGLand4,playZland2,playZland3,playZland4);

//----------------------------------------//       
//-------------- Scenario ----------------//       
//----------------------------------------// 

 if(cvid==1){
  double Altitude=0;
  static BOOL AltitudeSoundPlayed=FALSE;
  static BOOL RadarFlagForSound=FALSE;
           
  oapiGetFocusAltitude(&Altitude);
  if(Altitude>500&&Altitude<750&&AltitudeSoundPlayed==FALSE)
  {
   PlayVesselRadioExclusiveWave3(osnd,1,255); 
   AltitudeSoundPlayed=TRUE;
  }
  if(Altitude<500||Altitude>750) AltitudeSoundPlayed=FALSE;


  MinDist= _V(50,50,50); //Distance to trigger sound
  hvessel=oapiGetVesselByName("Diplomat");// name of vessel to detect distance(shows in F3 list)
  if(oapiIsVessel(hvessel)==true) { // check if vessel exist
   v->GetRelativePos(hvessel,RelPos);//crashes if hvessel isnt in the senario
                                         
   // change numbers to positive
   if(RelPos.x < 0.0)RelPos.x=-(RelPos.x);
   if(RelPos.y < 0.0)RelPos.y=-(RelPos.y);
   if(RelPos.z < 0.0)RelPos.z=-(RelPos.z);

   //sprintf(oapiDebugString(),"fuel %lf " ,v->GetFuelMass() /80);

   if(MinDist.x > RelPos.x && MinDist.y > RelPos.y && MinDist.z > RelPos.z){
    if(playZland2<1){ // play once !!!either lander1 OR lander2(both share this module)!!!
     PlayVesselRadioExclusiveWave3(osnd,2,255);// Add Sound code here  
     playZland2=1;
    }// play once
   }
  }
 }	 
//----------------------------------------// 
 if(cvid==2){
  double Altitude=0;
  static BOOL AltitudeSoundPlayed=FALSE;
  static BOOL RadarFlagForSound=FALSE;

  oapiGetFocusAltitude(&Altitude);
  if(Altitude>500&&Altitude<750&&AltitudeSoundPlayed==FALSE)
  {
   PlayVesselRadioExclusiveWave3(osnd,1,255); 
   AltitudeSoundPlayed=TRUE;
  }
  if(Altitude<500||Altitude>750) AltitudeSoundPlayed=FALSE;

  MinDist1=_V(50,50,50); //Distance to trigger sound
  hvessel=oapiGetVesselByName("Temloe_Ambassador");// name of vessel to detect distance(shows in F3 list)
  if(oapiIsVessel(hvessel)==true){ // check if vessel exist
   v->GetRelativePos(hvessel,RelPos1);//crashes if hvessel isnt in the senario

   // change numbers to positive
   if(RelPos1.x < 0.0)RelPos1.x=-(RelPos1.x);
   if(RelPos1.y < 0.0)RelPos1.y=-(RelPos1.y);
   if(RelPos1.z < 0.0)RelPos1.z=-(RelPos1.z);

   if(MinDist1.x > RelPos1.x && MinDist1.y > RelPos1.y && MinDist1.z > RelPos1.z){
    if(playZland2 < 1){ // play once !!!either lander1 OR lander2(both share this module)!!!
     PlayVesselRadioExclusiveWave3(osnd,2,255);// Add Sound code here  
     playZland2=1;
    }// play once
   } // END check if vessel exist
   
   MinDist2=_V(50,50,50); //Distance to trigger sound
   hvessel=oapiGetVesselByName("Dendrea_Ambassador");// name of vessel to detect distance(shows in F3 list)
   if(oapiIsVessel(hvessel)==true){ // check if vessel exist
    v->GetRelativePos(hvessel,RelPos2);//crashes if hvessel isnt in the senario

    // change numbers to positive
    if(RelPos2.x < 0.0)RelPos2.x=-(RelPos2.x);
    if(RelPos2.y < 0.0)RelPos2.y=-(RelPos2.y);
    if(RelPos2.z < 0.0)RelPos2.z=-(RelPos2.z);

    if(MinDist2.x > RelPos2.x && MinDist2.y > RelPos2.y && MinDist2.z > RelPos2.z){
     if(playZland3<1){ // play once !!!
      PlayVesselRadioExclusiveWave3(osnd,3,255);// Add Sound code here  
      playZland3=1;
     }// play once
    }
   }
   
   MinDist3= _V(50,50,50); //Distance to trigger sound
   hvessel=oapiGetVesselByName("Consul");// name of vessel to detect distance(shows in F3 list)
   if(oapiIsVessel(hvessel)==true) { // check if vessel exist
    v->GetRelativePos(hvessel,RelPos3);//crashes if hvessel isnt in the senario

    // change numbers to positive
    if(RelPos3.x < 0.0)RelPos3.x=-(RelPos3.x);
    if(RelPos3.y < 0.0)RelPos3.y=-(RelPos3.y);
    if(RelPos3.z < 0.0)RelPos3.z=-(RelPos3.z);

    if(MinDist3.x > RelPos3.x && MinDist3.y > RelPos3.y && MinDist3.z > RelPos3.z){
     if(playZland4 < 1){ // play once !!!either lander1 OR lander2(both share this module)!!!
      PlayVesselRadioExclusiveWave3(osnd,4,255);// Add Sound code here  
      playZland4=1;
     }// play once
    }
   }
  }
 }	   
//----------------------------------------// 
 if(cvid==3){
  double Altitude=0;
  static BOOL AltitudeSoundPlayed=FALSE;
  static BOOL RadarFlagForSound=FALSE;
           
  oapiGetFocusAltitude(&Altitude);
  if(Altitude>2500&&Altitude<2750&&AltitudeSoundPlayed==FALSE)
  {
   PlayVesselRadioExclusiveWave3(osnd,1,255); 
   AltitudeSoundPlayed=TRUE;
  }
  if(Altitude<2500||Altitude>2750) AltitudeSoundPlayed=FALSE;

     
  MinDist1=_V(50000,50000,50000); //Distance to trigger sound
  hvessel=oapiGetVesselByName("Orca");// name of vessel to detect distance(shows in F3 list)
  if(oapiIsVessel(hvessel)==true){ // check if vessel exist
   v->GetRelativePos(hvessel,RelPos1);//crashes if hvessel isnt in the senario

   // change numbers to positive
   if(RelPos1.x < 0.0)RelPos1.x=-(RelPos1.x);
   if(RelPos1.y < 0.0)RelPos1.y=-(RelPos1.y);
   if(RelPos1.z < 0.0)RelPos1.z=-(RelPos1.z);

   if(MinDist1.x > RelPos1.x && MinDist1.y > RelPos1.y && MinDist1.z > RelPos1.z){
    if(playGLand2 < 1){ // play once !!!either lander1 OR lander2(both share this module)!!!
     PlayVesselRadioExclusiveWave3(osnd,2,255);// Add Sound code here  
     playGLand2=1;
    }// play once
   }
  } // END check if vessel exist
   
  MinDist2= _V(5000,5000,5000); //Distance to trigger sound
  hvessel=oapiGetVesselByName("Gullwind");// name of vessel to detect distance(shows in F3 list)
  if(oapiIsVessel(hvessel)==true) { // check if vessel exist
   v->GetRelativePos(hvessel,RelPos2);//crashes if hvessel isnt in the senario

   // change numbers to positive
   if(RelPos2.x < 0.0)RelPos2.x=-(RelPos2.x);
   if(RelPos2.y < 0.0)RelPos2.y=-(RelPos2.y);
   if(RelPos2.z < 0.0)RelPos2.z=-(RelPos2.z);

   if(MinDist2.x > RelPos2.x && MinDist2.y > RelPos2.y && MinDist2.z > RelPos2.z){
    if(playGLand3 < 1){ // play once !!!
     PlayVesselRadioExclusiveWave3(osnd,3,255);// Add Sound code here  
     playGLand3=1;
    }// play once
   }
  }
 }

//----------------------------------------//       
//------------- Animatics ----------------//       
//----------------------------------------//   
/////////////////Landing Gear Perameters////////////
 if(gear_proc < 1.0 && gear_proc > 0.0 ) {
  SetTouchdownPoints(_V(0,(-5.5) - gear_proc*2 + 2 ,9),_V(-4.2,(-4.7) - gear_proc + 1,-5),_V(4.2,(-4.7) - gear_proc + 1,-5));
  oapiBlt(tex13,srf[23],0,0,0,0,256,256);

  HDC hDC2=oapiGetDC(tex13);
  SelectObject(hDC2,g_Param.hFont[1]);
  SetTextColor(hDC2,RGB(30,80,255));
  SetTextAlign(hDC2,TA_CENTER);
  SetBkMode(hDC2,TRANSPARENT);//TRANSPARENT);
  TextOut(hDC2,186,125,"GEAR ACTIVE",11);
    
  oapiReleaseDC(tex13,hDC2);
 }
///////////////////////////////////////////////////////////
///////// having trouble with MFD BUTTONS
//RedrawPanel_MFDButton(tex15,MFD_LEFT,0);
//RedrawPanel_MFDButton(tex16,MFD_LEFT,0);
///////////////////////////////////////////////////////////////////////
 if(v->DockingStatus(0)==1) oapiBlt(tex10,srf[16],0,0,0,0,64,64);else oapiBlt(tex10,srf[15],0,0,0,0,64,64);
 if(v->GetThrusterGroupLevel(THGROUP_RETRO)==1){
  oapiBlt(tex8,srf[14],0,0,0,0,64,64);//hold alt ON
 }else{
  oapiBlt(tex8,srf[13],0,0,0,0,64,64);//hold alt normal OFF
 }
 if(v->GetThrusterGroupLevel(THGROUP_MAIN)==1 ){
  oapiBlt(tex14,srf[25],0,0  ,0,0,128,128); // 108  94
  oapiBlt(tex11,srf[18],0,0,0,0,64,64);
 }else{
  oapiBlt(tex14,srf[25],0,0  ,0,0,128,128); // 108  94
  oapiBlt(tex11,srf[17],0,0,0,0,64,64);
 }
 //MULTI PURPOSE DISPLAY
 if( v->GetCOG_elev() > 4.83){
  oapiBlt(tex12,srf[20],0,0,0,0,64,64);
  oapiBlt(tex13,srf[22],0,0,0,0,256,256);

  HDC hDC2=oapiGetDC(tex13);
  SelectObject(hDC2,g_Param.hFont[1]);
  SetTextColor(hDC2,RGB(30,80,255));
  SetTextAlign(hDC2,TA_CENTER);
  SetBkMode(hDC2,TRANSPARENT);//TRANSPARENT);
  TextOut(hDC2,186,125,"GEAR DOWN",9);
    
  oapiReleaseDC(tex13,hDC2);
 }
      
 if( v->GetCOG_elev() < 3.68){
  oapiBlt(tex12,srf[19],0,0,0,0,64,64);
  oapiBlt(tex13,srf[21],0,0,0,0,256,256);
  HDC hDC2=oapiGetDC(tex13);
  SelectObject(hDC2,g_Param.hFont[1]);
  SetTextColor(hDC2,RGB(30,80,255));
  SetTextAlign(hDC2,TA_CENTER);
  SetBkMode(hDC2,TRANSPARENT);//TRANSPARENT);
  TextOut(hDC2,186,125,"GEAR RETRACTED",14);
    
  oapiReleaseDC(tex13,hDC2);
 }
 oapiBlt(tex14,srf[24],5,128 -(v->GetFuelMass() /40)  ,0,0,89,4); // 108  94

 sprintf(cbuf,"%g ",v->GetFuelMass() /40);
 HDC hDC=oapiGetDC(tex14);
 SelectObject(hDC,g_Param.hFont[1]);
 SetTextColor(hDC,RGB(30,80,255));
 if(v->GetFuelMass() /80 < 20)SetTextColor(hDC,RGB(255,20,0));

 SetTextAlign(hDC,TA_CENTER);
 SetBkMode(hDC,TRANSPARENT);
 TextOut(hDC,60,90,cbuf,4);
    
 oapiReleaseDC(tex14,hDC);
 if(v->GroundContact()==true){

  HDC hDC2=oapiGetDC(tex13);
  SelectObject(hDC2,g_Param.hFont[1]);
  SetTextColor(hDC2,RGB(30,80,255));
  SetTextAlign(hDC2,TA_CENTER);
  SetBkMode(hDC2,TRANSPARENT);
  TextOut(hDC2,40,40,"LANDED",6);
    
  oapiReleaseDC(tex13,hDC2);
 } // end if landed

 sprintf(cbuf2,"%lf",v->GetAirspeed());//v->GetCOG_elev() );
 HDC hDC3=oapiGetDC(tex13);
 SelectObject(hDC3,g_Param.hFont[1]);
 SetTextColor(hDC3,RGB(30,80,255));
 SetTextAlign(hDC3,TA_LEFT);
 SetBkMode(hDC3,TRANSPARENT);
 TextOut(hDC3,80,240,cbuf2,5);
 TextOut(hDC3,10,240,"AirSpeed: ",10);
 oapiReleaseDC(tex13,hDC3);

 sprintf(cbuf3,"%lf",v->GetAltitude());//v->GetCOG_elev() );
 HDC hDC4=oapiGetDC(tex13);
 SelectObject(hDC4,g_Param.hFont[1]);
 SetTextColor(hDC4,RGB(30,80,255));
 SetTextAlign(hDC4,TA_LEFT);
 SetBkMode(hDC4,TRANSPARENT);
 TextOut(hDC4,80,220,cbuf3,5);
 TextOut(hDC4,10,220,"Altitude: ",10);
 oapiReleaseDC(tex13,hDC4);

 oapiGetObjectName(v->GetSurfaceRef(),cbuf4,25);//NEEDS WORK
 HDC hDC5=oapiGetDC(tex13);
 SelectObject(hDC5,g_Param.hFont[1]);
 SetTextColor(hDC5,RGB(30,80,255));
 SetTextAlign(hDC5,TA_LEFT);
 SetBkMode(hDC5,TRANSPARENT);
 TextOut(hDC5,80,200,cbuf4,strlen(cbuf4));
 TextOut(hDC5,10,200,"Ref: ",5);
 oapiReleaseDC(tex13,hDC5);    
}
//############################################################################//
//############################## Keyboard input ##############################//
//############################################################################//
int LANDERZRG::clbkConsumeBufferedKey(DWORD key,bool down,char *kstate)
{
 if(!down) return 0; // only process keydown events
 switch(key) {
  case OAPI_KEY_G: // deploy/retract gear
   RevertGear();
   return 1;
 }	     
 return 0;    
}
//############################################################################//
//############################ Load from scn file ############################//
//############################################################################//
void LANDERZRG::clbkLoadStateEx(FILEHANDLE scn,void *vs)
{
 char *line;
 cscn=scns=0;
 cvid=1;

 while(oapiReadScenario_nextline(scn,line)){
  if(!_strnicmp(line,"VESID",5)){
   sscanf(line+5,"%d",&cvid);
  }else if(!_strnicmp(line,"SCENARIO",8)){
   sscanf(line+8,"%d",&cscn);
  }else if(!_strnicmp(line,"SCNSTATE",8)){
   sscanf(line+8,"%d",&scns);
  }else if(!_strnicmp(line,"Gear",4)) {
   sscanf(line+4,"%d%lf",&gear_status,&gear_proc);
  }else{
   ParseScenarioLineEx(line,vs);
  }
 }
 SetAnimation(anim_gear,gear_proc);

 playZland2=(scns& 1)>>0;
 playZland3=(scns& 2)>>1;
 playZland4=(scns& 4)>>2;
 playGLand2=(scns& 8)>>3;
 playGLand3=(scns&16)>>4;
 playGLand4=(scns&32)>>5;

}
//############################################################################//
//############################## Save to scn file ############################//
//############################################################################//
void LANDERZRG::clbkSaveState(FILEHANDLE scn)
{
 char cbuf[256];
 VESSEL2::clbkSaveState(scn);

 scns=0;
 
 if(playZland2==1)scns=scns+ 1;
 if(playZland3==1)scns=scns+ 2;
 if(playZland4==1)scns=scns+ 4;
 if(playGLand2==1)scns=scns+ 8;
 if(playGLand3==1)scns=scns+16;
 if(playGLand4==1)scns=scns+32;

 sprintf(cbuf,"%d",cvid);
 oapiWriteScenario_string(scn,"VESID",cbuf);
 sprintf(cbuf,"%d",cscn);
 oapiWriteScenario_string(scn,"SCENARIO",cbuf);
 sprintf(cbuf,"%d",scns);
 oapiWriteScenario_string(scn,"SCNSTATE",cbuf); 
 sprintf(cbuf,"%d %0.4f",gear_status,gear_proc);
 oapiWriteScenario_string(scn,"Gear",cbuf);
}
//############################################################################//
//############################## Load VC #####################################//
//Working Mess...
//############################################################################//
bool LANDERZRG::clbkLoadVC(int id)
{    //VC HUD not set up( mesh not added
   // static VCHUDSPEC hud={1,19,{-0.7,0.7,5},5}; // setup HUD
  // oapiVCRegisterHUD(&hud);
        static VCMFDSPEC mfds_right= {1,13}; //
     static VCMFDSPEC mfds_user1={1,14};
        static VCMFDSPEC mfds_user2={1,15};
     static VCMFDSPEC mfds_user3= {1,16}; // 
        static VCMFDSPEC mfds_left= {1,17}; // 

  oapiVCRegisterMFD(MFD_USER1,&mfds_user1); 
  oapiVCRegisterMFD(MFD_USER2,&mfds_user2);  
        oapiVCRegisterMFD(MFD_USER3,&mfds_user3);  
        oapiVCRegisterMFD(MFD_RIGHT,&mfds_right);
        oapiVCRegisterMFD(MFD_LEFT,&mfds_left);

        oapiOpenMFD(MFD_ORBIT,MFD_USER1);
        oapiOpenMFD(MFD_DOCKING,MFD_USER2);
        oapiOpenMFD(MFD_HSI,MFD_USER3);

 ////////////////////////VC BUTTONS/////////////////////////////////////

//SURFHANDLE tex2=oapiGetTextureHandle(ZRGpanel,4);// mesh ,texture#   krot
//SURFHANDLE tex3=oapiGetTextureHandle(ZRGpanel,5);// mesh ,texture#  hlvl
//SURFHANDLE tex4=oapiGetTextureHandle(ZRGpanel,6);// mesh ,texture#  prograde
//SURFHANDLE tex5=oapiGetTextureHandle(ZRGpanel,7);// mesh ,texture#  retrograde
//SURFHANDLE tex6=oapiGetTextureHandle(ZRGpanel,8);// mesh ,texture#  orbit norm
//SURFHANDLE tex7=oapiGetTextureHandle(ZRGpanel,9);// mesh ,texture#  orbit antinorm
//SURFHANDLE tex8=oapiGetTextureHandle(ZRGpanel,10);// mesh ,texture#  hold alt
//SURFHANDLE tex9=oapiGetTextureHandle(ZRGpanel,3);// mesh ,texture#  panel
//SURFHANDLE tex10=oapiGetTextureHandle(ZRGpanel,11);// mesh ,texture#  undock
//SURFHANDLE tex11=oapiGetTextureHandle(ZRGpanel,12);// mesh ,texture#  main off
//SURFHANDLE tex12=oapiGetTextureHandle(ZRGpanel,15);// mesh ,texture# gear

//SURFHANDLE tex13=oapiGetTextureHandle(ZRGpanel,14);// mesh ,texture# gearstat
//SURFHANDLE tex14=oapiGetTextureHandle(ZRGpanel,13);// mesh ,texture# FUELstat
////////////V(0,1.45,13.76);
//tex11   gear
oapiVCRegisterArea(GEARUP,_R(0,0,0,0),PANEL_REDRAW_ALWAYS,PANEL_MOUSE_LBDOWN,PANEL_MAP_BGONREQUEST,tex2);

oapiVCSetAreaClickmode_Spherical(GEARUP,_V(0.003661 ,1.4061955,13.689251),0.01);




//tex11   thrusters
oapiVCRegisterArea(MAIN,_R(0,0,0,0),PANEL_REDRAW_ALWAYS,PANEL_MOUSE_LBDOWN,PANEL_MAP_BGONREQUEST,tex2);

oapiVCSetAreaClickmode_Spherical(MAIN,_V(0.068982 ,1.4061955,13.689251),0.01);


//tex10   UNDOCK
oapiVCRegisterArea(UNDOCK,_R(0,0,0,0),PANEL_REDRAW_ALWAYS,PANEL_MOUSE_LBDOWN,PANEL_MAP_BGONREQUEST,tex2);

oapiVCSetAreaClickmode_Spherical(UNDOCK,_V(-0.06135 ,1.4061955,13.689251),0.01);

//tex2   kill rotation
oapiVCRegisterArea(KROT,_R(0,0,0,0),PANEL_REDRAW_ALWAYS,PANEL_MOUSE_LBDOWN,PANEL_MAP_BGONREQUEST,tex2);

oapiVCSetAreaClickmode_Spherical(KROT,_V(-0.06135 ,1.3975805,13.6676955),0.01);
//tex3   Horizon level
oapiVCRegisterArea(HORLVL,_R(0,0,0,0),PANEL_REDRAW_ALWAYS,PANEL_MOUSE_LBDOWN,PANEL_MAP_BGONREQUEST,tex3);
oapiVCSetAreaClickmode_Spherical(HORLVL,_V(-0.039317 ,1.3975805,13.6676955),0.01);
//tex4   prograde
oapiVCRegisterArea(PROGRD,_R(0,0,0,0),PANEL_REDRAW_ALWAYS,PANEL_MOUSE_LBDOWN,PANEL_MAP_BGONREQUEST,tex4);
oapiVCSetAreaClickmode_Spherical(PROGRD,_V(-0.01738 ,1.3975805,13.6676955),0.01);
//tex5   retrograde
oapiVCRegisterArea(RETROGRD,_R(0,0,0,0),PANEL_REDRAW_ALWAYS,PANEL_MOUSE_LBDOWN,PANEL_MAP_BGONREQUEST,tex5);
oapiVCSetAreaClickmode_Spherical(RETROGRD,_V(0.004103 ,1.3975805,13.6676955),0.01);
//tex6   orbit normal
oapiVCRegisterArea(NMLP,_R(0,0,0,0),PANEL_REDRAW_ALWAYS,PANEL_MOUSE_LBDOWN,PANEL_MAP_BGONREQUEST,tex6);
oapiVCSetAreaClickmode_Spherical(NMLP,_V(0.025507 ,1.3975805,13.6676955),0.01);
//tex7   orbit anti normal
oapiVCRegisterArea(NMLM,_R(0,0,0,0),PANEL_REDRAW_ALWAYS,PANEL_MOUSE_LBDOWN,PANEL_MAP_BGONREQUEST,tex7);
oapiVCSetAreaClickmode_Spherical(NMLM,_V(0.0477475 ,1.3975805,13.6676955),0.01);
//tex8  holdalt
oapiVCRegisterArea(HDAT,_R(0,0,0,0),PANEL_REDRAW_ALWAYS,PANEL_MOUSE_LBDOWN,PANEL_MAP_BGONREQUEST,tex8);
oapiVCSetAreaClickmode_Spherical(HDAT,_V(0.068882 ,1.3975805,13.6676955),0.01);

  //Kill rotation
srf[1]=oapiCreateSurface(LOADBMP(IDB_KROFF));
srf[2]=oapiCreateSurface(LOADBMP(IDB_KRON));
  //HORLVL
srf[3]=oapiCreateSurface(LOADBMP(IDB_HLVLOFF));
srf[4]=oapiCreateSurface(LOADBMP(IDB_HLVLON));
  // PRO GRADE
srf[5]=oapiCreateSurface(LOADBMP(IDB_PROGOFF));
srf[6]=oapiCreateSurface(LOADBMP(IDB_PROGON));
  // RETROGRADE
srf[7]=oapiCreateSurface(LOADBMP(IDB_RTROFF));
srf[8]=oapiCreateSurface(LOADBMP(IDB_RTRON));
  // ORBIT NORM
srf[9]=oapiCreateSurface(LOADBMP(IDB_NMLPOFF));
srf[10]=oapiCreateSurface(LOADBMP(IDB_NMLPON));
  // anti norm
srf[11]=oapiCreateSurface(LOADBMP(IDB_NMLMOFF));
srf[12]=oapiCreateSurface(LOADBMP(IDB_NMLMON));
// HOLD ALT
srf[13]=oapiCreateSurface(LOADBMP(IDB_HDATOFF));
srf[14]=oapiCreateSurface(LOADBMP(IDB_HDATON));
//// damn this shit is a pain in the ass
// blank button
srf[15]=oapiCreateSurface(LOADBMP(IDB_UNDKOFF));
srf[16]=oapiCreateSurface(LOADBMP(IDB_UNDKON));

srf[17]=oapiCreateSurface(LOADBMP(IDB_MOFF));
srf[18]=oapiCreateSurface(LOADBMP(IDB_MON));

srf[19]=oapiCreateSurface(LOADBMP(IDB_GEARUP));
srf[20]=oapiCreateSurface(LOADBMP(IDB_GEARDN));
srf[21]=oapiCreateSurface(LOADBMP(IDB_GEARSTAT));
srf[22]=oapiCreateSurface(LOADBMP(IDB_GEARSTAT2));
srf[23]=oapiCreateSurface(LOADBMP(IDB_GEARSTAT3));

srf[24]=oapiCreateSurface(LOADBMP(IDB_FUELSTAT));
srf[25]=oapiCreateSurface(LOADBMP(IDB_FUELBG));


//oapiBlt(tex2,srf[2],0,0,0,0,64,64);//KROT ON
//oapiBlt(tex3,srf[4],0,0,0,0,64,64);//Hlvl ON
//oapiBlt(tex4,srf[6],0,0,0,0,64,64);//prograde ON
//oapiBlt(tex5,srf[8],0,0,0,0,64,64);//retro ON
//oapiBlt(tex6,srf[10],0,0,0,0,64,64);//nml + ON
//oapiBlt(tex7,srf[12],0,0,0,0,64,64);//nml -  ON
//oapiBlt(tex8,srf[14],0,0,0,0,64,64);//hold alt  ON
//oapiBlt(tex10,srf[16],0,0,0,0,64,64);//hold alt  ON

oapiBlt(tex2,srf[1],0,0,0,0,64,64);//KROT OFF
oapiBlt(tex3,srf[3],0,0,0,0,64,64);//Hlvl Off
oapiBlt(tex4,srf[5],0,0,0,0,64,64);//prograde Off
oapiBlt(tex5,srf[7],0,0,0,0,64,64);//retro Off
oapiBlt(tex6,srf[9],0,0,0,0,64,64);//nml + Off
oapiBlt(tex7,srf[11],0,0,0,0,64,64);//nml -  Off
oapiBlt(tex8,srf[13],0,0,0,0,64,64);//hold alt  Off
oapiBlt(tex10,srf[15],0,0,0,0,64,64);//hold alt  Off
///fuel
VESSEL *v=oapiGetFocusInterface();
oapiBlt(tex14,srf[24],5,128 -(v->GetPropellantMass(oapiGetPropellantHandle(v->GetHandle(),0) )/80)  ,0,0,89,8); // 108  94



oapiVCRegisterArea(MFD1,_R(0,0,0,0),PANEL_REDRAW_ALWAYS,PANEL_MOUSE_LBDOWN,PANEL_MAP_BGONREQUEST,tex2);

//mfd1srf=oapiCreateSurface(128,512);/// not used yet
 return true;
}  
//############################################################################//
//############################## VC input ####################################//
//############################################################################//
bool LANDERZRG::clbkVCMouseEvent(int id,int event,VECTOR3 &p)
{
 VESSEL *v=oapiGetFocusInterface();
 switch(id){        
 //----------------------------------------//
  /////////////////////Kill rotation button//////////////////////////
 case KROT:
  if(krotation==0){
   v->ActivateNavmode(1);
   krotation=1;
  }else{
   v->DeactivateNavmode(1);
   krotation=0;
  }
  return true;
 //----------------------------------------//
 case HORLVL:
  if(horizon==0){
   v->ActivateNavmode(2);
   horizon=1;
  }else{
   v->DeactivateNavmode(2);
   horizon=0;
  }
  return true;
 //----------------------------------------//
 case PROGRD:
  if(prograde==0){
   v->ActivateNavmode(3);
   prograde=1;
  }else{
   v->DeactivateNavmode(3);
   prograde=0;
  }
  return true;
 //----------------------------------------//
 case RETROGRD:
  if(retgrade==0){
   v->ActivateNavmode(4);
   retgrade=1;
  }else{
   v->DeactivateNavmode(4);
   retgrade=0;
  }
  return true;
 //----------------------------------------//
 case NMLP:
  if(orbitn==0){
   v->ActivateNavmode(5);
   orbitn=1;
  }else{
   v->DeactivateNavmode(5);
   orbitn=0;
  }
  return true;
 //----------------------------------------//
 case NMLM:
  if(orbitan==0){
   v->ActivateNavmode(6);
   orbitan=1;
  }else{
   v->DeactivateNavmode(6);
   orbitan=0;
  }
  return true;
 //----------------------------------------//
 case HDAT: //////////////////////////////NO HOVER THRUSTERS
  if(v->GetThrusterGroupLevel(THGROUP_RETRO)==0){
   v->SetThrusterGroupLevel(THGROUP_RETRO,1);
  }else{
   v->SetThrusterGroupLevel(THGROUP_RETRO,0);
  }
  return true;
 //----------------------------------------//
 case UNDOCK:
  if(v->DockingStatus(0)==1){
   Undock(0);
   oapiBlt(tex10,srf[15],0,0,0,0,64,64);
  }
  return true;
 //----------------------------------------//
 case MAIN:
  tgl=0;
  if(v->GetThrusterGroupLevel(THGROUP_MAIN)==0){
   v->SetThrusterGroupLevel(THGROUP_MAIN,1);
  }else{
   v->SetThrusterGroupLevel(THGROUP_MAIN,0);
  }
 return true;

 case GEARUP:
  if(gear_proc==1){ // geardown
   gear_status=GEAR_RAISING;
  }else{
   gear_status=GEAR_LOWERING;
  }
  return true;
 //----------------------------------------//
 }
 return false;
}   
//############################################################################//
void LANDERZRG::RedrawNavMode() 
{
 VESSEL *v=oapiGetFocusInterface();
 ///vc nav mode
 //----------------------------------------//
 if(v->GetNavmodeState(1)==true ){
  krotation=1;
  oapiBlt(tex2,srf[2],0,0,0,0,64,64);//KROT ON
 }else{
  krotation=0;
  oapiBlt(tex2,srf[1],0,0,0,0,64,64);//KROT OFF
 }
 //----------------------------------------//
 if(v->GetNavmodeState(2)==true){
  horizon=1;
  oapiBlt(tex3,srf[4],0,0,0,0,64,64);//hlvl ON
 }else{
  horizon=0;
  oapiBlt(tex3,srf[3],0,0,0,0,64,64);//hlvl OFF
 }
 //----------------------------------------//
 if(v->GetNavmodeState(3)==true){
  prograde=1;
  oapiBlt(tex4,srf[6],0,0,0,0,64,64);//progrd ON
 }else{
  prograde=0;
  oapiBlt(tex4,srf[5],0,0,0,0,64,64);//progrd OFF
 }
 //----------------------------------------//
 if(v->GetNavmodeState(4)==true){
  retgrade=1;
  oapiBlt(tex5,srf[8],0,0,0,0,64,64);//retgrd ON
 }else{
  retgrade=0;
  oapiBlt(tex5,srf[7],0,0,0,0,64,64);//retgrd OFF
 }
 //----------------------------------------//
 if(v->GetNavmodeState(5)==true){
  orbitn=1;
  oapiBlt(tex6,srf[10],0,0,0,0,64,64);//orbit normal ON
 }else{
  orbitn=0;
  oapiBlt(tex6,srf[9],0,0,0,0,64,64);//orbit normal OFF
 }
 //----------------------------------------//
 if(v->GetNavmodeState(6)==true){
  orbitan=1;
  oapiBlt(tex7,srf[12],0,0,0,0,64,64);//orbit anti normal ON
 }else{
  orbitan=0;
  oapiBlt(tex7,srf[11],0,0,0,0,64,64);//orbit anti normal OFF
 }       
 //----------------------------------------//
 if(v->DockingStatus(0)==1)oapiBlt(tex10,srf[16],0,0,0,0,64,64); else oapiBlt(tex10,srf[15],0,0,0,0,64,64);
}
void LANDERZRG::clbkFocusChanged(bool getfocus,OBJHANDLE hNewVessel,OBJHANDLE hOldVessel)
{
 VESSEL *v=oapiGetFocusInterface();
//landing gear indicator panel(VC)
 if( v->GetCOG_elev() > 4.8){
  oapiBlt(tex12,srf[20],0,0,0,0,64,64);
  oapiBlt(tex13,srf[22],0,0,0,0,256,256);
 }
 if( v->GetCOG_elev() < 3.7){
  oapiBlt(tex12,srf[19],0,0,0,0,64,64);
  oapiBlt(tex13,srf[22],0,0,0,0,256,256);
 }
}
void LANDERZRG::clbkNavMode(int mode,bool active){RedrawNavMode();}
void LANDERZRG::RedrawPanel_MFDButton(SURFHANDLE surf,int mfd,int side)
{      // mfd buttons not set up yet
 HDC hDC=oapiGetDC(surf);
 SelectObject(hDC,g_Param.hFont[0]);
 SetTextColor(hDC,RGB(0,200,0));
 SetTextAlign(hDC,TA_CENTER);
 SetBkMode(hDC,TRANSPARENT);

 const char *label;
 for(int bt=0; bt < 6; bt++) {
  if(label=oapiMFDButtonLabel(mfd,bt+side*6))
  TextOut(hDC,64,3+90*bt,label,strlen(label));
  else break;
 }
 oapiReleaseDC(surf,hDC);
}

