#define STRICT
#define ORBITER_MODULE
#include "stdio.h"
#include "orbitersdk.h"
#include "OrbiterSoundSDK3.h"
#include <cstdlib> 
#include <ctime> 
using namespace std;

#define RED RGB(255, 0, 0)
#define YELLOW RGB(255, 255, 0)
#define WHITE RGB(255, 255, 255)
#define BLUE RGB(0, 0, 255)
#define GREY RGB(160, 160, 160)
#define BRIGHTERGREY RGB(200, 200, 200)
#define GAINSBORO RGB(220,220,220)
#define HUDGREEN RGB(189 ,183 ,107)
#define SLATGREY RGB(112 ,128 ,144)
#define CORNFLOWERBLUE RGB(100 ,149 ,237)
#define SKYBLUE RGB(135 ,206 ,235)
#define LIGHTSTEELBLUE RGB(176 ,196 ,222)
#define DARKTURQUISE RGB(0 ,206 ,209)
#define SEAGREEN RGB(46 ,139 ,87)
#define LIGHTSEAGREEN RGB(32 ,178 ,170)
#define HOTPINK RGB(255 ,105 ,180)
#define ORANGE RGB(255 ,69 ,0)
#define SEAGREEN2 RGB(84 ,255 ,159)


const double ZENI_FUELMASS = 5500.0;
const double PJET_FUELMASS = 29800.0;
const double STRUCTURAL = 100.0;
const double AVIONICS = 100.0;
const double RCS_THRUSTERS = 100.0;
const double PJET_DRIVES = 100.0;
const double ZENI_ENGINES = 100.0;
const double LIFE_SUPPORT = 100.0;
const double WEAPON_SYSTEMS = 100.0;
const double VAC_ZENI_ISP = 6.25e8;
const double NML_ZENI_ISP = 1e1;
const double VAC_PJET_ISP = 4e4;
const double NML_PJET_ISP = 4e4;
const double ZENI_MAXMAINTH = 5.5e6;
const double PJET_MAXHOVERTH = 2.5e6;
const double AS_MAXRCSTH = 1e6;
const double P_NML = 1e1;
const double HATCH_OPERATING_SPEED = 0.1;
#define ZENI_WARNING 1
#define ATMOS_TO_RCS 2
#define RCS_TO_ATMOS 3

int Counter_RCS_TO_Atmo = 1;
int Counter_Atmo_TO_RCS = 1;
int COUNTER_ZENI_WARNING = 1;
char * EVANAME;
int EVAS = 0;
char   buffer[200];
char * ScoutName = "None";
char * FlightMode = "Normal";
char * ControlSystem = "Rotation";
double ZENIFUELMASS = 0;
double PJETFUELMASS = 0;
char * APSTATUS = "Off";
char * EVASTATUS = "Inactive";
double ExternalTemperature;
double DynamicPressure;
DWORD CREATELIFT = 1;
int LIFT = TRUE;
double Structure;
double Thrusters;
double LifeSupport;
double ZeniDrive;
double PjetDrive;
double Avonics;
int HUDCOLOR = 0;
DWORD CamCounter = 0;











bool CREATEEVA(void *id, char *str, void *data);
bool ReturnEVA(void *id, char *str, void *data);




// ==============================================================
// Airfoil coefficient functions
// Return lift, moment and zero-lift drag coefficients as a
// function of angle of attack (alpha or beta)
// ==============================================================

// 1. vertical lift component (wings and body)

void VLiftCoeff (double aoa, double M, double Re, double *cl, double *cm, double *cd)
{
	const int nabsc = 9;
	static const double AOA[nabsc] = {-180*RAD,-60*RAD,-30*RAD,-2*RAD, 15*RAD,20*RAD,25*RAD,60*RAD,180*RAD};
	static const double CL[nabsc]  = {       0,      0,   -0.4,     0,    0.7,     1,   0.8,     0,      0};
	static const double CM[nabsc]  = {       0,      0,  0.014, 0.004,-0.0074,-0.094,-0.012,     0,      0};
	int i;
	for (i = 0; i < nabsc-1 && AOA[i+1] < aoa; i++);
	double f = (aoa-AOA[i]) / (AOA[i+1]-AOA[i]);
	*cl = CL[i] + (CL[i+1]-CL[i]) * f;  // aoa-dependent lift coefficient
	*cm = CM[i] + (CM[i+1]-CM[i]) * f;  // aoa-dependent moment coefficient
	double saoa = sin(aoa);
	double pd = 0.015 + 0.4*saoa*saoa;  // profile drag
	*cd = pd + oapiGetInducedDrag (*cl, 1.5, 0.7) + oapiGetWaveDrag (M, 0.75, 1.0, 1.1, 0.04);
	// profile drag + (lift-)induced drag + transonic/supersonic wave (compressibility) drag
}

// 2. horizontal lift component (vertical stabilisers and body)

void HLiftCoeff (double beta, double M, double Re, double *cl, double *cm, double *cd)
{
	const int nabsc = 8;
	static const double BETA[nabsc] = {-180*RAD,-135*RAD,-90*RAD,-45*RAD,45*RAD,90*RAD,135*RAD,180*RAD};
	static const double CL[nabsc]   = {       0,    +0.3,      0,   -0.3,  +0.3,     0,   -0.3,      0};
	int i;
	for (i = 0; i < nabsc-1 && BETA[i+1] < beta; i++);
	*cl = CL[i] + (CL[i+1]-CL[i]) * (beta-BETA[i]) / (BETA[i+1]-BETA[i]);
	*cm = 0.0;
	*cd = 0.015 + oapiGetInducedDrag (*cl, 1.5, 0.6) + oapiGetWaveDrag (M, 0.75, 1.0, 1.1, 0.04);
}

class AS: public VESSEL2 {
public:
	AS (OBJHANDLE hVessel, int flightmodel)
		: VESSEL2 (hVessel, flightmodel) {
	HATCHA_proc = 0.0;
	HATCHA_status = HATCHA_UP;
	HATCHB_proc = 0.0;
	HATCHB_status = HATCHB_UP;
	HATCHC_proc = 0.0;
	HATCHC_status = HATCHC_UP;
	HATCHD_proc = 0.0;
	HATCHD_status = HATCHD_UP;
	HATCHE_proc = 0.0;
	HATCHE_status = HATCHE_UP;
	HATCHF_proc = 0.0;
	HATCHF_status = HATCHF_UP;
	HATCHG_proc = 0.0;
	HATCHG_status = HATCHG_UP;
	
	
	DefineAnimations ();
}
	void clbkSetClassCaps (FILEHANDLE cfg);
	void clbkPostCreation(void);
	void clbkPreStep (double simt, double simdt, double mjd);
	void PLAYSOUND(int);
	int Scout;
	enum HATCHAStatus { HATCHA_UP, HATCHA_DOWN, HATCHA_RAISING, HATCHA_LOWERING } HATCHA_status;
	enum HATCHBStatus { HATCHB_UP, HATCHB_DOWN, HATCHB_RAISING, HATCHB_LOWERING } HATCHB_status;
	enum HATCHCStatus { HATCHC_UP, HATCHC_DOWN, HATCHC_RAISING, HATCHC_LOWERING } HATCHC_status;
	enum HATCHDStatus { HATCHD_UP, HATCHD_DOWN, HATCHD_RAISING, HATCHD_LOWERING } HATCHD_status;
	enum HATCHEStatus { HATCHE_UP, HATCHE_DOWN, HATCHE_RAISING, HATCHE_LOWERING } HATCHE_status;
	enum HATCHFStatus { HATCHF_UP, HATCHF_DOWN, HATCHF_RAISING, HATCHF_LOWERING } HATCHF_status;
	enum HATCHGStatus { HATCHG_UP, HATCHG_DOWN, HATCHG_RAISING, HATCHG_LOWERING } HATCHG_status;
	void DefineAnimations (void); // Useful for animation
	void RevertHATCHA (void);
	void RevertHATCHB (void);
	void RevertHATCHC (void);
	void RevertHATCHD (void); // Operates the HATCH only
	void RevertHATCHE (void); // Operates the HATCH only
	void RevertHATCHF (void); // Operates the HATCH only
	void RevertHATCHG (void); // Operates the HATCH only
	
    void clbkLoadStateEx (FILEHANDLE scn, void *vs);//loads the status from the scenario file
	void clbkSaveState (FILEHANDLE scn);// for saving status to scenario file
	void clbkPostStep (double simt, double simdt, double mjd); // Animation
	int  clbkConsumeBufferedKey (DWORD key, bool down, char *kstate); // Used to control events such as animation
    void SetAP(bool enable){AutoPilot = enable;}
	void ActivateAP(bool);
	void Pitch();
	void Bank();
	bool GetAP() { return AutoPilot;}
	void SetCam(bool camstat){if (camstat == true){SetCameraOffset(_V(0,0,-20)); SetCameraDefaultDirection(_V(0,0,-1));} if (camstat == false){SetCameraOffset(_V(0,0,-1)); SetCameraDefaultDirection(_V(0,0,1));}}
	
private:
	
	UINT anim_HATCHA;
	double HATCHA_proc;
	UINT anim_HATCHB;
	double HATCHB_proc;
	UINT anim_HATCHC;
	double HATCHC_proc;
	UINT anim_HATCHD;
	double HATCHD_proc;
	UINT anim_HATCHE;
	double HATCHE_proc;
	UINT anim_HATCHF;
	double HATCHF_proc;
	UINT anim_HATCHG;
	double HATCHG_proc;
	bool AutoPilot;
	void clbkDrawHUD(int iMode, const HUDPAINTSPEC* pHPS, HDC hdc);
 
};
void AS::DefineAnimations (void)
{
	
	//BRIDGE 
	static UINT HATCHAGrp [1] = {14};
	static MGROUP_TRANSLATE HATCHA (0, HATCHAGrp, 1, _V(0,-1,0));
	anim_HATCHA = CreateAnimation (0);
	AddAnimationComponent (anim_HATCHA, 0, 1, &HATCHA);
	
	//SYSTEMS ACCESS ROOM
	static UINT HATCHBGrp [1] = {15};
	static MGROUP_TRANSLATE HATCHB (0, HATCHBGrp, 1, _V(0,1.3,0));
	anim_HATCHB = CreateAnimation (0);
	AddAnimationComponent (anim_HATCHB, 0, 1, &HATCHB);
	
	//UPPER CREWS' HAB
	static UINT HATCHCGrp [1] = {16};
	static MGROUP_TRANSLATE HATCHC (0, HATCHCGrp, 1, _V(0,1.3,0));
	anim_HATCHC = CreateAnimation (0);
	AddAnimationComponent (anim_HATCHC, 0, 1, &HATCHC);
	
	//LOWER CREWS' HAB
	static UINT HATCHDGrp[1] = {17};
	static MGROUP_TRANSLATE HATCHD (0, HATCHDGrp, 1, _V(0,1.7,0));
	anim_HATCHD = CreateAnimation (0);
	AddAnimationComponent (anim_HATCHD, 0, 1, &HATCHD);
	
	//JEFFRIES TUBE
	static UINT HATCHEGrp[1] = {18};
	static MGROUP_TRANSLATE HATCHE (0, HATCHEGrp, 1, _V(0,2,0));
	anim_HATCHE = CreateAnimation (0);
	AddAnimationComponent (anim_HATCHE, 0, 1, &HATCHE);
	
	//MAIN HATCH SLIDING
	static UINT HATCHFGrp[2] = {5,12};
	static MGROUP_SCALE HATCHF (0, HATCHFGrp, 2, _V(-1.9,0,-19), _V(.01,1,1));
	anim_HATCHF = CreateAnimation (0);
	AddAnimationComponent (anim_HATCHF, 0, 1, &HATCHF);
	
	//MAIN HATCH ELEVATOR SKID
	static UINT HATCHGGrp[6] = {0,1,2,3,5,12};
	static MGROUP_TRANSLATE HATCHG (0, HATCHGGrp, 6, _V(0,0,-5));
	anim_HATCHG = CreateAnimation (0);
	AddAnimationComponent (anim_HATCHG, 0, 1, &HATCHG);
	


}

void AS::RevertHATCHA (void)
{
	HATCHA_status = ((HATCHA_status == HATCHA_UP || HATCHA_status == HATCHA_RAISING) ?
		HATCHA_LOWERING : HATCHA_RAISING);
}
void AS::RevertHATCHB (void)
{
	HATCHB_status = ((HATCHB_status == HATCHB_UP || HATCHB_status == HATCHB_RAISING) ?
		HATCHB_LOWERING : HATCHB_RAISING);
}
void AS::RevertHATCHC (void)
{
	HATCHC_status = ((HATCHC_status == HATCHC_UP || HATCHC_status == HATCHC_RAISING) ?
		HATCHC_LOWERING : HATCHC_RAISING);
}
void AS::RevertHATCHD (void)
{
	HATCHD_status = ((HATCHD_status == HATCHD_UP || HATCHD_status == HATCHD_RAISING) ?
		HATCHD_LOWERING : HATCHD_RAISING);
}
void AS::RevertHATCHE (void)
{
	HATCHE_status = ((HATCHE_status == HATCHE_UP || HATCHE_status == HATCHE_RAISING) ?
		HATCHE_LOWERING : HATCHE_RAISING);
}
void AS::RevertHATCHF (void)
{
	HATCHF_status = ((HATCHF_status == HATCHF_UP || HATCHF_status == HATCHF_RAISING) ?
		HATCHF_LOWERING : HATCHF_RAISING);
}
void AS::RevertHATCHG (void)
{
	HATCHG_status = ((HATCHG_status == HATCHG_UP || HATCHG_status == HATCHG_RAISING) ?
		HATCHG_LOWERING : HATCHG_RAISING);
}

void AS::clbkSetClassCaps (FILEHANDLE cfg)
{
	THRUSTER_HANDLE th_main, th_hover, th_rcs[14], th_group[4];

	SetSize (26);
	SetEmptyMass (100000);
	SetCW (0.09, 1.0, 1.8, 1.8);
	SetReentryTexture (NULL);
	SetWingAspect (0.7);
	SetWingEffectiveness (2.5);
	SetCrossSections (_V(10.5,15.0,5.8));
	SetRotDrag (_V(0.9,0.9,0.9));
	if (GetFlightModel() >= 1) {
		SetPitchMomentScale (5e-5);
		SetBankMomentScale (5e-5);
	}
	SetPMI (_V(131.19,156.2,31.43));
	SetTrimScale (0.05);
	SetCameraOffset (_V(0,0.0,5.0));
	SetDockParams (_V(0,0,-19.5), _V(0,0,-1), _V(0,1,0));
	SetTouchdownPoints (_V(0,-20,-20.5), _V(-10,20,-20.5), _V(10,20,-20.5));

	// propellant resources
	PROPELLANT_HANDLE hpr, hpp, str, rcs, jet, zen, lif, ave;
	hpr = CreatePropellantResource (ZENI_FUELMASS);
	hpp = CreatePropellantResource (PJET_FUELMASS);
	str = CreatePropellantResource (STRUCTURAL);
	rcs = CreatePropellantResource (RCS_THRUSTERS);
	lif = CreatePropellantResource (LIFE_SUPPORT);
	jet = CreatePropellantResource (PJET_DRIVES);
	zen = CreatePropellantResource (ZENI_ENGINES);
	ave = CreatePropellantResource (AVIONICS);
	
	

// ********************* aerodynamics ***********************

	CreateAirfoil (LIFT_VERTICAL, _V(0,0,-0.2), VLiftCoeff, 5, 300, 1.5);
	// wing and body lift+drag components

	CreateAirfoil (LIFT_HORIZONTAL, _V(0,0,-4), HLiftCoeff, 5, 50, 1.5);
	// vertical stabiliser and body lift and drag components

	CreateControlSurface (AIRCTRL_ELEVATOR,     6, 1.5, _V(   0,0,-17.2), AIRCTRL_AXIS_XPOS);
	CreateControlSurface (AIRCTRL_RUDDER,       4, 1.5, _V(   0,0,-17.2), AIRCTRL_AXIS_YPOS);
	CreateControlSurface (AIRCTRL_AILERON,      1, 1.5, _V( 7.5,0,-7.2), AIRCTRL_AXIS_XPOS);
	CreateControlSurface (AIRCTRL_AILERON,      1, 1.5, _V(-7.5,0,-7.2), AIRCTRL_AXIS_XNEG);
	CreateControlSurface (AIRCTRL_ELEVATORTRIM, .5, 1.5, _V(   0,0,-17.2), AIRCTRL_AXIS_XPOS);

	// ***************** thruster definitions *******************
     
      PARTICLESTREAMSPEC contrail_main = {
		0, 1.0, 16, 200, 0.15, 3.0, 5, 3.0, PARTICLESTREAMSPEC::DIFFUSE,
		PARTICLESTREAMSPEC::LVL_PSQRT, 0, 2,
		PARTICLESTREAMSPEC::ATM_PLOG, 1e-4, 1
	};
	PARTICLESTREAMSPEC contrail_hover = {
		0, 2.0, 40, 400, .15, 2.0, 30, 8.0, PARTICLESTREAMSPEC::DIFFUSE,
		PARTICLESTREAMSPEC::LVL_PSQRT, 0, 2,
		PARTICLESTREAMSPEC::ATM_PLOG, 1e-4, 1
	};
	PARTICLESTREAMSPEC exhaust_main = {
		0, 1.0, 30, 200, 0.05, 0.05, 3, 0.1, PARTICLESTREAMSPEC::EMISSIVE,
		PARTICLESTREAMSPEC::LVL_SQRT, 0, 1,
		PARTICLESTREAMSPEC::ATM_PLOG, 1e-5, 0.1
	};
	PARTICLESTREAMSPEC exhaust_hover = {
		0, 1.0, 10, 200, 0.05, 0.05, 3, 0.1, PARTICLESTREAMSPEC::EMISSIVE,
		PARTICLESTREAMSPEC::LVL_SQRT, 0, 1,
		PARTICLESTREAMSPEC::ATM_PLOG, 1e-5, 0.1
	};

	
	th_main = CreateThruster (_V(0,0,-20.5), _V(0,0,1), ZENI_MAXMAINTH, hpr, VAC_ZENI_ISP, NML_ZENI_ISP, P_NML);
	CreateThrusterGroup (&th_main, 1, THGROUP_MAIN);
	AddExhaust (th_main, 20, 1, _V(20,0,-18.3), _V(0,0,-1));
      AddExhaust (th_main, 20, 1, _V(-20,0,-18.3), _V(0,0,-1));

	th_hover = CreateThruster (_V(0,0,-18), _V(0,0,1), PJET_MAXHOVERTH, hpp, VAC_PJET_ISP, NML_PJET_ISP, P_NML);
	CreateThrusterGroup (&th_hover, 1, THGROUP_HOVER);
	AddExhaust (th_hover, 12, 1, _V(10,0,-20.5), _V(0,0,-1));
	AddExhaust (th_hover, 12, 1, _V(-10,0,-20.5), _V(0,0,-1));

	AddExhaustStream (th_hover, _V(10,0, -30), &contrail_hover);
	AddExhaustStream (th_hover, _V(-10,0,-30), &contrail_hover);
	AddExhaustStream (th_main, _V(20,0,-28), &contrail_main);
        AddExhaustStream (th_main, _V(-20,0,-28), &contrail_main);
	AddExhaustStream (th_hover, _V(10,0, -20.5), &exhaust_hover);
	AddExhaustStream (th_hover, _V(-10,0,-20.5), &exhaust_hover);
	AddExhaustStream (th_main, _V(20,0,-18.3), &exhaust_main);
	AddExhaustStream (th_main, _V(-20,0,-18.3), &exhaust_main);

	th_rcs[ 0] = CreateThruster (_V( 1,0, 3), _V(0,1,0), AS_MAXRCSTH, hpr, VAC_ZENI_ISP);
	th_rcs[ 1] = CreateThruster (_V( 1,0, 3), _V(0,-1,0), AS_MAXRCSTH, hpr, VAC_ZENI_ISP);
	th_rcs[ 2] = CreateThruster (_V(-1,0, 3), _V(0,1,0), AS_MAXRCSTH, hpr, VAC_ZENI_ISP);
	th_rcs[ 3] = CreateThruster (_V(-1,0, 3), _V(0,-1,0), AS_MAXRCSTH, hpr, VAC_ZENI_ISP);
	th_rcs[ 4] = CreateThruster (_V( 1,0,-3), _V(0,1,0), AS_MAXRCSTH, hpr, VAC_ZENI_ISP);
	th_rcs[ 5] = CreateThruster (_V( 1,0,-3), _V(0,-1,0), AS_MAXRCSTH, hpr, VAC_ZENI_ISP);
	th_rcs[ 6] = CreateThruster (_V(-1,0,-3), _V(0,1,0), AS_MAXRCSTH, hpr, VAC_ZENI_ISP);
	th_rcs[ 7] = CreateThruster (_V(-1,0,-3), _V(0,-1,0), AS_MAXRCSTH, hpr, VAC_ZENI_ISP);
	th_rcs[ 8] = CreateThruster (_V( 1,0, 3), _V(-1,0,0), AS_MAXRCSTH, hpr, VAC_ZENI_ISP);
	th_rcs[ 9] = CreateThruster (_V(-1,0, 3), _V(1,0,0), AS_MAXRCSTH, hpr, VAC_ZENI_ISP);
	th_rcs[10] = CreateThruster (_V( 1,0,-3), _V(-1,0,0), AS_MAXRCSTH, hpr, VAC_ZENI_ISP);
	th_rcs[11] = CreateThruster (_V(-1,0,-3), _V(1,0,0), AS_MAXRCSTH, hpr, VAC_ZENI_ISP);
	th_rcs[12] = CreateThruster (_V( 0,0,-3), _V(0,0,1), AS_MAXRCSTH, hpr, VAC_ZENI_ISP);
	th_rcs[13] = CreateThruster (_V( 0,0, 3), _V(0,0,-1), AS_MAXRCSTH, hpr, VAC_ZENI_ISP);

	th_group[0] = th_rcs[0];
	th_group[1] = th_rcs[2];
	th_group[2] = th_rcs[5];
	th_group[3] = th_rcs[7];
	CreateThrusterGroup (th_group, 4, THGROUP_ATT_PITCHUP);

	th_group[0] = th_rcs[1];
	th_group[1] = th_rcs[3];
	th_group[2] = th_rcs[4];
	th_group[3] = th_rcs[6];
	CreateThrusterGroup (th_group, 4, THGROUP_ATT_PITCHDOWN);

	th_group[0] = th_rcs[0];
	th_group[1] = th_rcs[4];
	th_group[2] = th_rcs[3];
	th_group[3] = th_rcs[7];
	CreateThrusterGroup (th_group, 4, THGROUP_ATT_BANKLEFT);

	th_group[0] = th_rcs[1];
	th_group[1] = th_rcs[5];
	th_group[2] = th_rcs[2];
	th_group[3] = th_rcs[6];
	CreateThrusterGroup (th_group, 4, THGROUP_ATT_BANKRIGHT);

	th_group[0] = th_rcs[0];
	th_group[1] = th_rcs[4];
	th_group[2] = th_rcs[2];
	th_group[3] = th_rcs[6];
	CreateThrusterGroup (th_group, 4, THGROUP_ATT_UP);

	th_group[0] = th_rcs[1];
	th_group[1] = th_rcs[5];
	th_group[2] = th_rcs[3];
	th_group[3] = th_rcs[7];
	CreateThrusterGroup (th_group, 4, THGROUP_ATT_DOWN);

	th_group[0] = th_rcs[8];
	th_group[1] = th_rcs[11];
	CreateThrusterGroup (th_group, 2, THGROUP_ATT_YAWLEFT);

	th_group[0] = th_rcs[9];
	th_group[1] = th_rcs[10];
	CreateThrusterGroup (th_group, 2, THGROUP_ATT_YAWRIGHT);

	th_group[0] = th_rcs[8];
	th_group[1] = th_rcs[10];
	CreateThrusterGroup (th_group, 2, THGROUP_ATT_LEFT);

	th_group[0] = th_rcs[9];
	th_group[1] = th_rcs[11];
	CreateThrusterGroup (th_group, 2, THGROUP_ATT_RIGHT);

	CreateThrusterGroup (th_rcs+12, 1, THGROUP_ATT_FORWARD);
	CreateThrusterGroup (th_rcs+13, 1, THGROUP_ATT_BACK);

	// visual specs defined in config
}

// ==============================================================
// API callback interface
// ==============================================================
void AS::PLAYSOUND(int MODE)
{
	if (MODE == 1)
	{
		PlayVesselWave3(Scout,ATMOS_TO_RCS);
		
	}
    if (MODE == 2)
	{
		PlayVesselWave3(Scout,RCS_TO_ATMOS);
	}
    if (MODE == 3)
	{
		PlayVesselWave3(Scout,ZENI_WARNING);
	}
}

// --------------------------------------------------------------
// Vessel initialisation
// --------------------------------------------------------------
DLLCLBK VESSEL *ovcInit (OBJHANDLE hvessel, int flightmodel)
{
	return new AS (hvessel, flightmodel);
	
}

// --------------------------------------------------------------
// Vessel cleanup
// --------------------------------------------------------------
DLLCLBK void ovcExit (VESSEL *vessel)
{
	if (vessel) delete (AS*)vessel;
}
void AS::clbkPostCreation (void)
{
	Scout=ConnectToOrbiterSoundDLL3(GetHandle());

	ReplaceStockSound3(Scout,"Sound\\Rho1\\Scout\\ZENI.wav",	REPLACE_MAIN_THRUST);
	ReplaceStockSound3(Scout,"Sound\\Rho1\\landerZRG\\AMB1.wav",	REPLACE_COCKPIT_AMBIENCE_1);
    ReplaceStockSound3(Scout,"Sound\\Rho1\\landerZRG\\AMB2.wav",	REPLACE_COCKPIT_AMBIENCE_2);
	ReplaceStockSound3(Scout,"Sound\\Rho1\\landerZRG\\AMB3.wav",	REPLACE_COCKPIT_AMBIENCE_3);
	ReplaceStockSound3(Scout,"Sound\\Rho1\\landerZRG\\AMB4.wav",	REPLACE_COCKPIT_AMBIENCE_4);
	SoundOptionOnOff3(Scout,PLAYCOUNTDOWNWHENTAKEOFF,FALSE);
	
	RequestLoadVesselWave3(Scout,RCS_TO_ATMOS,"Sound\\Rho1\\Scout\\RCS-to-atmos.wav",DEFAULT);
	RequestLoadVesselWave3(Scout,ZENI_WARNING,"Sound\\Rho1\\Scout\\Zeni-warning.wav",DEFAULT);
	RequestLoadVesselWave3(Scout,ATMOS_TO_RCS,"Sound\\Rho1\\Scout\\atmos-to-RCS.wav",DEFAULT);


	
	

    
}

void AS::clbkPreStep (double simt, double simdt, double mjd)
{
     VESSEL * v = oapiGetFocusInterface();

	 ActivateAP(AutoPilot);
	 double DENSITY = GetAtmPressure();


	 
	 
	

	while ((DENSITY < 0.030) && (DENSITY > 0.028))
	{
		PLAYSOUND(1);
	}

	if ((DENSITY > 0.040 ) && (DENSITY < 0.042))
	{
		PLAYSOUND(2);
	}


	if ((DENSITY > 0.05)&&(COUNTER_ZENI_WARNING == 1))
	{
		
		
		PLAYSOUND(3);
		COUNTER_ZENI_WARNING++;
	}
	//========================================================================================================//
	ScoutName = GetName();

	if (GetAttitudeMode() == RCS_NONE)
	{
		ControlSystem = "Avonics";
	}
	if (GetAttitudeMode() == RCS_ROT)
	{
		ControlSystem = "Rotation";
	}
	if (GetAttitudeMode() == RCS_LIN)
	{
		ControlSystem = "Linear";
	}

	PROPELLANT_HANDLE PJET, ZENI;
	PJET = GetPropellantHandleByIndex(1);
	ZENI = GetPropellantHandleByIndex(0);

	ZENIFUELMASS = oapiGetPropellantMass(ZENI);
	PJETFUELMASS = oapiGetPropellantMass(PJET);

	bool AP = GetAP();

	if (AP == true)
	{
		APSTATUS = "ON";
	}
	if (AP == false)
	{
		APSTATUS = "Off";
	}

	if (EVAS > 0)
	{
		EVASTATUS = "Active";
	}

	if ((EVAS == 0) || (EVAS < 0))
	{
		EVASTATUS = "Inactive";
	}

	ExternalTemperature = GetAtmTemperature();
	DynamicPressure = GetAtmPressure();

	PROPELLANT_HANDLE STRUCTURE, THRUSTERS, LIFESUPPORT,PJETDRIVE,ZENIDRIVE,AVONICS;
	STRUCTURE = GetPropellantHandleByIndex(2);
	THRUSTERS = GetPropellantHandleByIndex(3);
	LIFESUPPORT = GetPropellantHandleByIndex(4);
	PJETDRIVE = GetPropellantHandleByIndex(5);
	ZENIDRIVE = GetPropellantHandleByIndex(6);
	//AVONICS = GetPropellantHandleByIndex(7);

	Structure = oapiGetPropellantMass(STRUCTURE);
	Thrusters = oapiGetPropellantMass(THRUSTERS);
	PjetDrive = oapiGetPropellantMass(PJETDRIVE);
	ZeniDrive = oapiGetPropellantMass(ZENIDRIVE);
	LifeSupport = oapiGetPropellantMass(LIFESUPPORT);
	//Avonics = oapiGetPropellantMass(AVONICS);



	  

	  if (GetThrusterGroupLevel(THGROUP_MAIN) > ZeniDrive*0.01)
	  {
		  SetThrusterGroupLevel(THGROUP_MAIN,ZeniDrive*0.01);
	  }

      if (GetThrusterGroupLevel(THGROUP_HOVER) > PjetDrive*0.01)
	  {
		  SetThrusterGroupLevel(THGROUP_HOVER,PjetDrive*0.01);
	  }









	





}

void AS::clbkPostStep (double simt, double simdt, double mjd)
{
	// Animate HATCH
	
if (HATCHA_status >= HATCHA_RAISING) {
		double da = simdt * HATCH_OPERATING_SPEED;
		if (HATCHA_status == HATCHA_RAISING) {
			if (HATCHA_proc > 0.0) HATCHA_proc = max (0.0, HATCHA_proc-da);
			else                HATCHA_status = HATCHA_UP;
		} else {
			if (HATCHA_proc < 1.0) HATCHA_proc = min (1.0, HATCHA_proc+da);
			else                HATCHA_status = HATCHA_DOWN;
		}
		SetAnimation (anim_HATCHA, HATCHA_proc);
}
if (HATCHB_status >= HATCHB_RAISING) {
		double da = simdt * HATCH_OPERATING_SPEED;
		if (HATCHB_status == HATCHB_RAISING) {
			if (HATCHB_proc > 0.0) HATCHB_proc = max (0.0, HATCHB_proc-da);
			else                HATCHB_status = HATCHB_UP;
		} else {
			if (HATCHB_proc < 1.0) HATCHB_proc = min (1.0, HATCHB_proc+da);
			else                HATCHB_status = HATCHB_DOWN;
		}
		SetAnimation (anim_HATCHB, HATCHB_proc);
}
if (HATCHC_status >= HATCHC_RAISING) {
		double da = simdt * HATCH_OPERATING_SPEED;
		if (HATCHC_status == HATCHC_RAISING) {
			if (HATCHC_proc > 0.0) HATCHC_proc = max (0.0, HATCHC_proc-da);
			else                HATCHC_status = HATCHC_UP;
		} else {
			if (HATCHC_proc < 1.0) HATCHC_proc = min (1.0, HATCHC_proc+da);
			else                HATCHC_status = HATCHC_DOWN;
		}
		SetAnimation (anim_HATCHC, HATCHC_proc);
}
if (HATCHD_status >= HATCHD_RAISING) {
		double da = simdt * HATCH_OPERATING_SPEED;
		if (HATCHD_status == HATCHD_RAISING) {
			if (HATCHD_proc > 0.0) HATCHD_proc = max (0.0, HATCHD_proc-da);
			else                HATCHD_status = HATCHD_UP;
		} else {
			if (HATCHD_proc < 1.0) HATCHD_proc = min (1.0, HATCHD_proc+da);
			else                HATCHD_status = HATCHD_DOWN;
		}
		SetAnimation (anim_HATCHD, HATCHD_proc);
}
if (HATCHE_status >= HATCHE_RAISING) {
		double da = simdt * HATCH_OPERATING_SPEED;
		if (HATCHE_status == HATCHE_RAISING) {
			if (HATCHE_proc > 0.0) HATCHE_proc = max (0.0, HATCHE_proc-da);
			else                HATCHE_status = HATCHE_UP;
		} else {
			if (HATCHE_proc < 1.0) HATCHE_proc = min (1.0, HATCHE_proc+da);
			else                HATCHE_status = HATCHE_DOWN;
		}
		SetAnimation (anim_HATCHE, HATCHE_proc);
}
if (HATCHF_status >= HATCHF_RAISING) {
		double da = simdt * HATCH_OPERATING_SPEED;
		if (HATCHF_status == HATCHF_RAISING) {
			if (HATCHF_proc > 0.0) HATCHF_proc = max (0.0, HATCHF_proc-da);
			else                HATCHF_status = HATCHF_UP;
		} else {
			if (HATCHF_proc < 1.0) HATCHF_proc = min (1.0, HATCHF_proc+da);
			else                HATCHF_status = HATCHF_DOWN;
		}
		SetAnimation (anim_HATCHF, HATCHF_proc);
}
if (HATCHG_status >= HATCHG_RAISING) {
		double da = simdt * HATCH_OPERATING_SPEED;
		if (HATCHG_status == HATCHG_RAISING) {
			if (HATCHG_proc > 0.0) HATCHG_proc = max (0.0, HATCHG_proc-da);
			else                HATCHG_status = HATCHG_UP;
		} else {
			if (HATCHG_proc < 1.0) HATCHG_proc = min (1.0, HATCHG_proc+da);
			else                HATCHG_status = HATCHG_DOWN;
		}
		SetAnimation (anim_HATCHG, HATCHG_proc);
}
}

void AS::Pitch()
{
	double Pitch = GetPitch();
	Pitch = Pitch * DEG;
    double Bank = GetBank();
	Bank = Bank * DEG;
	VECTOR3 vel;
	GetAngularVel(vel);
	vel = vel * DEG;
    

	if ((Pitch < 90) && (vel.x < 5))
	{
		SetThrusterGroupLevel(THGROUP_ATT_PITCHUP,1);
	}

	if (vel.x > 3)
	{
		SetThrusterGroupLevel(THGROUP_ATT_PITCHUP,0);
		SetThrusterGroupLevel(THGROUP_ATT_PITCHDOWN,1);
	}

	if (Pitch > 85)
	{
		SetThrusterGroupLevel(THGROUP_ATT_PITCHUP,0);
		SetThrusterGroupLevel(THGROUP_ATT_PITCHDOWN,0);
		ActivateNavmode(NAVMODE_KILLROT);
	}


	
    
	

}

   
void AS::Bank()
{
	double Bank = GetBank();
	Bank = Bank * DEG;
	VECTOR3 vel;
	GetAngularVel(vel);
	vel = vel * DEG;

	if ((Bank > 1) && (vel.z < 4))
	{
		SetThrusterGroupLevel(THGROUP_ATT_BANKRIGHT,1);
		
	}

	
	if ((Bank < -1))
	{
		SetThrusterGroupLevel(THGROUP_ATT_BANKLEFT,1);
		
	}
	
	if ((Bank > 1) && (Bank < 3))
	{
		SetThrusterGroupLevel(THGROUP_ATT_BANKRIGHT,0);
		SetThrusterGroupLevel(THGROUP_ATT_BANKLEFT,0);
	    ActivateNavmode(NAVMODE_KILLROT);
	}

}







void AS::ActivateAP(bool Status)
{
	if (Status == false){SetThrusterGroupLevel(THGROUP_ATT_PITCHUP,0.0); SetThrusterGroupLevel(THGROUP_ATT_PITCHDOWN,0.0);}

	if (Status == true)
	{
	Bank();
	Pitch();
	}



        
        

}
int AS::clbkConsumeBufferedKey (DWORD key, bool down, char *kstate)
{
	if (!down) return 0; // only process keydown events
		switch (key) {
			
		case OAPI_KEY_1: // deploy/retract HATCHA
			RevertHATCHA();
			return 1;
		case OAPI_KEY_2: // deploy/retract HATCHB
			RevertHATCHB();
			return 1;
		case OAPI_KEY_3: // deploy/retract HATCHC
			RevertHATCHC();
			return 1;
		case OAPI_KEY_4: // deploy/retract HATCHD
			RevertHATCHD();
			return 1;
		case OAPI_KEY_5: // deploy/retract HATCHE
			RevertHATCHE();
			return 1;
		case OAPI_KEY_6: // deploy/retract HATCHF
			RevertHATCHF();
			return 1;
		case OAPI_KEY_7: // deploy/retract HATCHG
			{
			RevertHATCHG();
			return 1;
			}
		
		case OAPI_KEY_E:
			{
				oapiOpenInputBox("Type the name of the EVA ", CREATEEVA, 0, 20, (void *)this);
			return true;
			}
		case OAPI_KEY_B:
			{
				oapiOpenInputBox("Bring Back: ", ReturnEVA, 0, 20, (void *)this);
				return true;
			}
		case OAPI_KEY_P:
			{
				SetAP(true);
                return true;
			}
		case OAPI_KEY_O:
			{
				SetAP(false);
                return true;
			}
		case OAPI_KEY_K:
			{
				if (CREATELIFT == 1)
					 {
						 CREATELIFT = 2;
						 FlightMode = "Normal";
						 LIFT = TRUE;
						    CreateAirfoil (LIFT_VERTICAL, _V(0,0,-0.2), VLiftCoeff, 5, 300, 1.5);
                            CreateAirfoil (LIFT_HORIZONTAL, _V(0,0,-4), HLiftCoeff, 5, 50, 1.5);
	                        CreateControlSurface (AIRCTRL_ELEVATOR,     6, 1.5, _V(   0,0,-17.2), AIRCTRL_AXIS_XPOS);
	                        CreateControlSurface (AIRCTRL_RUDDER,       4, 1.5, _V(   0,0,-17.2), AIRCTRL_AXIS_YPOS);
	                        CreateControlSurface (AIRCTRL_AILERON,      1, 1.5, _V( 7.5,0,-7.2), AIRCTRL_AXIS_XPOS);
	                        CreateControlSurface (AIRCTRL_AILERON,      1, 1.5, _V(-7.5,0,-7.2), AIRCTRL_AXIS_XNEG);
	                        CreateControlSurface (AIRCTRL_ELEVATORTRIM, .5, 1.5, _V(   0,0,-17.2), AIRCTRL_AXIS_XPOS);
					 }
					 else{
						 CREATELIFT = 1;
						 FlightMode = "Landing";
						 	ClearAirfoilDefinitions();
	                        ClearControlSurfaceDefinitions();
						 LIFT = FALSE;
					 }
			}
		case OAPI_KEY_C:
			{
				if (HUDCOLOR == 6)
				{
					HUDCOLOR = 1;
				}
				else{
					HUDCOLOR++;}
				return true;
			}
			
		case OAPI_KEY_V:
			{
				CamCounter++;

				if (CamCounter == 1)
				{
					SetCam(true);
				}
				if (CamCounter == 2)
				{
					SetCam(false);
					CamCounter = 0;
				}

			
			
			}
				
				

				
		
					
				
			
				
					

		
		}
	    



	   	
    return 0;
}

bool CREATEEVA(void *id, char *str, void *data)
{
	VESSEL * v = oapiGetFocusInterface();
	OBJHANDLE ASSAULT = oapiGetFocusObject();
	EVANAME = str;
	VESSELSTATUS STATUS;
	v->GetStatus(STATUS);
    STATUS.rpos.z=STATUS.rpos.z-20;
	oapiCreateVessel(EVANAME,"JTEMU",STATUS);
	EVAS++;
return true;
}
	
bool ReturnEVA(void *id, char *str, void *data)
{
	OBJHANDLE DELETEVESSEL = oapiGetObjectByName(str);
	if (DELETEVESSEL == NULL)
	{
	return false;
	}
	else
	{
	oapiDeleteVessel(DELETEVESSEL);
	EVAS--;
	return true;
	}
}

//Load from scn file
void AS::clbkLoadStateEx (FILEHANDLE scn, void *vs)
{
	char *line;

	while (oapiReadScenario_nextline (scn, line)) {
		if (!strnicmp (line, "HATCH_A", 6)) {
			sscanf (line+6, "%d%lf", &HATCHA_status, &HATCHA_proc);
			} else if (!strnicmp (line, "HATCH_B", 6)) {
			sscanf (line+6, "%d%lf", &HATCHB_status, &HATCHB_proc);
			} else if (!strnicmp (line, "HATCH_C", 6)) {
			sscanf (line+6, "%d%lf", &HATCHC_status, &HATCHC_proc);
			} else if (!strnicmp (line, "HATCH_D", 6)) {
			sscanf (line+6, "%d%lf", &HATCHD_status, &HATCHD_proc);
			} else if (!strnicmp (line, "HATCH_E", 6)) {
			sscanf (line+6, "%d%lf", &HATCHE_status, &HATCHE_proc);
			} else if (!strnicmp (line, "HATCH_F", 6)) {
			sscanf (line+6, "%d%lf", &HATCHF_status, &HATCHF_proc);
			} else if (!strnicmp (line, "HATCH_G", 6)) {
			sscanf (line+6, "%d%lf", &HATCHG_status, &HATCHG_proc);
		} else {
			ParseScenarioLineEx (line, vs);
		}
	}

	
	SetAnimation (anim_HATCHA, HATCHA_proc);
	SetAnimation (anim_HATCHB, HATCHB_proc);
	SetAnimation (anim_HATCHC, HATCHC_proc);
	SetAnimation (anim_HATCHD, HATCHD_proc);
	SetAnimation (anim_HATCHE, HATCHE_proc);
	SetAnimation (anim_HATCHF, HATCHF_proc);
	SetAnimation (anim_HATCHG, HATCHG_proc);
}
////save to scn file
void AS::clbkSaveState (FILEHANDLE scn)
{
	char cbuf[256];
	VESSEL2::clbkSaveState (scn);
	SaveDefaultState (scn);
	

		sprintf (cbuf, "%d %0.4f", HATCHA_status, HATCHA_proc);
		oapiWriteScenario_string (scn, "HATCH_A", cbuf);
		sprintf (cbuf, "%d %0.4f", HATCHB_status, HATCHB_proc);
		oapiWriteScenario_string (scn, "HATCH_B", cbuf);
		sprintf (cbuf, "%d %0.4f", HATCHC_status, HATCHC_proc);
		oapiWriteScenario_string (scn, "HATCH_C", cbuf);
		sprintf (cbuf, "%d %0.4f", HATCHD_status, HATCHD_proc);
		oapiWriteScenario_string (scn, "HATCH_D", cbuf);
	    sprintf (cbuf, "%d %0.4f", HATCHE_status, HATCHE_proc);
		oapiWriteScenario_string (scn, "HATCH_E", cbuf);
		sprintf (cbuf, "%d %0.4f", HATCHF_status, HATCHF_proc);
		oapiWriteScenario_string (scn, "HATCH_F", cbuf);
		sprintf (cbuf, "%d %0.4f", HATCHG_status, HATCHG_proc);
		oapiWriteScenario_string (scn, "HATCH_G", cbuf);
		
	}


void AS::clbkDrawHUD(int iMode, const HUDPAINTSPEC* pHPS, HDC hdc)
{
	VESSEL2::clbkDrawHUD(iMode, pHPS, hdc);
    
	switch(iMode)
	{
	case HUD_SURFACE:
		{
			
			if (HUDCOLOR == 1)
			{
				SetTextColor(hdc,RED);
			}
			if (HUDCOLOR == 2)
			{
				SetTextColor(hdc,YELLOW);
			}
			if (HUDCOLOR == 3)
			{
				SetTextColor(hdc,WHITE);
			}
			if (HUDCOLOR == 4)
			{
				SetTextColor(hdc,BLUE);
			}
			if (HUDCOLOR == 5)
			{
				SetTextColor(hdc,SEAGREEN);
			}
            
			
			
			if (HUDCOLOR != 6)
			{
				char * percent = "%";

			sprintf(buffer,"ISA Assault Scout{%s)",ScoutName);
  TextOut(hdc,10,200,buffer,strlen(buffer));
  sprintf(buffer,"Control Mode  :(%s)",ControlSystem);
  TextOut(hdc,10,220,buffer,strlen(buffer));
  sprintf(buffer,"Zeni Fuel Mass: %.1f",ZENIFUELMASS);
  TextOut(hdc,10,240,buffer,strlen(buffer));
  sprintf(buffer,"PJET Fuel Mass: %.1f",PJETFUELMASS);
  TextOut(hdc,10,260,buffer,strlen(buffer));
  sprintf(buffer,"AutoPilot     : (%s)",APSTATUS);
  TextOut(hdc,10,280,buffer,strlen(buffer));
  sprintf(buffer,"EVA Status    : (%s)",EVASTATUS);
  TextOut(hdc,10,300,buffer,strlen(buffer));
  sprintf(buffer,"Ext. Temp     : %.1fk",ExternalTemperature);
  TextOut(hdc,10,320,buffer,strlen(buffer));
  sprintf(buffer,"Ext. Pressure : %.1fPa",DynamicPressure);
  TextOut(hdc,10,340,buffer,strlen(buffer));
  sprintf(buffer,"Flight Mode   : (%s)",FlightMode);
  TextOut(hdc,10,360,buffer,strlen(buffer));

  //Second print. We use the same y


  TextOut(hdc,700,200,"System Status: ",14);

  sprintf(buffer,"STRUCTURAL   : %.1f %s",Structure,percent);
  TextOut(hdc,800,220,buffer,strlen(buffer));
  sprintf(buffer,"Zeni Engines : %.1f %s",ZeniDrive,percent);
  TextOut(hdc,800,240,buffer,strlen(buffer));
  sprintf(buffer,"Pjet Engines : %.1f %s",PjetDrive,percent);
  TextOut(hdc,800,260,buffer,strlen(buffer));
  sprintf(buffer,"RCS Thrusters: %.1f %s",Thrusters,percent);
  TextOut(hdc,800,280,buffer,strlen(buffer));
  sprintf(buffer,"Life Support : %.1f %s",LifeSupport,percent);
  TextOut(hdc,800,300,buffer,strlen(buffer));
  //sprintf(buffer,"Avonics      : %.1f%s",,)"%";
  //TextOut(hdc,700,320,buffer,strlen(buffer));
			}






		
	       

		
		break;
		}

	case HUD_NONE:
		{
		break;
		}
		

		
	}



}



