
#define STRICT
#define ORBITER_MODULE
#define _CRT_SECURE_NO_DEPRECATE 1

#include "orbitersdk.h"
#include "Cargopod.h"


Cargopod::Cargopod (OBJHANDLE hObj, int fmodel)
: VESSEL2 (hObj, fmodel)
{
	
	

	HATCH_proc = 0.0;
	HATCH_status = HATCH_UP;
	HATCHA_proc = 0.0;
	HATCHA_status = HATCHA_UP;
	HATCHB_proc = 0.0;
	HATCHB_status = HATCHB_UP;
	HATCHC_proc = 0.0;
	HATCHC_status = HATCHC_UP;
	
	DefineAnimations ();

	sat_attach       = NULL;
	sat_attachA      = NULL;
	sat_attachB      = NULL;
	sat_attachC      = NULL;
	waldo_attach	 = NULL;
	
}
	
void Cargopod::DefineAnimations (void)
{
	static UINT HATCHGrp[1] = {0};
	static MGROUP_TRANSLATE HATCH (0, HATCHGrp, 1, _V(0,0.3,0));
	
	static UINT LOWHATCHGrp [1] = {0};
	static MGROUP_TRANSLATE LOWHATCH (0, LOWHATCHGrp, 1, _V(0,0,7));
	
	anim_HATCH = CreateAnimation (0);
	AddAnimationComponent (anim_HATCH, 0, 0.5, &HATCH);
	AddAnimationComponent (anim_HATCH, 0.5, 1, &LOWHATCH);
	
	static UINT HATCHAGrp [1] = {2};
	static MGROUP_ROTATE HATCHA (0, HATCHAGrp, 1, _V(7,3.9375,13.8),_V(-0.334,0.666,0), (float)(-170*RAD));
	
	anim_HATCHA = CreateAnimation (0);
	AddAnimationComponent (anim_HATCHA, 0, 1, &HATCHA);
	
	static UINT HATCHBGrp [1] = {3};
	static MGROUP_ROTATE HATCHB (0, HATCHBGrp, 1, _V(-7,3.9375,13.8),_V(0.333,0.667,0), (float)(170*RAD));
	
	anim_HATCHB = CreateAnimation (0);
	AddAnimationComponent (anim_HATCHB, 0, 1, &HATCHB);
	
	static UINT HATCHCGrp [1] = {4};
	static MGROUP_ROTATE HATCHC (0, HATCHCGrp, 1, _V(0,-8,13.8),_V(1,0,0), (float)(-125*RAD));
	
	anim_HATCHC = CreateAnimation (0);
	AddAnimationComponent (anim_HATCHC, 0, 1, &HATCHC);

}
void Cargopod::RevertHATCH (void)
{
	HATCH_status = ((HATCH_status == HATCH_UP || HATCH_status == HATCH_RAISING) ?
		HATCH_LOWERING : HATCH_RAISING);
}
void Cargopod::RevertHATCHA (void)
{
	HATCHA_status = ((HATCHA_status == HATCHA_UP || HATCHA_status == HATCHA_RAISING) ?
		HATCHA_LOWERING : HATCHA_RAISING);
}
void Cargopod::RevertHATCHB (void)
{
	HATCHB_status = ((HATCHB_status == HATCHB_UP || HATCHB_status == HATCHB_RAISING) ?
		HATCHB_LOWERING : HATCHB_RAISING);
}
void Cargopod::RevertHATCHC (void)
{
	HATCHC_status = ((HATCHC_status == HATCHC_UP || HATCHC_status == HATCHC_RAISING) ?
		HATCHC_LOWERING : HATCHC_RAISING);
}

void Cargopod::clbkSetClassCaps (FILEHANDLE cfg)
{
	THRUSTER_HANDLE th_rcs[14], th_group[4];

	SetSize (30);
	SetEmptyMass (2000);
	SetCW (1, 1, 1, 1);
	SetCrossSections (_V(1100,1100,500));
	SetRotDrag (_V(0.6,0.6,0.35));
	if (GetFlightModel() >= 1) {
		SetPitchMomentScale (5e-4);
		SetBankMomentScale (5e-4);
	}
	SetTrimScale (0.05);
	SetCameraOffset (_V(0,0.0,28));
	SetPMI (_V(10,10,5.175));
	SetTouchdownPoints (_V(0,9,30.5), _V(-7.86,-4.5,30.5), _V(7.86,-4.5,30.5));
	SetSurfaceFrictionCoeff (1, 1);
	SetMeshVisibilityMode (AddMesh("55Cancri//Cargopod"), MESHVIS_ALWAYS);
	if (!sat_attach)  sat_attach = CreateAttachment (false, _V(0,0,3.25), _V(0,-1,0), _V(0,0,-1), "XT", true);
	if (!sat_attachA) sat_attachA = CreateAttachment (false, _V(0,0,-3.25), _V(0,-1,0), _V(0,0,-1), "XT", true);
	if (!sat_attachB) sat_attachB = CreateAttachment (false, _V(0,0,-9.5), _V(0,-1,0), _V(0,0,-1), "XT", true);
	if (!sat_attachC) sat_attachC = CreateAttachment (false, _V(0,0,-15.5), _V(0,-1,0), _V(0,0,-1), "XT", true);
	if (!waldo_attach) waldo_attach = CreateAttachment (false, _V(0,0,25.5), _V(0,-1,0), _V(0,0,-1), "WS", true);

	// propellant resources
	PROPELLANT_HANDLE hpr;
	hpr = CreatePropellantResource (Cargopod_FUELMASS);
	

	// ***************** thruster definitions *******************
     
	th_rcs[ 0] = CreateThruster (_V( 1,0, 3), _V(0,1,0), Cargopod_MAXRCSTH, hpr, Cargopod_ISP);
	th_rcs[ 1] = CreateThruster (_V( 1,0, 3), _V(0,-1,0), Cargopod_MAXRCSTH, hpr, Cargopod_ISP);
	th_rcs[ 2] = CreateThruster (_V(-1,0, 3), _V(0,1,0), Cargopod_MAXRCSTH, hpr, Cargopod_ISP);
	th_rcs[ 3] = CreateThruster (_V(-1,0, 3), _V(0,-1,0), Cargopod_MAXRCSTH, hpr, Cargopod_ISP);
	th_rcs[ 4] = CreateThruster (_V( 1,0,-3), _V(0,1,0), Cargopod_MAXRCSTH, hpr, Cargopod_ISP);
	th_rcs[ 5] = CreateThruster (_V( 1,0,-3), _V(0,-1,0), Cargopod_MAXRCSTH, hpr, Cargopod_ISP);
	th_rcs[ 6] = CreateThruster (_V(-1,0,-3), _V(0,1,0), Cargopod_MAXRCSTH, hpr, Cargopod_ISP);
	th_rcs[ 7] = CreateThruster (_V(-1,0,-3), _V(0,-1,0), Cargopod_MAXRCSTH, hpr, Cargopod_ISP);
	th_rcs[ 8] = CreateThruster (_V( 1,0, 3), _V(-1,0,0), Cargopod_MAXRCSTH, hpr, Cargopod_ISP);
	th_rcs[ 9] = CreateThruster (_V(-1,0, 3), _V(1,0,0), Cargopod_MAXRCSTH, hpr, Cargopod_ISP);
	th_rcs[10] = CreateThruster (_V( 1,0,-3), _V(-1,0,0), Cargopod_MAXRCSTH, hpr, Cargopod_ISP);
	th_rcs[11] = CreateThruster (_V(-1,0,-3), _V(1,0,0), Cargopod_MAXRCSTH, hpr, Cargopod_ISP);
	th_rcs[12] = CreateThruster (_V( 0,0,-3), _V(0,0,1), Cargopod_MAXRCSTH, hpr, Cargopod_ISP);
	th_rcs[13] = CreateThruster (_V( 0,0, 3), _V(0,0,-1), Cargopod_MAXRCSTH, hpr, Cargopod_ISP);

	th_group[0] = th_rcs[0];
	th_group[1] = th_rcs[2];
	th_group[2] = th_rcs[5];
	th_group[3] = th_rcs[7];
	CreateThrusterGroup (th_group, 4, THGROUP_ATT_PITCHUP);

	th_group[0] = th_rcs[1];
	th_group[1] = th_rcs[3];
	th_group[2] = th_rcs[4];
	th_group[3] = th_rcs[6];
	CreateThrusterGroup (th_group, 4, THGROUP_ATT_PITCHDOWN);

	th_group[0] = th_rcs[0];
	th_group[1] = th_rcs[4];
	th_group[2] = th_rcs[3];
	th_group[3] = th_rcs[7];
	CreateThrusterGroup (th_group, 4, THGROUP_ATT_BANKLEFT);

	th_group[0] = th_rcs[1];
	th_group[1] = th_rcs[5];
	th_group[2] = th_rcs[2];
	th_group[3] = th_rcs[6];
	CreateThrusterGroup (th_group, 4, THGROUP_ATT_BANKRIGHT);

	th_group[0] = th_rcs[0];
	th_group[1] = th_rcs[4];
	th_group[2] = th_rcs[2];
	th_group[3] = th_rcs[6];
	CreateThrusterGroup (th_group, 4, THGROUP_ATT_UP);

	th_group[0] = th_rcs[1];
	th_group[1] = th_rcs[5];
	th_group[2] = th_rcs[3];
	th_group[3] = th_rcs[7];
	CreateThrusterGroup (th_group, 4, THGROUP_ATT_DOWN);

	th_group[0] = th_rcs[8];
	th_group[1] = th_rcs[11];
	CreateThrusterGroup (th_group, 2, THGROUP_ATT_YAWLEFT);

	th_group[0] = th_rcs[9];
	th_group[1] = th_rcs[10];
	CreateThrusterGroup (th_group, 2, THGROUP_ATT_YAWRIGHT);

	th_group[0] = th_rcs[8];
	th_group[1] = th_rcs[10];
	CreateThrusterGroup (th_group, 2, THGROUP_ATT_LEFT);

	th_group[0] = th_rcs[9];
	th_group[1] = th_rcs[11];
	CreateThrusterGroup (th_group, 2, THGROUP_ATT_RIGHT);

	CreateThrusterGroup (th_rcs+12, 1, THGROUP_ATT_FORWARD);
	CreateThrusterGroup (th_rcs+13, 1, THGROUP_ATT_BACK);

}

void Cargopod::SecureCargo ()
{
	VECTOR3 grms;
	VECTOR3 cent;
	VECTOR3 pos,dir,rot;

	Local2Global (cent, grms);
	double ownsize = GetSize();
	VECTOR3 rpos;
	for (DWORD i = 0; i < oapiGetVesselCount(); i++) {
			OBJHANDLE hV = oapiGetVesselByIndex (i);
			double othersize = oapiGetSize(hV);
			if (hV == GetHandle()) continue; // we don't want to grapple ourselves ...
			oapiGetRelativePos(GetHandle(), hV, &rpos);
			if(length(rpos) < 3) {
			VESSEL *v = oapiGetVesselInterface (hV);
	DWORD nAttach = v->AttachmentCount (true);
	for (DWORD j = 0; j < nAttach; j++) { // now scan all attachment points
	ATTACHMENTHANDLE hAtt = v->GetAttachmentHandle (true, j);
	const char *id = v->GetAttachmentId (hAtt);
	if (strncmp (id, "XT", 2)) continue; // attachment point not compatible
	v->GetAttachmentParams (hAtt, pos, dir, rot);
		AttachChild (hV, sat_attach, hAtt);
		return;
				}
			}
		}

}
void Cargopod::SecureCargoA ()
{
	VECTOR3 grms;
	VECTOR3 cent;
	VECTOR3 pos,dir,rot;

	Local2Global (cent, grms);
	double ownsize = GetSize();
	VECTOR3 rpos;
	for (DWORD i = 0; i < oapiGetVesselCount(); i++) {
			OBJHANDLE hV = oapiGetVesselByIndex (i);
			double othersize = oapiGetSize(hV);
			if (hV == GetHandle()) continue; // we don't want to grapple ourselves ...
			oapiGetRelativePos(GetHandle(), hV, &rpos);
			if(length(rpos) < 3) {
			VESSEL *v = oapiGetVesselInterface (hV);
	DWORD nAttach = v->AttachmentCount (true);
	for (DWORD j = 0; j < nAttach; j++) { // now scan all attachment points
	ATTACHMENTHANDLE hAtt = v->GetAttachmentHandle (true, j);
	const char *id = v->GetAttachmentId (hAtt);
	if (strncmp (id, "XT", 2)) continue; // attachment point not compatible
	v->GetAttachmentParams (hAtt, pos, dir, rot);
		AttachChild (hV, sat_attachA, hAtt);
		return;
				}
			}
		}

}
void Cargopod::SecureCargoB ()
{
	VECTOR3 grms;
	VECTOR3 cent;
	VECTOR3 pos,dir,rot;

	Local2Global (cent, grms);
	double ownsize = GetSize();
	VECTOR3 rpos;
	for (DWORD i = 0; i < oapiGetVesselCount(); i++) {
			OBJHANDLE hV = oapiGetVesselByIndex (i);
			double othersize = oapiGetSize(hV);
			if (hV == GetHandle()) continue; // we don't want to grapple ourselves ...
			oapiGetRelativePos(GetHandle(), hV, &rpos);
			if(length(rpos) < 3) {
			VESSEL *v = oapiGetVesselInterface (hV);
	DWORD nAttach = v->AttachmentCount (true);
	for (DWORD j = 0; j < nAttach; j++) { // now scan all attachment points
	ATTACHMENTHANDLE hAtt = v->GetAttachmentHandle (true, j);
	const char *id = v->GetAttachmentId (hAtt);
	if (strncmp (id, "XT", 2)) continue; // attachment point not compatible
	v->GetAttachmentParams (hAtt, pos, dir, rot);
		 AttachChild (hV, sat_attachB, hAtt);
		return;
				}
			}
		}

}
void Cargopod::SecureCargoC ()
{
	VECTOR3 grms;
	VECTOR3 cent;
	VECTOR3 pos,dir,rot;
	

	Local2Global (cent, grms);
	double ownsize = GetSize();
	VECTOR3 rpos;
	for (DWORD i = 0; i < oapiGetVesselCount(); i++) {
			OBJHANDLE hV = oapiGetVesselByIndex (i);
			double othersize = oapiGetSize(hV);
			if (hV == GetHandle()) continue; // we don't want to grapple ourselves ...
			oapiGetRelativePos(GetHandle(), hV, &rpos);
			if(length(rpos) < 3) {
			VESSEL *v = oapiGetVesselInterface (hV);
	DWORD nAttach = v->AttachmentCount (true);
	for (DWORD j = 0; j < nAttach; j++) { // now scan all attachment points
	ATTACHMENTHANDLE hAtt = v->GetAttachmentHandle (true, j);
	const char *id = v->GetAttachmentId (hAtt);
	if (strncmp (id, "XT", 2)) continue; // attachment point not compatible
	v->GetAttachmentParams (hAtt, pos, dir, rot);
		AttachChild (hV, sat_attachC, hAtt);
		return;
				}
			}
		}

}
void Cargopod::SecureWaldo ()
{
	VECTOR3 grms;
	VECTOR3 cent;
	VECTOR3 pos,dir,rot;

	Local2Global (cent, grms);
	double ownsize = GetSize();
	VECTOR3 rpos;
	for (DWORD i = 0; i < oapiGetVesselCount(); i++) {
			OBJHANDLE hV = oapiGetVesselByIndex (i);
			double othersize = oapiGetSize(hV);
			if (hV == GetHandle()) continue; // we don't want to grapple ourselves ...
			oapiGetRelativePos(GetHandle(), hV, &rpos);
			if(length(rpos) < 25) {
			VESSEL *v = oapiGetVesselInterface (hV);
	DWORD nAttach = v->AttachmentCount (true);
	for (DWORD j = 0; j < nAttach; j++) { // now scan all attachment points
	ATTACHMENTHANDLE hAtt = v->GetAttachmentHandle (true, j);
	const char *id = v->GetAttachmentId (hAtt);
	if (strncmp (id, "WS", 2)) continue; // attachment point not compatible
	v->GetAttachmentParams (hAtt, pos, dir, rot);
		AttachChild (hV, waldo_attach, hAtt);
		return;
				}
			}
		}

}
// ==============================================================
// API callback interface
// ==============================================================

void Cargopod::clbkPostStep (double simt, double simdt, double mjd)
{
	OBJHANDLE hG=GetAttachmentStatus(sat_attach);
	OBJHANDLE hGA=GetAttachmentStatus(sat_attachA);
	OBJHANDLE hGB=GetAttachmentStatus(sat_attachB);
	OBJHANDLE hGC=GetAttachmentStatus(sat_attachC);

	// Animate HATCH
	if (HATCH_status >= HATCH_RAISING) {
		double da = simdt * HATCH_OPERATING_SPEED;
		if (HATCH_status == HATCH_RAISING) {
			if (HATCH_proc > 0.0) HATCH_proc = max (0.0, HATCH_proc-da);
			else                HATCH_status = HATCH_UP;
		} else {
			if (HATCH_proc < 1.0) HATCH_proc = min (1.0, HATCH_proc+da);
			else                HATCH_status = HATCH_DOWN;
		}
		SetAnimation (anim_HATCH, HATCH_proc);
}
if (HATCHA_status >= HATCHA_RAISING) {
		double da = simdt * HATCH_OPERATING_SPEED;
		if (HATCHA_status == HATCHA_RAISING) {
			if (HATCHA_proc > 0.0) HATCHA_proc = max (0.0, HATCHA_proc-da);
			else                HATCHA_status = HATCHA_UP;
		} else {
			if (HATCHA_proc < 1.0) HATCHA_proc = min (1.0, HATCHA_proc+da);
			else                HATCHA_status = HATCHA_DOWN;
		}
		SetAnimation (anim_HATCHA, HATCHA_proc);
}
if (HATCHB_status >= HATCHB_RAISING) {
		double da = simdt * HATCH_OPERATING_SPEED;
		if (HATCHB_status == HATCHB_RAISING) {
			if (HATCHB_proc > 0.0) HATCHB_proc = max (0.0, HATCHB_proc-da);
			else                HATCHB_status = HATCHB_UP;
		} else {
			if (HATCHB_proc < 1.0) HATCHB_proc = min (1.0, HATCHB_proc+da);
			else                HATCHB_status = HATCHB_DOWN;
		}
		SetAnimation (anim_HATCHB, HATCHB_proc);
}
if (HATCHC_status >= HATCHC_RAISING) {
		double da = simdt * HATCH_OPERATING_SPEED;
		if (HATCHC_status == HATCHC_RAISING) {
			if (HATCHC_proc > 0.0) HATCHC_proc = max (0.0, HATCHC_proc-da);
			else                HATCHC_status = HATCHC_UP;
		} else {
			if (HATCHC_proc < 1.0) HATCHC_proc = min (1.0, HATCHC_proc+da);
			else                HATCHC_status = HATCHC_DOWN;
		}
		SetAnimation (anim_HATCHC, HATCHC_proc);
	}
if (GetSize()==30.01){
	RevertHATCH();
	SetSize(30);
	}
if (GetSize()==30.02){
	RevertHATCHA();
	SetSize(30);
	}
if (GetSize()==30.03){
	RevertHATCHB();
	SetSize(30);
	}
if (GetSize()==30.04){
	RevertHATCHC();
	SetSize(30);
	}
if (GetSize()==30.05){
	SecureCargo();
	SetSize(30);
	}
if (GetSize()==30.06){
	SecureCargoA();
	SetSize(30);
	}
if (GetSize()==30.07){
	SecureCargoB();
	SetSize(30);
	}
if (GetSize()==30.08){
	SecureCargoC();
	SetSize(30);
	}
}

int Cargopod::clbkConsumeBufferedKey (DWORD key, bool down, char *kstate)
{
	if (!down) return 0; // only process keydown events
		switch (key) {
		case OAPI_KEY_G: // deploy/retract HATCH
			RevertHATCH();
			return 1;
		case OAPI_KEY_1: // deploy/retract HATCHA
			RevertHATCHA();
			return 1;
		case OAPI_KEY_2: // deploy/retract HATCHB
			RevertHATCHB();
			return 1;
		case OAPI_KEY_3: // deploy/retract HATCHC
			RevertHATCHC();
			return 1;
		case OAPI_KEY_4: // deploy/retract HATCHC
			SecureWaldo();
			return 1;
		case OAPI_KEY_5: // deploy/retract HATCHC
			DetachChild(waldo_attach,0);
			return 1;
		}
	return 0;
}
//Load from scn file
void Cargopod::clbkLoadStateEx (FILEHANDLE scn, void *vs)
{
	char *line;

	while (oapiReadScenario_nextline (scn, line)) {
		if (!_strnicmp (line, "HATCH", 5)) {
			sscanf (line+5, "%d%lf", &HATCH_status, &HATCH_proc);
			} else if (!_strnicmp (line, "HATCHA", 6)) {
			sscanf (line+6, "%d%lf", &HATCHA_status, &HATCHA_proc);
			} else if (!_strnicmp (line, "HATCHB", 6)) {
			sscanf (line+6, "%d%lf", &HATCHB_status, &HATCHB_proc);
			} else if (!_strnicmp (line, "HATCHC", 6)) {
			sscanf (line+6, "%d%lf", &HATCHC_status, &HATCHC_proc);
		} else {
			ParseScenarioLineEx (line, vs);
		}
	}

	SetAnimation (anim_HATCH, HATCH_proc);
	SetAnimation (anim_HATCHA, HATCHA_proc);
	SetAnimation (anim_HATCHB, HATCHB_proc);
	SetAnimation (anim_HATCHC, HATCHC_proc);
}
////save to scn file
void Cargopod::clbkSaveState (FILEHANDLE scn)
{
	char cbuf[256];
	VESSEL2::clbkSaveState (scn);
	
	sprintf (cbuf, "%d %0.4f", HATCH_status, HATCH_proc);
	oapiWriteScenario_string (scn, "HATCH", cbuf);

		sprintf (cbuf, "%d %0.4f", HATCHA_status, HATCHA_proc);
		oapiWriteScenario_string (scn, "HATCHA", cbuf);
	
		sprintf (cbuf, "%d %0.4f", HATCHB_status, HATCHB_proc);
		oapiWriteScenario_string (scn, "HATCHB", cbuf);
	
		sprintf (cbuf, "%d %0.4f", HATCHC_status, HATCHC_proc);
		oapiWriteScenario_string (scn, "HATCHC", cbuf);
	}
// --------------------------------------------------------------
// Vessel initialisation
// --------------------------------------------------------------
DLLCLBK VESSEL *ovcInit (OBJHANDLE hvessel, int flightmodel)
{
	return new Cargopod (hvessel, flightmodel);
}

// --------------------------------------------------------------
// Vessel cleanup
// --------------------------------------------------------------
DLLCLBK void ovcExit (VESSEL *vessel)
{
	if (vessel) delete (Cargopod*)vessel;
}



