// ==============================================================
//                 ORBITER MODULE: Atlantis
//                  Part of the ORBITER SDK
//          Copyright (C) 2001-2004 Martin Schweiger
//                   All rights reserved
//
// W.h
// W basic specs and animations
//
// W mesh and textures by David Sundstrom
// ==============================================================

#ifndef __W_H
#define __W_H

#define STRICT
#include "orbitersdk.h"

// ==============================================================
// Some parameters and capabilities
// ==============================================================

const double ZENI_FUELMASS = 170.0;
const double VAC_ZENI_ISP = 6.25e8;
const double NML_ZENI_ISP = 1e1;
const double ZENI_MAXMAINTH = 5e2;
const double ORE_MAXRCSTH = 5e2;
const double P_NML = 1e1;

// ==============================================================
// W class interface
// ==============================================================

class ORE: public VESSEL2 {
public:
	ORE (OBJHANDLE hObj, int fmodel);
	void Network(void);
	ATTACHMENTHANDLE lnk_attach;
	
	// Overloaded callback functions
	void clbkSetClassCaps (FILEHANDLE cfg);
//	void clbkLoadStateEx (FILEHANDLE scn, void *vs);
//	void clbkSaveState (FILEHANDLE scn);
	void clbkPostStep (double simt, double simdt, double mjd);
//	int  clbkConsumeBufferedKey (DWORD key, bool down, char *kstate);

private:
	
};

#endif // !__W_H