// ==============================================================
//                 ORBITER MODULE: Atlantis
//                  Part of the ORBITER SDK
//          Copyright (C) 2001-2004 Martin Schweiger
//                   All rights reserved
//
// W.h
// W basic specs and animations
//
// W mesh and textures by David Sundstrom
// ==============================================================

#ifndef __Tug_H
#define __Tug_H

#define STRICT
#include "orbitersdk.h"

// ==============================================================
// Some parameters and capabilities
// ==============================================================

const double ZENI_FUELMASS = 39000.0;
const double VAC_ZENI_ISP = 6.25e8;
const double NML_ZENI_ISP = 1e1;
const double ZENI_MAXMAINTH = 5.5e5;
const double ZENI_MAXRETROTH = 8e5;
const double AS_MAXRCSTH = 3e5;
const double P_NML = 50e1;

const VECTOR3 OFS_POD = {0,0,30.0};


// ==============================================================
// W class interface
// ==============================================================

class Tug: public VESSEL2 {
public:
	Tug (OBJHANDLE hVessel, int flightmodel);
	void AttachPod(void);
	void RemoteView(void);
	void clbkSetClassCaps (FILEHANDLE cfg);
	void clbkPostCreation(void);
	void clbkPostStep (double simt, double simdt, double mjd); // Animation
	int  clbkConsumeBufferedKey (DWORD key, bool down, char *kstate); // Used to control events such as animation
	int Calamari;
	ATTACHMENTHANDLE pod_attach;
	OBJHANDLE hearth,hves;
	VECTOR3 Tglob,Tloc,Mglob,Mloc,Rloc,RVel,RLVel;
	bool Rview;
};

#endif // !__Tug_H