
#define STRICT
#define ORBITER_MODULE
#include "stdio.h"
#include "orbitersdk.h"
#include "OrbiterSoundSDK3.h"
const double ROVER_FUELMASS = 500.0;
const double ROVER_ISP = 6.25e6;
const double ROVER_MAXMAINTH = 2e4;
const double ROVER_MAXRCSTH = 5e4;
const double HATCH_OPERATING_SPEED = 0.1;
const double RADAR_OPERATING_SPEED = 0.00001;
double i = 0;
double i2 = 0;
double i3 = 0;
double i4 = 0;
double ib = 0;
double i2b = 0;
double i3b = 0;
double i4b = 0;
THRUSTER_HANDLE th_main, th_retro, th_hover, th_rcs[14], th_group[4];
class ROVER: public VESSEL2 {
public:


	ROVER (OBJHANDLE hVessel, int flightmodel)
		: VESSEL2 (hVessel, flightmodel) {
	HATCH_proc = 0.0;
	HATCH_status = HATCH_UP;
	ANTENNA_proc = 0.0;
	DefineAnimations ();
	}
	void clbkSetClassCaps (FILEHANDLE cfg);
	//void clbkPreStep (double simt, double simdt, double mjd);
	void clbkPostCreation(void);
	void clbkLoadStateEx (FILEHANDLE scn, void *vs);//loads the status from the scenario file
	void clbkSaveState (FILEHANDLE scn);// for saving status to scenario file
	void clbkPostStep (double simt, double simdt, double mjd); //
	void DefineAnimations (void); // Useful for animation
	int  clbkConsumeBufferedKey (DWORD key, bool down, char *kstate); // Used to control events such as animation
	int Sailor;
	enum HATCHStatus { HATCH_UP, HATCH_DOWN, HATCH_RAISING, HATCH_LOWERING } HATCH_status;
	
	
	
	void RevertHATCH (void);
	

	
private:
	
MESHHANDLE exmesh_tpl;
double Play_ROVER1;

	UINT anim_HATCH;
	double HATCH_proc;
	UINT anim_ANTENNA;
	double ANTENNA_proc;
	UINT anim_LEFTWHEELS;
    
    UINT anim_RIGHTWHEELS;
    
    UINT anim_LEFTBACK;
    
    UINT anim_RIGHTBACK;
    
    VECTOR3 RelPos1;        
    VECTOR3 MinDist1;
     OBJHANDLE hbase;
  
	
};
void ROVER::DefineAnimations (void)
{
	
	//UPPER DOOR PANEL  
	static UINT HATCHAGrp [1] = {32};
	static MGROUP_ROTATE HATCHA (0, HATCHAGrp, 1, _V(-1.896, -.366, .666),_V(0,0,-1), (float)(-62*RAD));
	
	
	//MIDDLE DOOR PANEL
	static UINT HATCHBGrp [2] = {32,31};
	static MGROUP_ROTATE HATCHB (0, HATCHBGrp, 2, _V(-1.896, -1.468, .666),_V(0,0,-1), (float)(-112*RAD));
	
	
	//bottom panel
	static UINT HATCHCGrp [3] = {32,31,30};
	static MGROUP_ROTATE HATCHC (0, HATCHCGrp, 3, _V(-1.041, -1.931, .666),_V(0,0,-1), (float)(-28.5*RAD));
	
	//AIRLOCK DOOR
	static UINT AIRDOORGrp[1] = {71};
	static MGROUP_TRANSLATE AIRDOOR (0, AIRDOORGrp, 1, _V(-.9,0,0));
	
	//AIRLOCK
	static UINT AIRLOCKGrp[1] = {70};
	static MGROUP_SCALE AIRLOCK (0, AIRLOCKGrp, 1, _V(-1.09, -.956, .666), _V(34,1,1));
	
	
	anim_HATCH = CreateAnimation (0);
	AddAnimationComponent (anim_HATCH, 0,.25, &HATCHA);
	AddAnimationComponent (anim_HATCH, .25, 0.5, &HATCHB);
	AddAnimationComponent (anim_HATCH, 0.5, .75, &HATCHC);
	AddAnimationComponent (anim_HATCH, 0.75, 1, &AIRDOOR);
    AddAnimationComponent (anim_HATCH, 0.75, 1, &AIRLOCK);
	
	
	
	/////////////////////////////////////////////////////////////////////////////////////////
	
	
	static UINT ANTENNAGrp [4] = {26,27,28,29};
	static MGROUP_ROTATE ANTENNA (0, ANTENNAGrp, 4, _V(.664,.489,.965),_V(0,1,0), (float)(17000*PI));
	
	anim_ANTENNA = CreateAnimation (0);
	AddAnimationComponent (anim_ANTENNA, 0, 1, &ANTENNA);
/////////////////////////////////////////////////////////////////////////////////////////////////

 // Front Left Wheel
   static UINT WGrp1[2] = {24,25};
   
   static MGROUP_ROTATE wheellf (0,WGrp1, 2, _V(0,-2.805,2.583), _V(1,0,0), (float)(360*RAD));
   
   //Front Right Wheel
   static UINT WGrp2[2] = {14,15};
   
   static MGROUP_ROTATE wheelrf (0,WGrp2, 2, _V(0,-2.805,2.583), _V(1,0,0), (float)(360*RAD));
   
   //Rear Left Wheel
   static UINT WGrp3[2] = {19,20};
   
   static MGROUP_ROTATE wheellr (0,WGrp3, 2, _V(0,-2.805,-2.439), _V(1,0,0), (float)(360*RAD));
   
   //Rear Right wheel
   static UINT WGrp4[2] = {9,10};
   
   static MGROUP_ROTATE wheelrr (0,WGrp4, 2, _V(0,-2.805,-2.439), _V(1,0,0), (float)(360*RAD));
   
   anim_LEFTWHEELS = CreateAnimation (0);
   AddAnimationComponent  (anim_LEFTWHEELS, 0, 1, &wheellf);
   AddAnimationComponent  (anim_LEFTWHEELS, 0, 1, &wheellr);
   
   anim_RIGHTWHEELS = CreateAnimation (0);
   AddAnimationComponent  (anim_RIGHTWHEELS, 0, 1, &wheelrf);
   AddAnimationComponent  (anim_RIGHTWHEELS, 0, 1, &wheelrr);
 /////////////////////REVERSE
  // Front Left Wheel
  
   static UINT WGrp5[2] = {24,25};
   static MGROUP_ROTATE wheellfB (0,WGrp5, 2, _V(0,-2.805,2.583), _V(1,0,0), (float)(-360*RAD));
   
   //Front Right Wheel
 
   static UINT WGrp6[2] = {14,15};
   static MGROUP_ROTATE wheelrfB (0,WGrp6, 2, _V(0,-2.805,2.583), _V(1,0,0), (float)(-360*RAD));
   
   //Rear Left Wheel
 
    static UINT WGrp7[2] = {19,20};
   static MGROUP_ROTATE wheellrB (0,WGrp7, 2, _V(0,-2.805,-2.439), _V(1,0,0), (float)(-360*RAD));
   
   //Rear Right wheel
   static UINT WGrp8[2] = {9,10};
   static MGROUP_ROTATE wheelrrB (0,WGrp8, 2, _V(0,-2.805,-2.439), _V(1,0,0), (float)(-360*RAD));
   
   anim_LEFTBACK = CreateAnimation (0);
   AddAnimationComponent  (anim_LEFTBACK, 0, 1, &wheellfB);
   AddAnimationComponent  (anim_LEFTBACK, 0, 1, &wheellrB);
   
   anim_RIGHTBACK = CreateAnimation (0);
   AddAnimationComponent  (anim_RIGHTBACK, 0, 1, &wheelrfB);
   AddAnimationComponent  (anim_RIGHTBACK, 0, 1, &wheelrrB); 
}

void ROVER::RevertHATCH (void)
{
	HATCH_status = ((HATCH_status == HATCH_UP || HATCH_status == HATCH_RAISING) ?
		HATCH_LOWERING : HATCH_RAISING);
}
/*void ROVER::RevertANTENNA (void)
{
	ANTENNA_status = ((ANTENNA_status == ANTENNA_UP || ANTENNA_status == ANTENNA_RAISING) ?
		ANTENNA_LOWERING : ANTENNA_RAISING);
}
*/
void ROVER::clbkSetClassCaps (FILEHANDLE cfg)
{
	//THRUSTER_HANDLE th_main, th_retro, th_hover, th_rcs[14], th_group[4];
  //  SURFHANDLE tex1 = oapiRegisterExhaustTexture ("ROVERExhaust");
	SetSize (5.123);
	SetEmptyMass (10000);
	SetCW (3.0, 3.0, .5, 4);
	SetReentryTexture (NULL);
	SetCrossSections (_V(20000,3000,3000));
	SetRotDrag (_V(0.1,0.1,0.1));
	if (GetFlightModel() >= 1) {
		SetPitchMomentScale (5e-5);
		SetBankMomentScale (5e-5);
	}
	SetPMI (_V(80,90,17.5));
	SetTrimScale (0.05);
	SetCameraOffset (_V(0,-.3,3.3));
	SetSurfaceFrictionCoeff (0.3, 0.4);
	SetTouchdownPoints (_V(0,-3.69,4), _V(-2,-3.69,-4), _V(2,-3.69,-4));
	Play_ROVER1 = 0 ;

	// propellant resources
	PROPELLANT_HANDLE hpr;
	hpr = CreatePropellantResource (ROVER_FUELMASS);
	
PARTICLESTREAMSPEC exhaust_main = {
		0, .5, 2, 6, 1.5, 3, 1, 5, PARTICLESTREAMSPEC::DIFFUSE,
		PARTICLESTREAMSPEC::LVL_SQRT, 0, 1,
		PARTICLESTREAMSPEC::ATM_PLOG, 1e-5, 0.1
	};

	SetMeshVisibilityMode (AddMesh (exmesh_tpl = oapiLoadMeshGlobal ("RedRover")), MESHVIS_ALWAYS);
 
	// ***************** thruster definitions *******************
     
     
	th_main = CreateThruster (_V(0,0,-4.5), _V(0,0,1), ROVER_MAXMAINTH, hpr, ROVER_ISP);
	CreateThrusterGroup (&th_main, 1, THGROUP_MAIN);
	
    AddExhaustStream (th_main, _V(-2,-4,3), &exhaust_main);
	AddExhaustStream (th_main, _V(2,-4,3), &exhaust_main);
	AddExhaustStream (th_main, _V(-2,-4,-5), &exhaust_main);
	AddExhaustStream (th_main, _V(2,-4,-5), &exhaust_main);
	
	
	
    

	th_rcs[0] = CreateThruster (_V(-60,0, 3), _V(0,0,-1), (ROVER_MAXRCSTH*1.2), hpr, ROVER_ISP);
	th_rcs[1] = CreateThruster (_V(-60,0,-3), _V(0,0,-1), (ROVER_MAXRCSTH*1.2), hpr, ROVER_ISP);
	th_rcs[2] = CreateThruster (_V( 60,0, 3), _V(0,0,-1), (ROVER_MAXRCSTH*1.2), hpr, ROVER_ISP);
	th_rcs[3] = CreateThruster (_V( 60,0,-3), _V(0,0,-1), (ROVER_MAXRCSTH*1.2), hpr, ROVER_ISP);
	th_rcs[4] = CreateThruster (_V(-60,0, 3), _V(0,0,1), ROVER_MAXRCSTH, hpr, ROVER_ISP);
	th_rcs[5] = CreateThruster (_V(-60,0,-3), _V(0,0,1), ROVER_MAXRCSTH, hpr, ROVER_ISP);
	th_rcs[6] = CreateThruster (_V( 60,0, 3), _V(0,0,1), ROVER_MAXRCSTH, hpr, ROVER_ISP);
	th_rcs[7] = CreateThruster (_V( 60,0,-3), _V(0,0,1), ROVER_MAXRCSTH, hpr, ROVER_ISP);
	
	
	

//Key 4, Port Wheels Reverse//
	th_group[0] = th_rcs[0];
	th_group[1] = th_rcs[1];
	CreateThrusterGroup (th_group, 2, THGROUP_ATT_BANKLEFT);
	
    AddExhaustStream (th_rcs[0], _V(-2,-4,3), &exhaust_main);
	AddExhaustStream (th_rcs[1], _V(-2,-4,-5), &exhaust_main);
	
	

	//Starboard Wheels Reverse//
	th_group[0] = th_rcs[2];
	th_group[1] = th_rcs[3];
	CreateThrusterGroup (th_group, 2, THGROUP_ATT_BANKRIGHT);
	
    AddExhaustStream (th_rcs[2], _V(2,-4,3), &exhaust_main);
	AddExhaustStream (th_rcs[3], _V(2,-4,-5), &exhaust_main);
	

//Port Wheels Forward//
	th_group[0] = th_rcs[4];
	th_group[1] = th_rcs[5];
	CreateThrusterGroup (th_group, 2, THGROUP_ATT_YAWLEFT);
	
    AddExhaustStream (th_rcs[4], _V(-2,-4,3), &exhaust_main);
	AddExhaustStream (th_rcs[5], _V(-2,-4,-5), &exhaust_main);
	

	//Starboard Wheels Forward//
	th_group[0] = th_rcs[6];
	th_group[1] = th_rcs[7];
	CreateThrusterGroup (th_group, 2, THGROUP_ATT_YAWRIGHT);
	
    AddExhaustStream (th_rcs[6], _V(2,-4,3), &exhaust_main);
	AddExhaustStream (th_rcs[7], _V(2,-4,-5), &exhaust_main);
	

	
	
}

// ==============================================================
// API callback interface
// ==============================================================

// --------------------------------------------------------------
// Vessel initialisation
// --------------------------------------------------------------
DLLCLBK VESSEL *ovcInit (OBJHANDLE hvessel, int flightmodel)
{
	return new ROVER (hvessel, flightmodel);
}

// --------------------------------------------------------------
// Vessel cleanup
// --------------------------------------------------------------
DLLCLBK void ovcExit (VESSEL *vessel)
{
	if (vessel) delete (ROVER*)vessel;
}

void ROVER::clbkPostCreation (void)
{
	Sailor=ConnectToOrbiterSoundDLL3(GetHandle());

	ReplaceStockSound3(Sailor,"Sound\\Rho1\\ROVER\\ROVERengines.wav",	REPLACE_MAIN_THRUST);
	ReplaceStockSound3(Sailor,"Sound\\Rho1\\ROVER\\ROVERAMB1.wav",	REPLACE_COCKPIT_AMBIENCE_1);
    ReplaceStockSound3(Sailor,"Sound\\Rho1\\ROVER\\ROVERAMB2.wav",	REPLACE_COCKPIT_AMBIENCE_2);
	ReplaceStockSound3(Sailor,"Sound\\Rho1\\ROVER\\ROVERAMB3.wav",	REPLACE_COCKPIT_AMBIENCE_3);
	ReplaceStockSound3(Sailor,"Sound\\Rho1\\ROVER\\ROVERAMB4.wav",	REPLACE_COCKPIT_AMBIENCE_4);
	//RequestLoadVesselWave3(Sailor,1,"Sound\\Rho1\\ROVER\\Greetings5.wav",DEFAULT);
	SoundOptionOnOff3(Sailor,PLAYCOUNTDOWNWHENTAKEOFF,FALSE);
	SoundOptionOnOff3(Sailor,DISPLAYTIMER,FALSE);
	SoundOptionOnOff3(Sailor,PLAYRADIOATC,FALSE);
	SoundOptionOnOff3(Sailor,PLAYATTITUDETHRUST,FALSE);
	SoundOptionOnOff3(Sailor,PLAYGPWS,FALSE);
	
}


//void ROVER::clbkPreStep (double simt, double simdt, double mjd) 
//{
 ///////////////////////////////////////////////////////////////////
       // position relative to object
  // / //  VESSEL *v = oapiGetFocusInterface();// to determine which vehicle has focus  
     // MinDist1 =  _V(750,750,750); //Distance to trigger sound
     // hbase=oapiGetVesselByName("pip");// name of vessel to detect distance (shows in F3 list)
	   //  if (oapiIsVessel(hbase) == true) { // check if vessel exist
		//  v->GetRelativePos (hbase, RelPos1);//crashes if hvessel isnt in the senario
	  		                                     //
// change numbers to positive
  //     if (RelPos1.x < 0.0){
 //	RelPos1.x = -(RelPos1.x) ;}
  //     if (RelPos1.y < 0.0){
  //  RelPos1.y = -(RelPos1.y) ;}
   //    if (RelPos1.z < 0.0){ 
  //  RelPos1.z = -(RelPos1.z) ;} 
   






   //  if (MinDist1.x > RelPos1.x && MinDist1.y > RelPos1.y && MinDist1.z > RelPos1.z){

	//	 if (Play_ROVER1 < 1){ // play once !
    
		//	 PlayVesselRadioExclusiveWave3(Sailor,1,255); 
		//	 Play_ROVER1 = 1;


	//	 }// play once
	// }

	
		// } }
		 
void ROVER::clbkPostStep (double simt, double simdt, double mjd)
{
	// Animate HATCH
	
if (HATCH_status >= HATCH_RAISING) {
		double da = simdt * HATCH_OPERATING_SPEED;
		if (HATCH_status == HATCH_RAISING) {
			if (HATCH_proc > 0.0) HATCH_proc = max (0.0, HATCH_proc-da);
			else                HATCH_status = HATCH_UP;
		} else {
			if (HATCH_proc < 1.0) HATCH_proc = min (1.0, HATCH_proc+da);
			else                HATCH_status = HATCH_DOWN;
		}
		SetAnimation (anim_HATCH, HATCH_proc);
		}
	
	



if(simt > 5){ 
double da = simdt * RADAR_OPERATING_SPEED;
if (ANTENNA_proc == 1){
ANTENNA_proc = 0;}
ANTENNA_proc = max (0.0, ANTENNA_proc+da);
SetAnimation (anim_ANTENNA, ANTENNA_proc);

}
////////////////////wheel spinning stuff

 double leftwheelspeed (GetThrusterLevel (th_rcs[4]) );
  double airspeed = GetAirspeed();
    
    if (i > 1)i=0;
    if (i < 0)i=1;
    
    if (leftwheelspeed > 0) {
    
    if (i > 1)i=0;
    if (i < 0)i=1;
   
    i=(i+.1);
     
    if (leftwheelspeed ==0) i=0;
	SetAnimation (anim_LEFTWHEELS, i);
	}
	 
    if (ib > 1)ib=0;
    if (ib < 0)ib=1;
    
    if (airspeed > 0) {
    
    if (ib > 1)ib=0;
    if (ib < 0)ib=1;
   
    ib=(ib+.1);
     
    if (airspeed ==0) ib=0;
	SetAnimation (anim_LEFTWHEELS, ib);
	}
	//////////////////////////////////////////////////////////
	 double rightwheelspeed (GetThrusterLevel (th_rcs[6]) );
  
    
    if (i2 > 1)i2=0;
    if (i2 < 0)i2=1;
    
    if (rightwheelspeed > 0) {
    
    if (i2 > 1)i2=0;
    if (i2 < 0)i2=1;
   
    i2=(i2+.1);
     
    if (rightwheelspeed ==0) i2=0;
	SetAnimation (anim_RIGHTWHEELS, i2);
    }
    
     
    if (i2b > 1)i2b=0;
    if (i2b < 0)i2b=1;
    
    if (airspeed > 0) {
    
    if (i2b > 1)i2b=0;
    if (i2b < 0)i2b=1;
   
    i2b=(i2b+.1);
     
    if (airspeed ==0) i2b=0;
	SetAnimation (anim_RIGHTWHEELS, i2b);
	}
    /////////////////////////////////////////////
	 double leftwheelrev (GetThrusterLevel (th_rcs[0]) );
  
    
    if (i3 > 1)i3=0;
    if (i3 < 0)i3=1;
    
    if (leftwheelrev > 0) {
    
    if (i3 > 1)i3=0;
    if (i3 < 0)i3=1;
   
    i3=(i3+.1);
     
    if (leftwheelrev ==0) i3=0;
	SetAnimation (anim_LEFTBACK, i3);
    
	}
	 double rightwheelrev (GetThrusterLevel (th_rcs[2]) );
  
    
    if (i4 > 1)i4=0;
    if (i4 < 0)i4=1;
    
    if (rightwheelrev > 0) {
    
    if (i4 > 1)i4=0;
    if (i4 < 0)i4=1;
   
    i4=(i4+.1);
     
    if (rightwheelrev ==0) i4=0;
	SetAnimation (anim_RIGHTBACK, i4);
    
	}
}
    
int ROVER::clbkConsumeBufferedKey (DWORD key, bool down, char *kstate)
{
	if (!down) return 0; // only process keydown events
		switch (key) {
			
		case OAPI_KEY_1: // deploy/retract HATCH
			RevertHATCH();
			return 1;
		/*case OAPI_KEY_2: // deploy/retract ANTENNA
			RevertANTENNA();
			return 1; */
		
				   	
    return 0;
}
}
void ROVER::clbkLoadStateEx (FILEHANDLE scn, void *vs)
{
	char *line;

	while (oapiReadScenario_nextline (scn, line)) {
		if (!strnicmp (line, "HATCH", 6)) {
			sscanf (line+6, "%d%lf", &HATCH_status, &HATCH_proc);
			
			
			
		} else {
			ParseScenarioLineEx (line, vs);
		}
	}

	
	SetAnimation (anim_HATCH, HATCH_proc);
	SetAnimation (anim_ANTENNA, ANTENNA_proc);
	
	
}
////save to scn file
void ROVER::clbkSaveState (FILEHANDLE scn)
{
	char cbuf[256];
	VESSEL2::clbkSaveState (scn);
	SaveDefaultState (scn);
	

		sprintf (cbuf, "%d %0.4f", HATCH_status, HATCH_proc);
		oapiWriteScenario_string (scn, "HATCH", cbuf);
		
		
	    
		
	}