
#define STRICT
#define ORBITER_MODULE
#define _CRT_SECURE_NO_DEPRECATE 1

#include "W.h"
#include "resource.h"
#include <stdio.h>
#include <fstream>
#include <time.h>



struct {
	HINSTANCE hDLL;
	VESSEL    *vessel;

} g_Param;


BOOL CALLBACK RMS_DlgProc (HWND, UINT, WPARAM, LPARAM);

void CreateVesselList (HWND hDlg)
{
	
	char cbuf[128];
	DWORD i, n = oapiGetVesselCount();
	SendDlgItemMessage (hDlg, IDC_SIGNAL, CB_RESETCONTENT, 0, 0);
	for (i = 0; i < n; i++) {
		OBJHANDLE hVessel = oapiGetVesselByIndex (i);
		if (oapiGetSize(hVessel)==30){
		oapiGetObjectName (hVessel, cbuf, 128);
		SendDlgItemMessage (hDlg, IDC_SIGNAL, CB_ADDSTRING, 0, (LPARAM)cbuf);
		}
	}
	g_Param.vessel = oapiGetFocusInterface();
	SendDlgItemMessage (hDlg, IDC_SIGNAL, CB_SELECTSTRING, 0, (LPARAM)g_Param.vessel->GetName());
}
	
W::W (OBJHANDLE hObj, int fmodel)
: VESSEL2 (hObj, fmodel)
{
	
	reset_sat       = false;
	vis             = NULL;

	

	DefineAnimations ();
	center_arm		= false;
	arm_moved       = false;
	rms_attach      = NULL;
	sat_attach      = NULL;
	rot_thrust		= false;
	lin_thrust		= false;
	range			= false;

	hWaldoMesh = oapiLoadMeshGlobal ("55Cancri//Waldo");

	arm_sp = 0.0;
	arm_ep = 0.0;
	arm_cp = 0.35;
	arm_cgu = 0.15;
	arm_cgl = 0.15;
	arm_at = 0.0;
	arm_tip[0] = _V(0,0.883,0.527);
	arm_tip[1] = _V(0,0.883,1.527);
	arm_tip[2] = _V(0,1.883,0.527);
	
}

W::~W ()
{
	int i;
	for (i = 0; i < 6; i++) delete rms_anim[i];
}
void W::DefineAnimations (void)
{

ANIMATIONCOMPONENT_HANDLE parent,parentX;

	static UINT RMSShoulderPitchGrp[6] = {22,23,31,32,33,34};
	rms_anim[0] = new MGROUP_ROTATE (0, RMSShoulderPitchGrp, 6,
		_V(0.9,0.657,0),_V(1,0,0), (float) (-161*RAD));
	anim_arm_sp = CreateAnimation (0);
	parent = AddAnimationComponent (anim_arm_sp, 0, 1, rms_anim[0]);

	static UINT RMSElbowPitchGrp[2] = {29,30};
	rms_anim[1] = new MGROUP_ROTATE (0, RMSElbowPitchGrp, 2,
		_V(0.9,-1.211,0.277),_V(1,0,0), (float)(250*RAD));
	anim_arm_ep = CreateAnimation (0);
	parent = AddAnimationComponent (anim_arm_ep, 0, 1, rms_anim[1],parent);

	static UINT RMSClawPitchGrp[2] = {37,38};
	rms_anim[2] = new MGROUP_ROTATE (0, RMSClawPitchGrp, 2,
		_V(0.9,0.65,0.331),_V(1,0,0), (float)(-210*RAD));
	anim_arm_cp = CreateAnimation (0.35);
	parentX = AddAnimationComponent (anim_arm_cp, 0, 1, rms_anim[2],parent);

	static UINT RMSClawGrabuGrp[2] = {35,36};
	rms_anim[3] = new MGROUP_ROTATE (0, RMSClawGrabuGrp, 2,
		_V(0.9,0.67,0.364),_V(-1,0,0), (float)(47*RAD));
	anim_arm_cgu = CreateAnimation (0.13);
	parent = AddAnimationComponent (anim_arm_cgu, 0, 1, rms_anim[3],parentX);

	static UINT RMSClawGrablGrp[2] = {27,28};
	rms_anim[4] = new MGROUP_ROTATE (0, RMSClawGrablGrp, 2,
		_V(0.9,0.67,0.364),_V(1,0,0), (float)(47*RAD));
	anim_arm_cgl = CreateAnimation (0.13);
	parent = AddAnimationComponent (anim_arm_cgl, 0, 1, rms_anim[4],parentX);

	rms_anim[5] = new MGROUP_ROTATE (LOCALVERTEXLIST, MAKEGROUPARRAY(arm_tip), 3,
		_V(0,0.883,0.527), _V(0,0,1), (float)(894*RAD)); // -447 .. +447
	anim_arm_at = CreateAnimation (0);
	hAC_arm = AddAnimationComponent (anim_arm_at, 0, 1, rms_anim[5], parentX);


}
void W::AddVisual (const VECTOR3 &ofs)
{
	orbiter_ofs = ofs;

	UINT meshidx;
	meshidx = AddMesh (hWaldoMesh, &ofs);
	SetMeshVisibilityMode (meshidx, MESHVIS_ALWAYS);


	SetCameraOffset (_V(0,ofs.y+1.26,ofs.z-0.5));
	
	if (!rms_attach){ rms_attach = CreateAttachment (false, ofs+arm_tip[0], _V(0,1,0), _V(0,0,1), "G", true);
	sat_attach = CreateAttachment (true, ofs+arm_tip[0], _V(0,1,0), _V(0,0,1), "G", true);
	}
	else {SetAttachmentParams (rms_attach, ofs+arm_tip[0], _V(0,1,0), _V(0,0,1));
	SetAttachmentParams (sat_attach, ofs+arm_tip[0], _V(0,1,0), _V(0,0,1));
	}

}

void W::UpdateMesh ()
{
	// update animation states
	SetAnimationArm (anim_arm_sp, arm_sp);
	SetAnimationArm (anim_arm_ep, arm_ep);
	SetAnimationArm (anim_arm_cp, arm_cp);
	SetAnimationArm (anim_arm_cgu, arm_cgu);
	SetAnimationArm (anim_arm_cgl, arm_cgl);
	SetAnimationArm (anim_arm_at, arm_at);
	
}


void W::SetAnimationArm (UINT anim, double state)
{
	SetAnimation (anim, state);
	arm_moved = true;
}
void W::ToggleGrapple()
{
	HWND hDlg;
	OBJHANDLE hV = GetAttachmentStatus (rms_attach);

		VECTOR3 gpos, grms, pos, dir, rot;
		Local2Global (orbiter_ofs+arm_tip[0], grms);  // global position of RMS tip
		
		// Search the complete vessel list for a grappling candidate.
		// Not very scalable ...
		for (DWORD i = 0; i < oapiGetVesselCount(); i++) {
			OBJHANDLE hV = oapiGetVesselByIndex (i);
			if (hV == GetHandle()) continue; // we don't want to grapple ourselves ...
			oapiGetGlobalPos (hV, &gpos);
			if (dist (gpos, grms) < oapiGetSize (hV)) { // in range
				VESSEL *v = oapiGetVesselInterface (hV);
				DWORD nAttach = v->AttachmentCount (true);
				for (DWORD j = 0; j < nAttach; j++) { // now scan all attachment points of the candidate
					ATTACHMENTHANDLE hAtt = v->GetAttachmentHandle (true, j);
					const char *id = v->GetAttachmentId (hAtt);
					if (strncmp (id, "GS", 2)) continue; // attachment point not compatible
					v->GetAttachmentParams (hAtt, pos, dir, rot);
					v->Local2Global (pos, gpos);
					if (dist (gpos, grms) < 0.25) { // found one!
						// check whether satellite is currently clamped into payload bay
						AttachChild (hV, rms_attach, hAtt);
						if (hDlg = oapiFindDialog (g_Param.hDLL, IDD_RMS)) {
							EnableWindow (GetDlgItem (hDlg, IDC_LINK), TRUE);
							EnableWindow (GetDlgItem (hDlg, IDC_LOAD), TRUE);
							EnableWindow (GetDlgItem (hDlg, IDC_LOADA), TRUE);
							EnableWindow (GetDlgItem (hDlg, IDC_LOADB), TRUE);
							EnableWindow (GetDlgItem (hDlg, IDC_LOADC), TRUE);
							SetWindowText (GetDlgItem (hDlg, IDC_GRAPPLELOCK), "-LOCKED-");
							OBJHANDLE hG=GetAttachmentStatus(rms_attach);
						if (hG){
							SetWindowText (GetDlgItem (hDlg, IDC_GRAPPLEGOOD), "-LOCKED-");
							}
						}
					return;
					}
				}
			}
		}
}

void W::CreateLink()
{
	VECTOR3 gpos, grms, pos, dir, rot;
		Local2Global (orbiter_ofs+arm_tip[0], grms);  // global position of RMS tip
		
		// Search the complete vessel list for a grappling candidate.
		// Not very scalable ...
		for (DWORD i = 0; i < oapiGetVesselCount(); i++) {
			OBJHANDLE hV = oapiGetVesselByIndex (i);
			if (hV == GetHandle()) continue; // we don't want to grapple ourselves ...
			oapiGetGlobalPos (hV, &gpos);
			if (dist (gpos, grms) < oapiGetSize (hV)) { // in range
				VESSEL *v = oapiGetVesselInterface (hV);
				DWORD nAttach = v->AttachmentCount (true);
				for (DWORD j = 0; j < nAttach; j++) { // now scan all attachment points of the candidate
					ATTACHMENTHANDLE hAtt = v->GetAttachmentHandle (true, j);
					const char *id = v->GetAttachmentId (hAtt);
					if (strncmp (id, "GS", 2)) continue; // attachment point not compatible
					v->GetAttachmentParams (hAtt, pos, dir, rot);
					v->Local2Global (pos, gpos);
					if (dist (gpos, grms) < 0.25) { // found one!
					oapiGetVesselInterface(hV);
					SetThrusterGroupLevel(THGROUP_MAIN,0);
					SetThrusterGroupLevel(THGROUP_HOVER,0);
					SetThrusterGroupLevel(THGROUP_RETRO,0);
					SetThrusterGroupLevel(THGROUP_ATT_PITCHUP,0);
					SetThrusterGroupLevel(THGROUP_ATT_PITCHDOWN,0);
					SetThrusterGroupLevel(THGROUP_ATT_YAWLEFT,0);
					SetThrusterGroupLevel(THGROUP_ATT_YAWRIGHT,0);
					SetThrusterGroupLevel(THGROUP_ATT_BANKLEFT,0);
					SetThrusterGroupLevel(THGROUP_ATT_BANKRIGHT,0);
					DeactivateNavmode(NAVMODE_HOLDALT);
					DeactivateNavmode(NAVMODE_HLEVEL);
		v->SetSize (6.05);
					}
				}
		return;
		}
	}
}

void W::KillLink()
{
	VECTOR3 gpos, grms, pos, dir, rot;
		Local2Global (orbiter_ofs+arm_tip[0], grms);  // global position of RMS tip
		
		// Search the complete vessel list for a grappling candidate.
		// Not very scalable ...
		for (DWORD i = 0; i < oapiGetVesselCount(); i++) {
			OBJHANDLE hV = oapiGetVesselByIndex (i);
			if (hV == GetHandle()) continue; // we don't want to grapple ourselves ...
			oapiGetGlobalPos (hV, &gpos);
			if (dist (gpos, grms) < oapiGetSize (hV)) { // in range
				VESSEL *v = oapiGetVesselInterface (hV);
				DWORD nAttach = v->AttachmentCount (true);
				for (DWORD j = 0; j < nAttach; j++) { // now scan all attachment points of the candidate
					ATTACHMENTHANDLE hAtt = v->GetAttachmentHandle (true, j);
					const char *id = v->GetAttachmentId (hAtt);
					if (strncmp (id, "GS", 2)) continue; // attachment point not compatible
					v->GetAttachmentParams (hAtt, pos, dir, rot);
					v->Local2Global (pos, gpos);
					if (dist (gpos, grms) < 0.25) { // found one!
		oapiGetVesselInterface(hV);
		v->SetSize (6.06);
					}
				}
		return;
		}
	}
}

void W::RemoteThrust()
{
	VECTOR3 tempC;
	

		
		tempC.x = GetManualControlLevel(THGROUP_ATT_PITCHUP, MANCTRL_ANYDEVICE, MANCTRL_ANYMODE) - GetManualControlLevel(THGROUP_ATT_PITCHDOWN, MANCTRL_ANYDEVICE, MANCTRL_ANYMODE);
		tempC.y = GetManualControlLevel(THGROUP_ATT_YAWLEFT, MANCTRL_ANYDEVICE, MANCTRL_ANYMODE) - GetManualControlLevel(THGROUP_ATT_YAWRIGHT, MANCTRL_ANYDEVICE, MANCTRL_ANYMODE);
		tempC.z = GetManualControlLevel(THGROUP_ATT_BANKRIGHT, MANCTRL_ANYDEVICE, MANCTRL_ANYMODE) - GetManualControlLevel(THGROUP_ATT_BANKLEFT, MANCTRL_ANYDEVICE, MANCTRL_ANYMODE);
		
	VECTOR3 gpos, grms,pos,dir, rot;
		Local2Global (orbiter_ofs+arm_tip[0], grms);  // global position of RMS tip
		
		// Search the complete vessel list for a grappling candidate.
		// Not very scalable ...
		for (DWORD i = 0; i < oapiGetVesselCount(); i++) {
			OBJHANDLE hV = oapiGetVesselByIndex (i);
			if (hV == GetHandle()) continue; // we don't want to grapple ourselves ...
			oapiGetGlobalPos (hV, &gpos);
			if (dist (gpos, grms) < oapiGetSize (hV)) { 
				VESSEL *v = oapiGetVesselInterface (hV);
				DWORD nAttach = v->AttachmentCount (true);
				for (DWORD j = 0; j < nAttach; j++) { // now scan all attachment points of the candidate
					ATTACHMENTHANDLE hAtt = v->GetAttachmentHandle (true, j);
					const char *id = v->GetAttachmentId (hAtt);
					if (strncmp (id, "GS", 2)) continue; // attachment point not compatible
					v->GetAttachmentParams (hAtt, pos, dir, rot);
					v->Local2Global (pos, gpos);
					if (dist (gpos, grms) < 0.5) { 
		v->SetAttitudeRotLevel(tempC);
		return;
					}
				}
			}
		}
}
void W::RemoteThrustLin()
{
	VECTOR3 tempC;
	
	
		
		tempC.y = GetManualControlLevel(THGROUP_ATT_PITCHUP, MANCTRL_ANYDEVICE, MANCTRL_ANYMODE) - GetManualControlLevel(THGROUP_ATT_PITCHDOWN, MANCTRL_ANYDEVICE, MANCTRL_ANYMODE);
		tempC.x = GetManualControlLevel(THGROUP_ATT_YAWRIGHT, MANCTRL_ANYDEVICE, MANCTRL_ANYMODE) - GetManualControlLevel(THGROUP_ATT_YAWLEFT, MANCTRL_ANYDEVICE, MANCTRL_ANYMODE);
		tempC.z = GetManualControlLevel(THGROUP_ATT_BANKRIGHT, MANCTRL_ANYDEVICE, MANCTRL_ANYMODE) - GetManualControlLevel(THGROUP_ATT_BANKLEFT, MANCTRL_ANYDEVICE, MANCTRL_ANYMODE);
		
		VECTOR3 gpos, grms,pos,dir, rot;
		Local2Global (orbiter_ofs+arm_tip[0], grms);  // global position of RMS tip
		
		// Search the complete vessel list for a grappling candidate.
		// Not very scalable ...
		for (DWORD i = 0; i < oapiGetVesselCount(); i++) {
			OBJHANDLE hV = oapiGetVesselByIndex (i);
			if (hV == GetHandle()) continue; // we don't want to grapple ourselves ...
			oapiGetGlobalPos (hV, &gpos);
			if (dist (gpos, grms) < oapiGetSize (hV)) { 
				VESSEL *v = oapiGetVesselInterface (hV);
				DWORD nAttach = v->AttachmentCount (true);
				for (DWORD j = 0; j < nAttach; j++) { // now scan all attachment points of the candidate
					ATTACHMENTHANDLE hAtt = v->GetAttachmentHandle (true, j);
					const char *id = v->GetAttachmentId (hAtt);
					if (strncmp (id, "GS", 2)) continue; // attachment point not compatible
					v->GetAttachmentParams (hAtt, pos, dir, rot);
					v->Local2Global (pos, gpos);
					if (dist (gpos, grms) < 0.5) { 
		v->SetAttitudeLinLevel(tempC);
		return;
				}
			}
		}
	}
}
void W::RemoteThrustKillRot()
{
			
		VECTOR3 gpos, grms,pos,dir, rot;
		Local2Global (orbiter_ofs+arm_tip[0], grms);  // global position of RMS tip
		
		// Search the complete vessel list for a grappling candidate.
		// Not very scalable ...
		for (DWORD i = 0; i < oapiGetVesselCount(); i++) {
			OBJHANDLE hV = oapiGetVesselByIndex (i);
			if (hV == GetHandle()) continue; // we don't want to grapple ourselves ...
			oapiGetGlobalPos (hV, &gpos);
			if (dist (gpos, grms) < oapiGetSize (hV)) { 
				VESSEL *v = oapiGetVesselInterface (hV);
				DWORD nAttach = v->AttachmentCount (true);
				for (DWORD j = 0; j < nAttach; j++) { // now scan all attachment points of the candidate
					ATTACHMENTHANDLE hAtt = v->GetAttachmentHandle (true, j);
					const char *id = v->GetAttachmentId (hAtt);
					if (strncmp (id, "GS", 2)) continue; // attachment point not compatible
					v->GetAttachmentParams (hAtt, pos, dir, rot);
					v->Local2Global (pos, gpos);
					if (dist (gpos, grms) < 0.5) { 
		v->ActivateNavmode(NAVMODE_KILLROT);
		return;
				}
			}
		}
	}
}
void W::RemoteThrustHoldAlt()
{
		VECTOR3 gpos, grms,pos,dir, rot;
		Local2Global (orbiter_ofs+arm_tip[0], grms);  // global position of RMS tip
		
		// Search the complete vessel list for a grappling candidate.
		// Not very scalable ...
		for (DWORD i = 0; i < oapiGetVesselCount(); i++) {
			OBJHANDLE hV = oapiGetVesselByIndex (i);
			if (hV == GetHandle()) continue; // we don't want to grapple ourselves ...
			oapiGetGlobalPos (hV, &gpos);
			if (dist (gpos, grms) < oapiGetSize (hV)) { 
				VESSEL *v = oapiGetVesselInterface (hV);
				DWORD nAttach = v->AttachmentCount (true);
				for (DWORD j = 0; j < nAttach; j++) { // now scan all attachment points of the candidate
					ATTACHMENTHANDLE hAtt = v->GetAttachmentHandle (true, j);
					const char *id = v->GetAttachmentId (hAtt);
					if (strncmp (id, "GS", 2)) continue; // attachment point not compatible
					v->GetAttachmentParams (hAtt, pos, dir, rot);
					v->Local2Global (pos, gpos);
					if (dist (gpos, grms) < 0.5) { 
		v->ActivateNavmode(NAVMODE_HOLDALT);
		return;
				}
			}
		}
	}
}
void W::RemoteThrustHLevel()
{
			
		VECTOR3 gpos, grms,pos,dir, rot;
		Local2Global (orbiter_ofs+arm_tip[0], grms);  // global position of RMS tip
		
		// Search the complete vessel list for a grappling candidate.
		// Not very scalable ...
		for (DWORD i = 0; i < oapiGetVesselCount(); i++) {
			OBJHANDLE hV = oapiGetVesselByIndex (i);
			if (hV == GetHandle()) continue; // we don't want to grapple ourselves ...
			oapiGetGlobalPos (hV, &gpos);
			if (dist (gpos, grms) < oapiGetSize (hV)) { 
				VESSEL *v = oapiGetVesselInterface (hV);
				DWORD nAttach = v->AttachmentCount (true);
				for (DWORD j = 0; j < nAttach; j++) { // now scan all attachment points of the candidate
					ATTACHMENTHANDLE hAtt = v->GetAttachmentHandle (true, j);
					const char *id = v->GetAttachmentId (hAtt);
					if (strncmp (id, "GS", 2)) continue; // attachment point not compatible
					v->GetAttachmentParams (hAtt, pos, dir, rot);
					v->Local2Global (pos, gpos);
					if (dist (gpos, grms) < 0.5) { 
				v->ActivateNavmode(NAVMODE_HLEVEL);
			return;
				}
			}
		}
	}
}
void W::RemoteThrustOff()
{
			
		VECTOR3 gpos, grms,pos,dir, rot;
		Local2Global (orbiter_ofs+arm_tip[0], grms);  // global position of RMS tip
		
		// Search the complete vessel list for a grappling candidate.
		// Not very scalable ...
		for (DWORD i = 0; i < oapiGetVesselCount(); i++) {
			OBJHANDLE hV = oapiGetVesselByIndex (i);
			if (hV == GetHandle()) continue; // we don't want to grapple ourselves ...
			oapiGetGlobalPos (hV, &gpos);
			if (dist (gpos, grms) < oapiGetSize (hV)) { 
				VESSEL *v = oapiGetVesselInterface (hV);
				DWORD nAttach = v->AttachmentCount (true);
				for (DWORD j = 0; j < nAttach; j++) { // now scan all attachment points of the candidate
					ATTACHMENTHANDLE hAtt = v->GetAttachmentHandle (true, j);
					const char *id = v->GetAttachmentId (hAtt);
					if (strncmp (id, "GS", 2)) continue; // attachment point not compatible
					v->GetAttachmentParams (hAtt, pos, dir, rot);
					v->Local2Global (pos, gpos);
					if (dist (gpos, grms) < 0.5) { 
					v->SetThrusterGroupLevel(THGROUP_MAIN,0);
					v->SetThrusterGroupLevel(THGROUP_HOVER,0);
					v->SetThrusterGroupLevel(THGROUP_RETRO,0);
					v->SetThrusterGroupLevel(THGROUP_ATT_PITCHUP,0);
					v->SetThrusterGroupLevel(THGROUP_ATT_PITCHDOWN,0);
					v->SetThrusterGroupLevel(THGROUP_ATT_YAWLEFT,0);
					v->SetThrusterGroupLevel(THGROUP_ATT_YAWRIGHT,0);
					v->SetThrusterGroupLevel(THGROUP_ATT_BANKLEFT,0);
					v->SetThrusterGroupLevel(THGROUP_ATT_BANKRIGHT,0);
					v->DeactivateNavmode(NAVMODE_HOLDALT);
					v->DeactivateNavmode(NAVMODE_HLEVEL);
				return;
				}
			}
		}
	}
}

void W::clbkSetClassCaps (FILEHANDLE cfg)
{
	THRUSTER_HANDLE th_main, th_retro, th_hover,th_rcs[27], th_group[4];

	SetSize (3);
	SetEmptyMass (100);
	SetCW (1, 1, 1, 1);
	SetCrossSections (_V(1,3,1));
	SetRotDrag (_V(0.6,0.6,0.35));
	if (GetFlightModel() >= 1) {
		SetPitchMomentScale (5e-4);
		SetBankMomentScale (5e-4);
	}
	SetTrimScale (0.05);
	SetCameraOffset (_V(0,0.0,0));
	SetDockParams (_V(0,0,-0.952), _V(0,0,-1), _V(0,1,0));
	SetTouchdownPoints (_V(0,-2.47,1.2), _V(-1.53,-2.47,-4.83), _V(1.53,-2.47,-4.83));
	SetSurfaceFrictionCoeff (0.05, 0.4);
	// propellant resources
	PROPELLANT_HANDLE hpr;
	hpr = CreatePropellantResource (W_FUELMASS);
	

	// ***************** thruster definitions *******************
     
	
	
	th_main = CreateThruster (_V(0,0,-1), _V(0,0,1), W_MAXMAINTH, hpr, W_ISP);
	th_hover = CreateThruster (_V(0,-1,0), _V(0,1,0), W_MAXMAINTH, hpr, W_ISP);
	th_retro = CreateThruster (_V(0,0,1), _V(0,0,-1), W_MAXRETROTH, hpr, W_ISP);
	CreateThrusterGroup (&th_main, 1, THGROUP_MAIN);
	CreateThrusterGroup (&th_hover, 1, THGROUP_HOVER);
	CreateThrusterGroup (&th_retro, 1, THGROUP_RETRO);
	AddExhaust (th_main, .2, .05, _V(0,1.875,-.181), _V(0,0,-1));
	AddExhaust (th_main, .2, .05, _V(0,-1.812,-.181), _V(0,0,-1));
    AddExhaust (th_retro, .2, .05, _V(0,1.875,.181), _V(0,0,1));
    AddExhaust (th_retro, .2, .05, _V(0,-1.822,.181), _V(0,0,1));
	AddExhaust (th_hover, .2, .05, _V(0,-2.013,-.01), _V(0,-1,0));


	th_rcs[ 0] = CreateThruster (_V( 1,0, 3), _V(0,1,0), W_MAXRCSTH, hpr, W_ISP);
	th_rcs[ 1] = CreateThruster (_V( 1,0, 3), _V(0,-1,0), W_MAXRCSTH, hpr, W_ISP);
	th_rcs[ 2] = CreateThruster (_V(-1,0, 3), _V(0,1,0), W_MAXRCSTH, hpr, W_ISP);
	th_rcs[ 3] = CreateThruster (_V(-1,0, 3), _V(0,-1,0), W_MAXRCSTH, hpr, W_ISP);
	th_rcs[ 4] = CreateThruster (_V( 1,0,-3), _V(0,1,0), W_MAXRCSTH, hpr, W_ISP);
	th_rcs[ 5] = CreateThruster (_V( 1,0,-3), _V(0,-1,0), W_MAXRCSTH, hpr, W_ISP);
	th_rcs[ 6] = CreateThruster (_V(-1,0,-3), _V(0,1,0), W_MAXRCSTH, hpr, W_ISP);
	th_rcs[ 7] = CreateThruster (_V(-1,0,-3), _V(0,-1,0), W_MAXRCSTH, hpr, W_ISP);
	th_rcs[ 8] = CreateThruster (_V( 1,0, 3), _V(-1,0,0), W_MAXRCSTH, hpr, W_ISP);
	th_rcs[ 9] = CreateThruster (_V(-1,0, 3), _V(1,0,0), W_MAXRCSTH, hpr, W_ISP);
	th_rcs[10] = CreateThruster (_V( 1,0,-3), _V(-1,0,0), W_MAXRCSTH, hpr, W_ISP);
	th_rcs[11] = CreateThruster (_V(-1,0,-3), _V(1,0,0), W_MAXRCSTH, hpr, W_ISP);
	th_rcs[12] = CreateThruster (_V( 0,0,-3), _V(0,0,1), W_MAXRCSTH, hpr, W_ISP);//lwr rear
	th_rcs[13] = CreateThruster (_V( 0,0, 3), _V(0,0,-1), W_MAXRCSTH, hpr, W_ISP);//upr frt
	th_rcs[14] = CreateThruster (_V( 0,0,-3), _V(0,0,-1), W_MAXRCSTH, hpr, W_ISP);//lwr frt
	th_rcs[15] = CreateThruster (_V( 0,0, 3), _V(0,0,1), W_MAXRCSTH, hpr, W_ISP);//upr rear
	th_rcs[16] = CreateThruster (_V(-1,0, 3), _V(0,1,0), W_MAXRCSTH, hpr, W_ISP);
	th_rcs[17] = CreateThruster (_V(-1,0,-3), _V(0,1,0), W_MAXRCSTH, hpr, W_ISP);
	th_rcs[18] = CreateThruster (_V(-1,0, 3), _V(0,-1,0), W_MAXRCSTH, hpr, W_ISP);
	th_rcs[19] = CreateThruster (_V(-1,0,-3), _V(0,-1,0), W_MAXRCSTH, hpr, W_ISP);
	th_rcs[20] = CreateThruster (_V( 1,0, 3), _V(0,1,0), W_MAXRCSTH, hpr, W_ISP);
	th_rcs[21] = CreateThruster (_V( 1,0,-3), _V(0,1,0), W_MAXRCSTH, hpr, W_ISP);
	th_rcs[22] = CreateThruster (_V( 1,0, 3), _V(0,1,0), W_MAXRCSTH, hpr, W_ISP);
	th_rcs[23] = CreateThruster (_V(-1,0, 3), _V(0,1,0), W_MAXRCSTH, hpr, W_ISP);
	th_rcs[24] = CreateThruster (_V( 1,0,-3), _V(0,1,0), W_MAXRCSTH, hpr, W_ISP);
	th_rcs[25] = CreateThruster (_V(-1,0,-3), _V(0,1,0), W_MAXRCSTH, hpr, W_ISP);
	th_rcs[26] = CreateThruster (_V( 1,0, 3), _V(0,-1,0), W_MAXRCSTH, hpr, W_ISP);

    th_group[0] = th_rcs[0];
	th_group[1] = th_rcs[2];
	th_group[2] = th_rcs[5];
	th_group[3] = th_rcs[7];
	CreateThrusterGroup (th_group, 4, THGROUP_ATT_PITCHUP);

	th_group[0] = th_rcs[1];
	th_group[1] = th_rcs[3];
	th_group[2] = th_rcs[4];
	th_group[3] = th_rcs[6];
	CreateThrusterGroup (th_group, 4, THGROUP_ATT_PITCHDOWN);
AddExhaust (th_rcs[0], .2, .05, _V(0,-1.812,-.181), _V(0,0,-1));
AddExhaust (th_rcs[2], .2, .05, _V(0,1.875,.181), _V(0,0,1));
AddExhaust (th_rcs[4], .2, .05, _V(0,-1.812,.181), _V(0,0,1));
AddExhaust (th_rcs[6], .2, .05, _V(0,1.875,-.181), _V(0,0,-1));

	th_group[0] = th_rcs[20];
	th_group[1] = th_rcs[21];
	th_group[2] = th_rcs[18];
	th_group[3] = th_rcs[19];
	CreateThrusterGroup (th_group, 4, THGROUP_ATT_BANKLEFT);
	AddExhaust (th_rcs[18], .2, .05, _V(.195,1.865,0), _V(1,0,0));
	AddExhaust (th_rcs[19], .2, .05, _V(-.195,-1.822,0), _V(-1,0,0));

	th_group[0] = th_rcs[1];
	th_group[1] = th_rcs[5];
	th_group[2] = th_rcs[16];
	th_group[3] = th_rcs[17];
	CreateThrusterGroup (th_group, 4, THGROUP_ATT_BANKRIGHT);
AddExhaust (th_rcs[16], .2, .05, _V(-.195,1.865,0), _V(-1,0,0));
AddExhaust (th_rcs[17], .2, .05, _V(.195,-1.822,0), _V(1,0,0));

	th_group[0] = th_rcs[22];
	th_group[1] = th_rcs[23];
	th_group[2] = th_rcs[24];
	th_group[3] = th_rcs[25];
	CreateThrusterGroup (th_group, 4, THGROUP_ATT_UP);
	AddExhaust (th_rcs[25], .2, .05, _V(0,-2.013,-.01), _V(0,-1,0));

	th_group[0] = th_rcs[26];
	th_group[1] = th_rcs[5];
	th_group[2] = th_rcs[3];
	th_group[3] = th_rcs[7];
	CreateThrusterGroup (th_group, 4, THGROUP_ATT_DOWN);
	AddExhaust (th_rcs[26], .2, .05, _V(0,2.065,-.01), _V(0,1,0));


	th_group[0] = th_rcs[8];
	th_group[1] = th_rcs[11];
	CreateThrusterGroup (th_group, 2, THGROUP_ATT_YAWLEFT);

	th_group[0] = th_rcs[9];
	th_group[1] = th_rcs[10];
	CreateThrusterGroup (th_group, 2, THGROUP_ATT_YAWRIGHT);

	th_group[0] = th_rcs[8];
	th_group[1] = th_rcs[10];
	CreateThrusterGroup (th_group, 2, THGROUP_ATT_LEFT);
	AddExhaust (th_rcs[8], .2, .05, _V(.195,-1.822,0), _V(1,0,0));
	AddExhaust (th_rcs[10], .2, .05, _V(.195,1.865,0), _V(1,0,0));


	th_group[0] = th_rcs[9];
	th_group[1] = th_rcs[11];
	CreateThrusterGroup (th_group, 2, THGROUP_ATT_RIGHT);
	AddExhaust (th_rcs[9], .2, .05, _V(-.195,-1.822,0), _V(-1,0,0));
	AddExhaust (th_rcs[11], .2, .05, _V(-.195,1.865,0), _V(-1,0,0));


	th_group[0] = th_rcs[12];
	th_group[1] = th_rcs[15];
	CreateThrusterGroup (th_group, 2, THGROUP_ATT_FORWARD);
	th_group[0] = th_rcs[13];
	th_group[1] = th_rcs[14];
	CreateThrusterGroup (th_group, 2, THGROUP_ATT_BACK);

AddExhaust (th_rcs[12], .2, .05, _V(0,-1.812,-.181), _V(0,0,-1));
AddExhaust (th_rcs[13], .2, .05, _V(0,1.875,.181), _V(0,0,1));
AddExhaust (th_rcs[14], .2, .05, _V(0,-1.812,.181), _V(0,0,1));
AddExhaust (th_rcs[15], .2, .05, _V(0,1.875,-.181), _V(0,0,-1));


ClearMeshes();
  ///////////////////////////////////STOP///////////////////////////////////////////////////////////
AddVisual (OFS_ZERO);
	
}
// ==============================================================
// API callback interface
// ==============================================================


void W::clbkPostStep (double simt, double simdt, double mjd)
{
	

	SetAnimationArm (anim_arm_sp, arm_sp);
	SetAnimationArm (anim_arm_ep, arm_ep);
	SetAnimationArm (anim_arm_cp, arm_cp);
	SetAnimationArm (anim_arm_cgu, arm_cgu);
	SetAnimationArm (anim_arm_cgl, arm_cgl);
	SetAnimationArm (anim_arm_at, arm_at);


	if (center_arm) {
		double t0 = oapiGetSimTime();
		double dt = t0 - center_arm_t;       // time step
		double da = ARM_OPERATING_SPEED*dt;  // total rotation angle

		// work from the wrist down to the shoulder
		if (da && arm_at) {             // zero elbow pitch
			if (da >= arm_at)           // finished
				arm_at = 0.0, da -= arm_at;
			else
				arm_at -= da, da = 0;
			SetAnimationArm (anim_arm_at, arm_at);
		}
		if (da && (arm_cgl != 0.15)) {    // zero wrist yaw
			if (da >= fabs(arm_cgl-0.15)) // finished
				arm_cgl = 0.15, da -= fabs(arm_cgl-0.15);
			else
				arm_cgl -= (arm_cgl > 0.15 ? da:-da), da = 0;
			SetAnimationArm (anim_arm_cgl, arm_cgl);
		}
		if (da && (arm_cgu != 0.15)) {    // zero wrist yaw
			if (da >= fabs(arm_cgu-0.15)) // finished
				arm_cgu = 0.15, da -= fabs(arm_cgu-0.15);
			else
				arm_cgu -= (arm_cgu > 0.15 ? da:-da), da = 0;
			SetAnimationArm (anim_arm_cgu, arm_cgu);
		}
		if (da && (arm_cp != 0.35)) {    // zero wrist yaw
			if (da >= fabs(arm_cp-0.35)) // finished
				arm_cp = 0.35, da -= fabs(arm_cp-0.35);
			else
				arm_cp -= (arm_cp > 0.35 ? da:-da), da = 0;
			SetAnimationArm (anim_arm_cp, arm_cp);
		}
		if (da && arm_ep) {             // zero elbow pitch
			if (da >= arm_ep)           // finished
				arm_ep = 0.0, da -= arm_ep;
			else
				arm_ep -= da, da = 0;
			SetAnimationArm (anim_arm_ep, arm_ep);
		}
		if (da && arm_sp) {             // zero shoulder pitch
			if (da >= arm_sp)           // finished
				arm_sp = 0.0, da -= arm_sp;
			else
				arm_sp -= da, da = 0;
			SetAnimationArm (anim_arm_sp, arm_sp);
		}
		center_arm_t = t0;
		if (da) {
			center_arm = false; // finished stowing
		}
	}
	
if (arm_moved) {
		SetAttachmentParams (rms_attach, orbiter_ofs+arm_tip[0], arm_tip[2]-arm_tip[0], arm_tip[1]-arm_tip[0]);
		SetAttachmentParams (sat_attach, orbiter_ofs+arm_tip[0], arm_tip[2]-arm_tip[0], arm_tip[1]-arm_tip[0]);
		arm_moved = false;
	}

if (arm_cgl>0.76){
	DetachChild (rms_attach, 0.01);
	HWND hDlg = oapiFindDialog (g_Param.hDLL, IDD_RMS);
	EnableWindow (GetDlgItem (hDlg, IDC_STOW), TRUE);
	EnableWindow (GetDlgItem (hDlg, IDC_LINK), FALSE);
	SetWindowText (GetDlgItem (hDlg, IDC_GRAPPLELOCK), "--------------------");
}
OBJHANDLE hV=GetAttachmentStatus(sat_attach);
if ((hV) && (rot_thrust == true)){
RemoteThrust();

}
if ((hV) && (lin_thrust == true)){
RemoteThrustLin();

}
//sprintf(oapiDebugString(), "Claw %f",test);

OBJHANDLE hS=GetAttachmentStatus(sat_attach);
		VECTOR3 gpos, grms,pos,dir, rot;
		Local2Global (orbiter_ofs+arm_tip[0], grms);  // global position of RMS tip
		
		// Search the complete vessel list for a grappling candidate.
		// Not very scalable ...
		for (DWORD i = 0; i < oapiGetVesselCount(); i++) {
			OBJHANDLE hV = oapiGetVesselByIndex (i);
			if (hV == GetHandle()) continue; // we don't want to grapple ourselves ...
			oapiGetGlobalPos (hV, &gpos);
			if (dist (gpos, grms) < oapiGetSize (hV)) { 
				VESSEL *v = oapiGetVesselInterface (hV);
				DWORD nAttach = v->AttachmentCount (true);
				for (DWORD j = 0; j < nAttach; j++) { // now scan all attachment points of the candidate
					ATTACHMENTHANDLE hAtt = v->GetAttachmentHandle (true, j);
					const char *id = v->GetAttachmentId (hAtt);
					if (strncmp (id, "GS", 2)) continue; // attachment point not compatible
					v->GetAttachmentParams (hAtt, pos, dir, rot);
					v->Local2Global (pos, gpos);
					if (dist (gpos, grms) < 0.25) { 
			HWND hDlg = oapiFindDialog (g_Param.hDLL, IDD_RMS);
			OBJHANDLE hG=GetAttachmentStatus(rms_attach);
			if ((hG==NULL) && range==false){
			SetWindowText (GetDlgItem (hDlg, IDC_GRAPPLEGOOD), "IN RANGE");
			}
			}else if (dist (gpos, grms) > 0.25){HWND hDlg = oapiFindDialog (g_Param.hDLL, IDD_RMS);
				SetWindowText (GetDlgItem (hDlg, IDC_GRAPPLEGOOD), "--------------------");
			}
			return;
			}
		}
	}

//SetCameraOffset (ofs+arm_tip[0]);	
//SetCameraDefaultDirection(arm_tip[2]-arm_tip[0]);
}

// --------------------------------------------------------------
// Update mesh animation state
// --------------------------------------------------------------
void W::clbkAnimate (double simt)
{
	arm_tip[0] = _V(0,0.87,0.66);
	arm_tip[1] = _V(0,0.87,1.66);
	arm_tip[2] = _V(0,1.87,0.66);

	UpdateMesh ();
}


int W::clbkConsumeBufferedKey (DWORD key, bool down, char *kstate)
{
	

	if (!down) return 0; // only process keydown events
		switch (key) {
		case OAPI_KEY_G: // deploy/retract ARM
			oapiOpenDialogEx (g_Param.hDLL, IDD_RMS, RMS_DlgProc, DLG_CAPTIONCLOSE, this);
			return 1;
		case OAPI_KEY_1: // deploy/retract ARM
			DetachChild (rms_attach, 0);
			return 1;
		case OAPI_KEY_2: // deploy/retract ARM
			ToggleGrapple();
			return 1;
		}
	return 0;
}

// --------------------------------------------------------------
// Module initialisation
// --------------------------------------------------------------

//Load from scn file
void W::clbkLoadStateEx (FILEHANDLE scn, void *vs)
{
	char *line;
	while (oapiReadScenario_nextline (scn, line)) {
        if (!_strnicmp (line, "ARM_STATUS", 10)) {
			sscanf (line+10, "%lf%lf%lf", &arm_sp, &arm_ep, &arm_cp);
        } else {
            ParseScenarioLineEx (line, vs);
			// unrecognised option - pass to Orbiter's generic parser
        }
    }
	UpdateMesh ();
}
////save to scn file
void W::clbkSaveState (FILEHANDLE scn)
{
	VESSEL2::clbkSaveState (scn);
	
}
DLLCLBK void InitModule (HINSTANCE hModule)
{
	g_Param.hDLL = hModule;
}

// --------------------------------------------------------------
// Vessel initialisation
// --------------------------------------------------------------
DLLCLBK VESSEL *ovcInit (OBJHANDLE hvessel, int flightmodel)
{
	return new W (hvessel, flightmodel);
}

// --------------------------------------------------------------
// Vessel cleanup
// --------------------------------------------------------------
DLLCLBK void ovcExit (VESSEL *vessel)
{
	if (vessel) delete (W*)vessel;
}

BOOL CALLBACK RMS_DlgProc (HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
	W *sts = (uMsg == WM_INITDIALOG ? (W*)lParam : (W*)oapiGetDialogContext (hWnd));
	// pointer to vessel instance was passed as dialog context
	
	const double step = 0.05*RAD;
	static double t0;
	double t1;
	HICON hIcon;
	int idx;
	OBJHANDLE hVessel;

	char cbuf[128];
	
	switch (uMsg) {
	case WM_INITDIALOG:
		CreateVesselList (hWnd);
		hIcon = LoadIcon (g_Param.hDLL, MAKEINTRESOURCE(IDI_UP));
		SendDlgItemMessage (hWnd, IDC_ELBOWUP, BM_SETIMAGE, IMAGE_ICON, (LPARAM)hIcon);
		SendDlgItemMessage (hWnd, IDC_SHOULDERUP, BM_SETIMAGE, IMAGE_ICON, (LPARAM)hIcon);
		SendDlgItemMessage (hWnd, IDC_CLAWUP, BM_SETIMAGE, IMAGE_ICON, (LPARAM)hIcon);
		hIcon = LoadIcon (g_Param.hDLL, MAKEINTRESOURCE(IDI_DOWN));
		SendDlgItemMessage (hWnd, IDC_ELBOWDOWN, BM_SETIMAGE, IMAGE_ICON, (LPARAM)hIcon);
		SendDlgItemMessage (hWnd, IDC_SHOULDERDOWN, BM_SETIMAGE, IMAGE_ICON, (LPARAM)hIcon);
		SendDlgItemMessage (hWnd, IDC_CLAWDOWN, BM_SETIMAGE, IMAGE_ICON, (LPARAM)hIcon);
		EnableWindow (GetDlgItem (hWnd, IDC_STOW),TRUE); 
		EnableWindow (GetDlgItem (hWnd, IDC_LINK), sts->SatGrappled() ? TRUE : FALSE);
		EnableWindow (GetDlgItem (hWnd, IDC_KILL_LINKA), (!sts->range) ? FALSE : TRUE);
		EnableWindow (GetDlgItem (hWnd, IDC_KILL_LINKB),FALSE);
		SetWindowText (GetDlgItem (hWnd, IDC_GRAPPLELOCK), sts->SatGrappled() || (sts->range) ? "-LOCKED-" : "--------------------");
		SetWindowText (GetDlgItem (hWnd, IDC_GRAPPLEGOOD), sts->SatGrappled() || (sts->range) ? "-LOCKED-" : "--------------------");
		EnableWindow (GetDlgItem (hWnd, IDC_ROTATION),(sts->rot_thrust) || (!sts->range) ? FALSE : TRUE);
		EnableWindow (GetDlgItem (hWnd, IDC_LINEAR),(sts->lin_thrust) || (!sts->range) ? FALSE : TRUE);
		EnableWindow (GetDlgItem (hWnd, IDC_KILLROT),(!sts->range) ? FALSE : TRUE);
		EnableWindow (GetDlgItem (hWnd, IDC_HOLDALT),(!sts->range) ? FALSE : TRUE);
		EnableWindow (GetDlgItem (hWnd, IDC_HOLDLEVEL),(!sts->range) ? FALSE : TRUE);
		EnableWindow (GetDlgItem (hWnd, IDC_OFF),(!sts->range) ? FALSE : TRUE);
		EnableWindow (GetDlgItem (hWnd, IDC_SIGNAL),TRUE); 
		EnableWindow (GetDlgItem (hWnd, IDC_DOOR1),TRUE); 
		EnableWindow (GetDlgItem (hWnd, IDC_DOOR2),TRUE); 
		EnableWindow (GetDlgItem (hWnd, IDC_DOOR3),TRUE); 
		EnableWindow (GetDlgItem (hWnd, IDC_DOOR4),TRUE); 
		EnableWindow (GetDlgItem (hWnd, IDC_LOAD), sts->SatGrappled() ? TRUE : FALSE);
		EnableWindow (GetDlgItem (hWnd, IDC_LOADA), sts->SatGrappled() ? TRUE : FALSE);
		EnableWindow (GetDlgItem (hWnd, IDC_LOADB), sts->SatGrappled() ? TRUE : FALSE);
		EnableWindow (GetDlgItem (hWnd, IDC_LOADC), sts->SatGrappled() ? TRUE : FALSE);
		SetTimer (hWnd, 1, 50, NULL);
		t0 = oapiGetSimTime();
		return FALSE;
	case WM_DESTROY:
		KillTimer (hWnd, 1);
		return 0;
	case WM_TIMER:
		if (wParam == 1) {
			t1 = oapiGetSimTime();
			 if (SendDlgItemMessage (hWnd, IDC_SHOULDERUP, BM_GETSTATE, 0, 0) & BST_PUSHED) {
				sts->arm_sp = min (1.0, sts->arm_sp + (t1-t0)*ARM_OPERATING_SPEED);
				sts->SetAnimationArm (sts->anim_arm_sp, sts->arm_sp);
			} else if (SendDlgItemMessage (hWnd, IDC_SHOULDERDOWN, BM_GETSTATE, 0, 0) & BST_PUSHED) {
				sts->arm_sp = max (0.0, sts->arm_sp - (t1-t0)*ARM_OPERATING_SPEED);
				sts->SetAnimationArm (sts->anim_arm_sp, sts->arm_sp);
			} else if (SendDlgItemMessage (hWnd, IDC_ELBOWUP, BM_GETSTATE, 0, 0) & BST_PUSHED) {
				sts->arm_ep = max (0.0, sts->arm_ep - (t1-t0)*ARM_OPERATING_SPEED);
				sts->SetAnimationArm (sts->anim_arm_ep, sts->arm_ep);
			} else if (SendDlgItemMessage (hWnd, IDC_ELBOWDOWN, BM_GETSTATE, 0, 0) & BST_PUSHED) {
				sts->arm_ep = min (1.0, sts->arm_ep + (t1-t0)*ARM_OPERATING_SPEED);
				sts->SetAnimationArm (sts->anim_arm_ep, sts->arm_ep);
			} else if (SendDlgItemMessage (hWnd, IDC_CLAWDOWN, BM_GETSTATE, 0, 0) & BST_PUSHED) {
				sts->arm_cp = max (0.0, sts->arm_cp - (t1-t0)*ARM_OPERATING_SPEED);
				sts->SetAnimationArm (sts->anim_arm_cp, sts->arm_cp);
			} else if (SendDlgItemMessage (hWnd, IDC_CLAWUP, BM_GETSTATE, 0, 0) & BST_PUSHED) {
				sts->arm_cp = min (1.0, sts->arm_cp + (t1-t0)*ARM_OPERATING_SPEED);
				sts->SetAnimationArm (sts->anim_arm_cp, sts->arm_cp);
			} else if (SendDlgItemMessage (hWnd, IDC_CLAWCLOSE, BM_GETSTATE, 0, 0) & BST_PUSHED) {
				sts->arm_cgu = max (0.0, sts->arm_cgu - (t1-t0)*ARM_OPERATING_SPEED);
				sts->arm_cgl = max (0.0, sts->arm_cgl - (t1-t0)*ARM_OPERATING_SPEED);
				sts->SetAnimationArm (sts->anim_arm_cgu, sts->arm_cgu);
				sts->SetAnimationArm (sts->anim_arm_cgl, sts->arm_cgl);
				if (sts->arm_cgl==0.0){
					sts->ToggleGrapple();
					}
			} else if (SendDlgItemMessage (hWnd, IDC_CLAWOPEN, BM_GETSTATE, 0, 0) & BST_PUSHED) {
				sts->arm_cgu = min (1.0, sts->arm_cgu + (t1-t0)*ARM_OPERATING_SPEED);
				sts->arm_cgl = min (1.0, sts->arm_cgl + (t1-t0)*ARM_OPERATING_SPEED);
				sts->SetAnimationArm (sts->anim_arm_cgu, sts->arm_cgu);
				sts->SetAnimationArm (sts->anim_arm_cgl, sts->arm_cgl);
				if ((sts->arm_cgl>=1.0)&& BST_PUSHED){
				MessageBox(hWnd, "WOW! How freaking far do you need to open the damn claws anyways!?!?!?", "WTF", MB_OK|MB_ICONEXCLAMATION);
				}
			}
			t0 = t1;
		}
		break;
	case WM_COMMAND:
		switch (LOWORD(wParam)) {
		case IDCANCEL:
			oapiCloseDialog (hWnd);
			return TRUE;
		case IDC_STOW:
			sts->center_arm = true; 
				sts->center_arm_t = oapiGetSimTime();
			return 0;
		case IDC_LINK:
			sts->DetachChild (sts->rms_attach, 0);
			sts->CreateLink();
			sts->rot_thrust=true;
			sts->lin_thrust=false;
			sts->range=true;
			EnableWindow (GetDlgItem (hWnd, IDC_LINK), FALSE);
			EnableWindow (GetDlgItem (hWnd, IDC_KILL_LINKA),TRUE);
			EnableWindow (GetDlgItem (hWnd, IDC_KILL_LINKB),FALSE);
			EnableWindow (GetDlgItem (hWnd, IDC_ROTATION),FALSE);
			EnableWindow (GetDlgItem (hWnd, IDC_LINEAR),TRUE);
			EnableWindow (GetDlgItem (hWnd, IDC_KILLROT),TRUE);
			EnableWindow (GetDlgItem (hWnd, IDC_HOLDALT),TRUE);
			EnableWindow (GetDlgItem (hWnd, IDC_HOLDLEVEL),TRUE);
			EnableWindow (GetDlgItem (hWnd, IDC_OFF),TRUE);
			EnableWindow (GetDlgItem (hWnd, IDC_LOAD),FALSE);
			EnableWindow (GetDlgItem (hWnd, IDC_LOADA),FALSE);
			EnableWindow (GetDlgItem (hWnd, IDC_LOADB),FALSE);
			EnableWindow (GetDlgItem (hWnd, IDC_LOADC),FALSE);
			return 0;
		case IDC_KILL_LINKA:
			sts->range=false;
			sts->rot_thrust=false;
			sts->lin_thrust=false;
			sts->KillLink();
			EnableWindow (GetDlgItem (hWnd, IDC_KILL_LINKA),FALSE);
			EnableWindow (GetDlgItem (hWnd, IDC_KILL_LINKB),TRUE);
			EnableWindow (GetDlgItem (hWnd, IDC_LINEAR),FALSE);
			EnableWindow (GetDlgItem (hWnd, IDC_ROTATION),FALSE);
			EnableWindow (GetDlgItem (hWnd, IDC_KILLROT),FALSE);
			EnableWindow (GetDlgItem (hWnd, IDC_HOLDALT),FALSE);
			EnableWindow (GetDlgItem (hWnd, IDC_HOLDLEVEL),FALSE);
			EnableWindow (GetDlgItem (hWnd, IDC_OFF),FALSE);
			return 0;
		case IDC_KILL_LINKB:
			sts->ToggleGrapple();
			EnableWindow (GetDlgItem (hWnd, IDC_KILL_LINKA),FALSE);
			EnableWindow (GetDlgItem (hWnd, IDC_KILL_LINKB),FALSE);
			EnableWindow (GetDlgItem (hWnd, IDC_LOAD),TRUE);
			EnableWindow (GetDlgItem (hWnd, IDC_LOADA),TRUE);
			EnableWindow (GetDlgItem (hWnd, IDC_LOADB),TRUE);
			EnableWindow (GetDlgItem (hWnd, IDC_LOADC),TRUE);
			return 0;
		case IDC_ROTATION:
			sts->rot_thrust=true;
			sts->lin_thrust=false;
			EnableWindow (GetDlgItem (hWnd, IDC_LINEAR),TRUE);
			EnableWindow (GetDlgItem (hWnd, IDC_ROTATION),FALSE);
			EnableWindow (GetDlgItem (hWnd, IDC_KILLROT),TRUE);
			EnableWindow (GetDlgItem (hWnd, IDC_HOLDALT),TRUE);
			EnableWindow (GetDlgItem (hWnd, IDC_HOLDLEVEL),TRUE);
			EnableWindow (GetDlgItem (hWnd, IDC_OFF),TRUE);
			return 0;
		case IDC_LINEAR:
			sts->rot_thrust=false;
			sts->lin_thrust=true;
			EnableWindow (GetDlgItem (hWnd, IDC_LINEAR),FALSE);
			EnableWindow (GetDlgItem (hWnd, IDC_ROTATION),TRUE);
			EnableWindow (GetDlgItem (hWnd, IDC_KILLROT),TRUE);
			EnableWindow (GetDlgItem (hWnd, IDC_HOLDALT),TRUE);
			EnableWindow (GetDlgItem (hWnd, IDC_HOLDLEVEL),TRUE);
			EnableWindow (GetDlgItem (hWnd, IDC_OFF),TRUE);
			return 0;
		case IDC_KILLROT:
			sts->RemoteThrustKillRot();
			return 0;
		case IDC_HOLDALT:
			sts->RemoteThrustHoldAlt();
			return 0;
		case IDC_HOLDLEVEL:
			sts->RemoteThrustHLevel();
			return 0;
		case IDC_OFF:
			sts->RemoteThrustOff();
			sts->rot_thrust=false;
			sts->lin_thrust=false;
			EnableWindow (GetDlgItem (hWnd, IDC_LINEAR),TRUE);
			EnableWindow (GetDlgItem (hWnd, IDC_ROTATION),TRUE);
			EnableWindow (GetDlgItem (hWnd, IDC_KILLROT),FALSE);
			EnableWindow (GetDlgItem (hWnd, IDC_HOLDALT),FALSE);
			EnableWindow (GetDlgItem (hWnd, IDC_HOLDLEVEL),FALSE);
			return 0;
		case IDC_SIGNAL:
			if (HIWORD(wParam) == CBN_SELCHANGE) {
				idx = SendDlgItemMessage (hWnd, IDC_SIGNAL, CB_GETCURSEL, 0, 0);
				SendDlgItemMessage (hWnd, IDC_SIGNAL, CB_GETLBTEXT, idx, (LPARAM)cbuf);
				hVessel = oapiGetVesselByName (cbuf);
				if (hVessel) g_Param.vessel = oapiGetVesselInterface (hVessel);
			}
			break;
		case IDC_DOOR1:
			g_Param.vessel->SetSize(30.01);
			break;
		case IDC_DOOR2:
			g_Param.vessel->SetSize(30.02);
			break;
		case IDC_DOOR3:
			g_Param.vessel->SetSize(30.03);
			break;
		case IDC_DOOR4:
			g_Param.vessel->SetSize(30.04);
			break;
		case IDC_LOAD:
			sts->DetachChild (sts->rms_attach, 0.01);
			g_Param.vessel->SetSize(30.05);
			EnableWindow (GetDlgItem (hWnd, IDC_LINK), FALSE);
			SetWindowText (GetDlgItem (hWnd, IDC_GRAPPLELOCK), "--------------------");
			SetWindowText (GetDlgItem (hWnd, IDC_GRAPPLEGOOD), "--------------------");
			break;
		case IDC_LOADA:
			sts->DetachChild (sts->rms_attach, 0.01);
			g_Param.vessel->SetSize(30.06);
			EnableWindow (GetDlgItem (hWnd, IDC_LINK), FALSE);
			SetWindowText (GetDlgItem (hWnd, IDC_GRAPPLELOCK), "--------------------");
			SetWindowText (GetDlgItem (hWnd, IDC_GRAPPLEGOOD), "--------------------");
			break;
		case IDC_LOADB:
			sts->DetachChild (sts->rms_attach, 0.01);
			g_Param.vessel->SetSize(30.07);
			EnableWindow (GetDlgItem (hWnd, IDC_LINK), FALSE);
			SetWindowText (GetDlgItem (hWnd, IDC_GRAPPLELOCK), "--------------------");
			SetWindowText (GetDlgItem (hWnd, IDC_GRAPPLEGOOD), "--------------------");
			break;
		case IDC_LOADC:
			sts->DetachChild (sts->rms_attach, 0.01);
			g_Param.vessel->SetSize(30.08);
			EnableWindow (GetDlgItem (hWnd, IDC_LINK), FALSE);
			SetWindowText (GetDlgItem (hWnd, IDC_GRAPPLELOCK), "--------------------");
			SetWindowText (GetDlgItem (hWnd, IDC_GRAPPLEGOOD), "--------------------");
			break;
		}
		break;
	}
	return oapiDefDialogProc (hWnd, uMsg, wParam, lParam);
}


