//############################################################################//
/*
Project Frontier
ZeRG meteor shield v0.8

v0.1:
Initial code

v0.1-0.8(061101):Artlav
Cleaned the code

Copyright 2006 Frontier team
*/
//############################################################################//
#define STRICT
#define ORBITER_MODULE

#include "shield.h"       
//############################################################################//
	  
//############################################################################//
//####################### Setting vessel parameters ##########################//
//############################################################################//
void Shield::clbkSetClassCaps(FILEHANDLE cfg)
{
 SetSize(40);
 SetEmptyMass(10000);
 SetCW(1,1,1,1);
 SetCrossSections(_V(944,901,564));
 SetRotDrag(_V(0.6,0.6,0.35));
 if(GetFlightModel()>=1){
  SetPitchMomentScale(5e-5);
  SetBankMomentScale(5e-5);
 }
 SetPMI(_V(640,640,160));
 SetTrimScale(0.05);
 SetCameraOffset(_V(0,0,0));
 SetDockParams(_V(0,0,-57),_V(0,0,-1),_V(0,1,0));
 SetTouchdownPoints(_V(0,-1,1.2),_V(-1.53,-1.,-4.83),_V(1.53,-1.,-4.83));

 AddMesh("ZeRGShield");
}

//############################################################################//
//####################### Setting vessel parameters ##########################//
//############################################################################//
DLLCLBK VESSEL *ovcInit(OBJHANDLE hvessel,int flightmodel){return new Shield(hvessel,flightmodel);}
DLLCLBK void ovcExit(VESSEL *vessel){if(vessel)delete(Shield*)vessel;}
